package amidagame;

import org.andengine.engine.handler.physics.PhysicsHandler;
import org.andengine.entity.primitive.Rectangle;
import org.andengine.entity.scene.Scene;
import org.andengine.entity.scene.background.Background;
import org.andengine.entity.sprite.Sprite;
import org.andengine.opengl.texture.atlas.bitmap.BitmapTextureAtlas;
import org.andengine.opengl.texture.atlas.bitmap.BitmapTextureAtlasTextureRegionFactory;
import org.andengine.opengl.texture.region.TextureRegion;

import persistantgame.TrainStats;

import amidagame.component.PlayerSprite;
import android.app.AlertDialog;
import android.content.DialogInterface;
import android.content.SharedPreferences;

import com.example.traingame.SceneManager;
import com.example.traingame.Setup;

import database.DBProtocolC;

public class amidaResultSetup extends Setup {
	private int numOfPlayers;
	
	private BitmapTextureAtlas c1BitmapTextureAtlas;
	private TextureRegion c1TextureRegion;
	private BitmapTextureAtlas c2BitmapTextureAtlas;
	private TextureRegion c2TextureRegion;
	private BitmapTextureAtlas c3BitmapTextureAtlas;
	private TextureRegion c3TextureRegion;
	private BitmapTextureAtlas c4BitmapTextureAtlas;
	private TextureRegion c4TextureRegion;
	private BitmapTextureAtlas backgroundBitmapTextureAtlas;
	private TextureRegion backgroundTextureRegion;
	
	private PlayerSprite[] players;
	private Rectangle[] bars;
	private PhysicsHandler[] pPhysics;
	private PhysicsHandler[] bPhysics;
	private int[] score;
	
	private SharedPreferences sp;
	private SharedPreferences sp2;
	
	public amidaResultSetup(SceneManager SM) {
		this.sm = SM;
		numOfPlayers = 4;
		players = new PlayerSprite[4];
		bars = new Rectangle[4];
		pPhysics = new PhysicsHandler[4];
		bPhysics = new PhysicsHandler[4];
		score = new int[4];
	}
	
	@Override
	public void load() {
		// TODO Auto-generated method stub
		c1BitmapTextureAtlas = new BitmapTextureAtlas(sm.activity.getTextureManager(), 128, 128);
		c1TextureRegion = BitmapTextureAtlasTextureRegionFactory.createFromAsset(c1BitmapTextureAtlas, sm.activity.getAssets(), "amida character 1.png",0,0);
		c1BitmapTextureAtlas.load();
		c2BitmapTextureAtlas = new BitmapTextureAtlas(sm.activity.getTextureManager(), 128, 128);
		c2TextureRegion = BitmapTextureAtlasTextureRegionFactory.createFromAsset(c2BitmapTextureAtlas, sm.activity.getAssets(), "amida character 2.png",0,0);
		c2BitmapTextureAtlas.load();
		c3BitmapTextureAtlas = new BitmapTextureAtlas(sm.activity.getTextureManager(), 128, 128);
		c3TextureRegion = BitmapTextureAtlasTextureRegionFactory.createFromAsset(c3BitmapTextureAtlas, sm.activity.getAssets(), "amida character 3.png",0,0);
		c3BitmapTextureAtlas.load();
		c4BitmapTextureAtlas = new BitmapTextureAtlas(sm.activity.getTextureManager(), 128, 128);
		c4TextureRegion = BitmapTextureAtlasTextureRegionFactory.createFromAsset(c4BitmapTextureAtlas, sm.activity.getAssets(), "amida character 4.png",0,0);
		c4BitmapTextureAtlas.load();
		backgroundBitmapTextureAtlas = new BitmapTextureAtlas(sm.activity.getTextureManager(), 2048, 2048);
		backgroundTextureRegion = BitmapTextureAtlasTextureRegionFactory.createFromAsset(backgroundBitmapTextureAtlas, sm.activity.getAssets(), "amida background.png",0,0);
		backgroundBitmapTextureAtlas.load();
	}

	@Override
	public Scene create() {
		// TODO Auto-generated method stub
		sp = sm.activity.getSharedPreferences("amidaresult", 0);
		sp2 = sm.activity.getSharedPreferences("currentUser", 0);
		
		Scene result = new Scene();
		result.setBackground(new Background(255,255,255));
	
		// Background
		final Sprite backgroundSprite = new Sprite(0, 0, backgroundTextureRegion,
				sm.activity.getVertexBufferObjectManager());
		result.attachChild(backgroundSprite);
		
		for (int i = 0; i < numOfPlayers; i++) {	
			// Score
			int tempscore = sp.getInt(""+i, -1);
			score[i] = tempscore;
			
			// Rectangles
			bars[i] = new Rectangle(0, 0, 30, sm.camera.getHeight()*2, sm.activity.getVertexBufferObjectManager());
			bars[i].setColor(1.0f, 1.0f, 0.804f);
			
			// Heads
			TextureRegion headtr = null;
			switch(i){
			case 0:
				headtr = c1TextureRegion;
				break;
			case 1:
				headtr = c2TextureRegion;
				break;
			case 2:
				headtr = c3TextureRegion;
				break;
			case 3:
				headtr = c4TextureRegion;
				break;
			}
			players[i] = new PlayerSprite(0,0,headtr,sm.activity.getVertexBufferObjectManager(),1);
			pPhysics[i] = new PhysicsHandler(players[i]);
			players[i].registerUpdateHandler(pPhysics[i]);
			pPhysics[i].setVelocity(0, -tempscore*1.5f*(sm.camera.getHeight()/800f));
			players[i].setPosition(this.lineXCord(i) - players[i].getWidth() / 2,
					sm.camera.getHeight());
			players[i].setZIndex(2);
			
			
			bPhysics[i] = new PhysicsHandler(bars[i]);
			bPhysics[i].setVelocity(0, -tempscore*1.5f*(sm.camera.getHeight()/800f));
			bars[i].registerUpdateHandler(bPhysics[i]);
			bars[i].setPosition(this.lineXCord(i) - 10,
					sm.camera.getHeight()+50);
			bars[i].setZIndex(1);
			
			result.attachChild(bars[i]);
			result.attachChild(players[i]);		
		}
		Thread r = new Thread(){
			@Override
			public void run() {
				// TODO Auto-generated method stub
				try {
					Thread.sleep(5000);
				} catch (InterruptedException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
				
				// GameRectangle stop moving
				for (PhysicsHandler p: pPhysics){
					p.setVelocity(0, 0);
				}
				for (PhysicsHandler p: bPhysics){
					p.setVelocity(0, 0);
				}
				
				sm.activity.runOnUiThread(new Runnable() {
					
					@Override
					public void run() {
						// TODO Auto-generated method stub

						AlertDialog.Builder builder = new AlertDialog.Builder(sm.activity);
						builder.setMessage("Your Score is: " + score[sp.getInt("myself", -1)]);
						builder.setPositiveButton("OK", new DialogInterface.OnClickListener() {
							@Override
							public void onClick(DialogInterface dialog, int which) {
								// TODO Auto-generated method stub
								sm.activity.finish();
							}
						});
						builder.show();
						DBProtocolC.storeScore(sp2.getString("uid", ""), "4", ""+score[sp.getInt("myself", -1)]);
						TrainStats.getInstance().setMoney(TrainStats.getInstance().getMoney() + score[sp.getInt("myself", -1)]);
					}
				});
			}
		};
		r.start();
		
		return result;
	}

	// Start from line 0!!!!!!!
	public float lineXCord(int line) {
		return (float) ((line + 1.5) * sm.camera.getWidth() / (numOfPlayers + 2));
	}
}
