package amidagame;

import java.util.Collections;
import java.util.LinkedList;
import java.util.Random;

import org.andengine.entity.primitive.Line;
import org.andengine.entity.primitive.Rectangle;
import org.andengine.entity.scene.Scene;
import org.andengine.entity.scene.background.Background;
import org.andengine.entity.sprite.Sprite;
import org.andengine.entity.text.Text;
import org.andengine.entity.text.TextOptions;
import org.andengine.input.touch.TouchEvent;
import org.andengine.opengl.font.Font;
import org.andengine.opengl.font.FontFactory;
import org.andengine.opengl.texture.atlas.bitmap.BitmapTextureAtlas;
import org.andengine.opengl.texture.atlas.bitmap.BitmapTextureAtlasTextureRegionFactory;
import org.andengine.opengl.texture.region.TextureRegion;
import org.andengine.util.HorizontalAlign;

import amidagame.component.*;
import amidagame.component.TurningPoint.LRPosition;
import amidagame.packets.*;
import android.content.SharedPreferences;
import android.graphics.Typeface;
import android.os.Bundle;
import android.util.Log;
import android.widget.Toast;

import com.example.traingame.SceneManager;
import com.example.traingame.Setup;

public class amidaSetup extends Setup {
	public final int MAX_SMALL_LINES = 6;

	private int numOfPlayers;
	private int numOfShortLines;

	private PlayerSprite[] players;
	private Line[] lines;
	private AmidaTimer at;
	
	private AmidaClient client;
	
	private boolean canDraw;
	private SharedPreferences sharedPf;
	
	private BitmapTextureAtlas backgroundBitmapTextureAtlas;
	private TextureRegion backgroundTextureRegion;
	private BitmapTextureAtlas coinBitmapTextureAtlas;
	private TextureRegion coinTextureRegion;
	private BitmapTextureAtlas bronzeBitmapTextureAtlas;
	private TextureRegion bronzeTextureRegion;
	private BitmapTextureAtlas silverBitmapTextureAtlas;
	private TextureRegion silverTextureRegion;
	private BitmapTextureAtlas goldBitmapTextureAtlas;
	private TextureRegion goldTextureRegion;
	private BitmapTextureAtlas bootBitmapTextureAtlas;
	private TextureRegion bootTextureRegion;
	private BitmapTextureAtlas c1BitmapTextureAtlas;
	private TextureRegion c1TextureRegion;
	private BitmapTextureAtlas c2BitmapTextureAtlas;
	private TextureRegion c2TextureRegion;
	private BitmapTextureAtlas c3BitmapTextureAtlas;
	private TextureRegion c3TextureRegion;
	private BitmapTextureAtlas c4BitmapTextureAtlas;
	private TextureRegion c4TextureRegion;

	private Font youFont;
	private Font timerFont;
	
	private int peopleDoneMoving;
	private static int[] score;
	private static short myPid;
	private int gameid;
	
	private SharedPreferences sharedPref;
	private SharedPreferences.Editor speditor;

	public amidaSetup(SceneManager SM) {
		this.sm = SM;
		numOfPlayers = 4;
		numOfShortLines = 0;
		client = null;
		score = new int[4];
		peopleDoneMoving = 0;
		setCanDraw(false);
	}

	@Override
	public void load() {
		BitmapTextureAtlasTextureRegionFactory.setAssetBasePath("gfx/Amida/");
		backgroundBitmapTextureAtlas = new BitmapTextureAtlas(sm.activity.getTextureManager(), 2048, 2048);
		backgroundTextureRegion = BitmapTextureAtlasTextureRegionFactory.createFromAsset(backgroundBitmapTextureAtlas, sm.activity.getAssets(), "amida background.png",0,0);
		backgroundBitmapTextureAtlas.load();
		coinBitmapTextureAtlas = new BitmapTextureAtlas(
				sm.activity.getTextureManager(), 512, 512);
		coinTextureRegion = BitmapTextureAtlasTextureRegionFactory
				.createFromAsset(coinBitmapTextureAtlas,
						sm.activity.getAssets(), "amida coin.png", 0, 0);
		coinBitmapTextureAtlas.load();	
		bronzeBitmapTextureAtlas = new BitmapTextureAtlas(sm.activity.getTextureManager(), 512, 512);
		bronzeTextureRegion = BitmapTextureAtlasTextureRegionFactory.createFromAsset(bronzeBitmapTextureAtlas, sm.activity.getAssets(), "bronze chest.png",0,0);
		bronzeBitmapTextureAtlas.load();
		silverBitmapTextureAtlas = new BitmapTextureAtlas(sm.activity.getTextureManager(), 512, 512);
		silverTextureRegion = BitmapTextureAtlasTextureRegionFactory.createFromAsset(silverBitmapTextureAtlas, sm.activity.getAssets(), "silver chest.png",0,0);
		silverBitmapTextureAtlas.load();
		goldBitmapTextureAtlas = new BitmapTextureAtlas(sm.activity.getTextureManager(), 512, 512);
		goldTextureRegion = BitmapTextureAtlasTextureRegionFactory.createFromAsset(goldBitmapTextureAtlas, sm.activity.getAssets(), "gold chest.png",0,0);
		goldBitmapTextureAtlas.load();
		bootBitmapTextureAtlas = new BitmapTextureAtlas(sm.activity.getTextureManager(), 512, 512);
		bootTextureRegion = BitmapTextureAtlasTextureRegionFactory.createFromAsset(bootBitmapTextureAtlas, sm.activity.getAssets(), "boot.png",0,0);
		bootBitmapTextureAtlas.load();
		c1BitmapTextureAtlas = new BitmapTextureAtlas(sm.activity.getTextureManager(), 128, 128);
		c1TextureRegion = BitmapTextureAtlasTextureRegionFactory.createFromAsset(c1BitmapTextureAtlas, sm.activity.getAssets(), "amida character 1.png",0,0);
		c1BitmapTextureAtlas.load();
		c2BitmapTextureAtlas = new BitmapTextureAtlas(sm.activity.getTextureManager(), 128, 128);
		c2TextureRegion = BitmapTextureAtlasTextureRegionFactory.createFromAsset(c2BitmapTextureAtlas, sm.activity.getAssets(), "amida character 2.png",0,0);
		c2BitmapTextureAtlas.load();
		c3BitmapTextureAtlas = new BitmapTextureAtlas(sm.activity.getTextureManager(), 128, 128);
		c3TextureRegion = BitmapTextureAtlasTextureRegionFactory.createFromAsset(c3BitmapTextureAtlas, sm.activity.getAssets(), "amida character 3.png",0,0);
		c3BitmapTextureAtlas.load();
		c4BitmapTextureAtlas = new BitmapTextureAtlas(sm.activity.getTextureManager(), 128, 128);
		c4TextureRegion = BitmapTextureAtlasTextureRegionFactory.createFromAsset(c4BitmapTextureAtlas, sm.activity.getAssets(), "amida character 4.png",0,0);
		c4BitmapTextureAtlas.load();
		this.youFont = FontFactory.create(sm.activity.getFontManager(), sm.activity.getTextureManager(), 32, 32, Typeface.create(Typeface.DEFAULT, Typeface.BOLD), 16);
		this.youFont.load();
		this.timerFont =  FontFactory.create(sm.activity.getFontManager(), sm.activity.getTextureManager(), 64, 64, Typeface.create(Typeface.DEFAULT, Typeface.BOLD), 24);
		this.timerFont.load();
		
		Bundle extra = sm.activity.getIntent().getExtras();
		if (extra != null){
			gameid = extra.getInt("gameID");
		}else {
			gameid = -99999;
		}
	}

	@Override
	public Scene create() {
		sharedPref = sm.activity.getSharedPreferences("amidaresult", 0);
		speditor = sharedPref.edit();
		
		Scene resultScene = new Scene();
		resultScene.setBackground(new Background(255, 255, 255));
		players = new PlayerSprite[numOfPlayers];
		lines = new Line[numOfPlayers];

		if (client != null){
			client.client.stop();
		}
		
		client = new AmidaClient(this);
		
		Log.i("CAMERA", "Camera height is: " + sm.camera.getHeight());
		Log.i("CAMERA", "Camera width is: " + sm.camera.getWidth());
		
		// Background
		final Sprite backgroundSprite = new Sprite(0, 0, backgroundTextureRegion,
				sm.activity.getVertexBufferObjectManager());
		resultScene.attachChild(backgroundSprite);
		
		// Lines
		for (int i = 0; i < numOfPlayers; i++) {
			lines[i] = new Line(
					(float) ((i + 1.5) * sm.camera.getWidth() / (numOfPlayers + 2)),
					48,
					(float) ((i + 1.5) * sm.camera.getWidth() / (numOfPlayers + 2)),
					(float) (sm.camera.getHeight() - 64), sm.activity
							.getVertexBufferObjectManager());
			lines[i].setColor(1.0f, 1.0f, 0);
			resultScene.attachChild(lines[i]);
		}
		
		at = new AmidaTimer(sm.camera.getWidth() - 100, 100, timerFont, 10, new TextOptions(HorizontalAlign.LEFT), sm.activity.getVertexBufferObjectManager(), this);
		resultScene.attachChild(at);

		// Players
		for (int i = 0; i < numOfPlayers; i++) {
			TextureRegion tr = null;
			switch(i){
			case 0:
				tr = c1TextureRegion;
				break;
			case 1:
				tr = c2TextureRegion;
				break;
			case 2:
				tr = c3TextureRegion;
				break;
			case 3:
				tr = c4TextureRegion;
				break;
			}
			players[i] = new PlayerSprite(0,0,tr,sm.activity.getVertexBufferObjectManager(),1) {
				@Override
				protected void onManagedUpdate(float pSecondsElapsed) {
					super.onManagedUpdate(pSecondsElapsed);
					if (!this.isOnLine()) {
						if (this.getLineNum() > this.getNextLine()) {
							if ((this.getX() - lineXCord(this.getNextLine())) < -50) {
								this.moveDown();
								this.setLineNum(this.getNextLine());
								this.setOnLine(true);
							}
						} else if (this.getLineNum() < this.getNextLine()) {
							if ((lineXCord(this.getNextLine()) - this.getX()) < 50) {
								this.moveDown();
								this.setLineNum(this.getNextLine());
								this.setOnLine(true);
							}
						}
					}
				}
			};
			players[i].setPosition(this.lineXCord(i) - players[i].getWidth() / 2,
							16);
			players[i].setLineNum(i);
			players[i].setNextLine(i);
			players[i].setOnLine(true);
			players[i].setPid(i);
			players[i].setZIndex(2);
			resultScene.attachChild(players[i]);
		}
		
		// Request for coins and start the timer after 3 seconds
		Thread r = new Thread(){
			@Override
			public void run() {
				try {
					Thread.sleep(3000);
				} catch (InterruptedException e) {
					e.printStackTrace();
				}
				PackageCoinReq p = new PackageCoinReq();
				p.gameid = amidaSetup.this.gameid;
				client.client.sendTCP(p);
			}
		};
		r.start();
		
		return resultScene;
	}

	// Start from line 0!!!!!!!
	// Get x coordinate by line number
	public float lineXCord(int line) {
		return (float) ((line + 1.5) * sm.camera.getWidth() / (numOfPlayers + 2));
	}
	
	// Make coin Sprite
	public Sprite makeCoins(int line, float yCord){
		final Sprite faceSprite1 = new Sprite(0, 0, coinTextureRegion,
				sm.activity.getVertexBufferObjectManager());
		faceSprite1.setScale(0.3f, 0.3f);
		faceSprite1.setPosition(lineXCord(line) - faceSprite1.getWidth()
				/ 2, yCord - 100);
		return faceSprite1;
	}
	
	// Make score point for coins online
	public ScorePoint makeSP(Sprite coin, int score){
		ScorePoint sp = new ScorePoint(coin.getX() + coin.getWidth()/2, coin.getY() + coin.getHeight()/2, score, numOfPlayers, sm.activity.getVertexBufferObjectManager()){
			@Override
			protected void onManagedUpdate(float pSecondsElapsed) {
				super.onManagedUpdate(pSecondsElapsed);
				for (PlayerSprite p : players) {
					if (!this.visited(p.getPid())) {
						if (p.collidesWith(this)) {
							this.setPlayerWentBy(p.getPid());				
							p.setScore(p.getScore() + this.getScore());
						}
					}
				}
			}
		};
		return sp;
	}
	
	// Add a new coin to the board
	public boolean addCoins(int line, float yCord, int score){
		Sprite coin = makeCoins(line, yCord);
		coin.setZIndex(1);
		ScorePoint sp = makeSP(coin, score);
		sm.getAmidaScene().attachChild(coin);
		sm.getAmidaScene().attachChild(sp);
		return true;
	}
	
	// Add a line on the board
	// This is for adding foreign lines.
	public boolean addCross(float x, float y){
		return addCross(x,y,false);
	}

	public boolean addCross(float x, float y, boolean myLine) {
		float currentLine = 0;

		for (int i = 0; i < numOfPlayers; i++) {
			currentLine = lineXCord(i);

			// You cannot draw line unless you are allowed
			if (!canDraw){
				return false;
			}
			
			// No more lines should be drawed
			if ((numOfShortLines >= MAX_SMALL_LINES) && myLine) {
				return false;
			}

			// Out of left bound
			if ((x < currentLine) && (i == 0)) {
				return false;
			}

			if (x > currentLine) {
				if (i == numOfPlayers - 1) {
					// Out of right bound, return false
					return false;
				} else if (x < lineXCord(i + 1)) {
					// Draw a line between these two lines
					Line smallLine = new Line(lineXCord(i), y,
							lineXCord(i + 1), y,
							sm.activity.getVertexBufferObjectManager());
					smallLine.setColor(1, 1, 1);
					smallLine.setZIndex(0);
					sm.getAmidaScene().attachChild(smallLine);
					TurningPoint dot1 = new TurningPoint(lineXCord(i), y + 50,
							LRPosition.LEFT, numOfPlayers,
							sm.activity.getVertexBufferObjectManager()) {
						@Override
						protected void onManagedUpdate(float pSecondsElapsed) {
							super.onManagedUpdate(pSecondsElapsed);
							for (PlayerSprite p : players) {
								if (!this.visited(p.getPid())
										&& p.isOnLine()
										&& (p.getLineNum() < (numOfPlayers - 1))
										&& (p.getTraversedLine() <= this
												.getY1())) {
									if (p.collidesWith(this)) {
										this.setPlayerWentBy(p.getPid());
										this.getPartner().setPlayerWentBy(
												p.getPid());
										p.moveRight();
										p.setOnLine(false);
										p.setNextLine(p.getLineNum() + 1);
										p.setTraversedLine(this.getY1());
									}
								}
							}
						}
					};
					TurningPoint dot2 = new TurningPoint(lineXCord(i + 1),
							y + 50, LRPosition.RIGHT, numOfPlayers,
							sm.activity.getVertexBufferObjectManager()) {
						@Override
						protected void onManagedUpdate(float pSecondsElapsed) {
							super.onManagedUpdate(pSecondsElapsed);
							for (PlayerSprite p : players) {
								if (!this.visited(p.getPid())
										&& p.isOnLine()
										&& (p.getLineNum() > 0)
										&& (p.getTraversedLine() <= this
												.getY1())) {
									if (p.collidesWith(this)) {
										this.setPlayerWentBy(p.getPid());
										this.getPartner().setPlayerWentBy(
												p.getPid());
										p.moveLeft();
										p.setOnLine(false);
										p.setNextLine(p.getLineNum() - 1);
										p.setTraversedLine(this.getY1());
									}
								}
							}
						}
					};

					dot1.setPartner(dot2);
					dot2.setPartner(dot1);
					sm.getAmidaScene().attachChild(dot1);
					sm.getAmidaScene().attachChild(dot2);			
					
					if (myLine){
						//Send package to the Server
						client.submitNewLine(x,y,myPid);
						numOfShortLines++;
					}
					
					sm.getAmidaScene().sortChildren();
					
					return true;
				}
			}

		}

		return false;
	}
	
	public void drawBoxes(int[] boxes) {
		// Coins below
		LinkedList<Integer> coinList = new LinkedList<Integer>();
		for (int i = 0; i < numOfPlayers; i++) {
			coinList.add(i + 1);
		}
		Collections.shuffle(coinList);
		
		for (int i = 0; i < numOfPlayers; i++) {
			TextureRegion tr = bronzeTextureRegion;
			int tempscore = 0;
			switch (boxes[i]) {
			case 1:
				tr = bronzeTextureRegion;
				tempscore = 10;
				break;
			case 2:
				tr = silverTextureRegion;
				tempscore = 20;
				break;
			case 3:
				tr = goldTextureRegion;
				tempscore = 30;
				break;
			case 4:
				tr = bootTextureRegion;
				tempscore = 0;
				break;
			}
			final Sprite faceSprite1 = new Sprite(0, 0, tr,
					sm.activity.getVertexBufferObjectManager());
			faceSprite1.setScale(0.3f, 0.3f);
			faceSprite1.setPosition(this.lineXCord(i) - faceSprite1.getWidth()
					/ 2, sm.camera.getHeight() - 176);

			EndPoint ep = new EndPoint(faceSprite1.getX()
					+ faceSprite1.getWidth() / 2, faceSprite1.getY()
					+ faceSprite1.getHeight() / 2, tempscore,
					sm.activity.getVertexBufferObjectManager()) {
				@Override
				protected void onManagedUpdate(float pSecondsElapsed) {
					super.onManagedUpdate(pSecondsElapsed);
					if (!isVisited()) {
						for (PlayerSprite p : players) {
							if (p.collidesWith(this)) {
								p.setScore(p.getScore() + this.getScore());
								p.stop();
								Log.i("AmidaPlayer",
										"The final score for player "
												+ p.getPid() + " is: "
												+ p.getScore());

								speditor.putInt("" + p.getPid(), p.getScore());
								speditor.commit();

								setVisited(true);
								score[p.getPid()] = p.getScore();
								peopleDoneMoving++;
								PackageAmidaGameOver pack = new PackageAmidaGameOver();
								pack.pid = (short) p.getPid();
								pack.score = p.getScore();
								client.client.sendTCP(pack);
								if (peopleDoneMoving >= numOfPlayers) {
									try {
										Thread.sleep(3000);
									} catch (InterruptedException e) {
										e.printStackTrace();
									}
									client.client.stop();
									sm.setCurrentS(SceneManager.AllScenes.AMIDARESULT);
								}
							}
						}
					}
				}
			};
			sm.getAmidaScene().attachChild(faceSprite1);
			sm.getAmidaScene().attachChild(ep);
		}
	}
	
	public void moveEverybody(){
		for (PlayerSprite p: players){
			p.moveDown();
		}
		sm.getAmidaScene().sortChildren();
		setCanDraw(false);
	}

	public int getNumOfPlayers() {
		return numOfPlayers;
	}

	public void setNumOfPlayers(int numOfPlayers) {
		this.numOfPlayers = numOfPlayers;
	}

	public int getsLineNum() {
		return numOfShortLines;
	}

	public void setsLineNum(int sLineNum) {
		this.numOfShortLines = sLineNum;
	}

	public static short getMyPid() {
		return myPid;
	}

	public void setMyPid(short myPid) {
		amidaSetup.myPid = myPid;
		final Text you = new Text(lineXCord(myPid) - 16, 16, this.youFont, "You", sm.activity.getVertexBufferObjectManager());
		you.setColor(1.0f,1.0f,0);
		sm.getAmidaScene().attachChild(you);
		speditor.putInt("myself", myPid);
		speditor.commit();
	}
	
	public float getCameraWidth(){
		return sm.camera.getWidth();
	}
	
	public float getCameraHeight(){
		return sm.camera.getHeight();
	}
	
	public AmidaTimer getAt() {
		return at;
	}

	public void setAt(AmidaTimer at) {
		this.at = at;
	}

	public static int[] getScore() {
		return score;
	}

	public static void setScore(int[] score) {
		amidaSetup.score = score;
	}

	public boolean isCanDraw() {
		return canDraw;
	}

	public void setCanDraw(boolean canDraw) {
		this.canDraw = canDraw;
	}

	public SharedPreferences getSharedPf() {
		return sharedPf;
	}

	public void setSharedPf(SharedPreferences sharedPf) {
		this.sharedPf = sharedPf;
	}

	public int getGameid() {
		return gameid;
	}

	public void setGameid(int gameid) {
		this.gameid = gameid;
	}
}
