package amidagame.component;

import org.andengine.entity.text.Text;
import org.andengine.entity.text.TextOptions;
import org.andengine.opengl.font.IFont;
import org.andengine.opengl.vbo.VertexBufferObjectManager;

import amidagame.amidaSetup;

public class AmidaTimer extends Text {
	private boolean counting;
	private int maxSecond;
	private int currentSecond;
	private int currentMsecond;
	private long startTime;
	private long deltaTime;
	private amidaSetup game;

	public AmidaTimer(float pX, float pY, IFont pFont, Integer time,
			TextOptions pTextOptions, VertexBufferObjectManager pVertexBufferObjectManager, amidaSetup game) {
		super(pX, pY, pFont, time.toString() + ".0", pTextOptions,pVertexBufferObjectManager);
		startTime = System.nanoTime();
		maxSecond = time;
		currentSecond = time;
		currentMsecond = 0;
		setCounting(false);
		this.game = game;
		this.setColor(1.0f, 1.0f, 0);
	}
	
	@Override
	protected void onManagedUpdate(float pSecondsElapsed) {
		// TODO Auto-generated method stub
		if (counting){
			deltaTime = (maxSecond*10) - (System.nanoTime() - startTime) / 100000000;
			currentSecond = (int) (deltaTime/10);
			currentMsecond = (int) (deltaTime%10);
			if ((currentSecond <= 0) && (currentMsecond < 0)){
				currentSecond = 0;
				currentMsecond = 0;
				counting = false;
				game.moveEverybody();
			}
			this.setText(currentSecond + "." + currentMsecond);
		}
		
	}

	public boolean isCounting() {
		return counting;
	}

	public void setCounting(boolean counting) {
		this.counting = counting;
		if (counting){
			startTime = System.nanoTime();
		}
	}

}
