package amidagame.component;

import org.andengine.engine.handler.physics.PhysicsHandler;
import org.andengine.entity.sprite.Sprite;
import org.andengine.opengl.texture.region.ITextureRegion;
import org.andengine.opengl.vbo.VertexBufferObjectManager;

public class PlayerSprite extends Sprite {
	private int velocity;
	private PhysicsHandler mPhysicsHandler;
	private int lineNum;
	private int nextLine;
	private boolean isOnLine;
	private int pid;
	private float traversedLine;
	private int score;
	
	public enum LDirection{
		UP,
		DOWN,
		LEFT,
		RIGHT
	}
	
	public PlayerSprite(float pX, float pY, ITextureRegion pTextureRegion,
			VertexBufferObjectManager pVertexBufferObjectManager, int velocity) {
		super(pX, pY, pTextureRegion, pVertexBufferObjectManager);
		this.velocity = velocity;
		mPhysicsHandler = new PhysicsHandler(this);
		setTraversedLine(-1);
		score = 0;
		this.registerUpdateHandler(mPhysicsHandler);
		// TODO Auto-generated constructor stub
	}
	
	/*
	public Rectangle fGameRectangle(float pX, float pY, float pWidth, float pHeight,
			VertexBufferObjectManager pVertexBufferObjectManager, int velocity) {
		//super(pX, pY, pWidth, pHeight, pVertexBufferObjectManager);
		this.velocity = velocity;
		mPhysicsHandler = new PhysicsHandler(this);
		setTraversedLine(-1);
		score = 0;
		this.registerUpdateHandler(mPhysicsHandler);
		// TODO Auto-generated constructor stub
		return null;
	}
	*/

	public void setVelocity(int velocity) {
		this.velocity = velocity;
	}
	
	public void setv(){
		mPhysicsHandler.setVelocityX(50);
		mPhysicsHandler.setVelocityY(50);
	}
	
	public void moveLeft(){
		mPhysicsHandler.setVelocity(-125, 0);
	}
	
	public void moveRight(){
		mPhysicsHandler.setVelocity(125, 0);
	}

	public void moveDown(){
		mPhysicsHandler.setVelocity(0, 125);
	}

	public void stop(){
		mPhysicsHandler.setVelocity(0, 0);
	}
	
	public void move(LDirection direction){
		switch (direction){
		case UP:
			this.setPosition(getX() - velocity, getY());
			break;
		case DOWN:
			this.setPosition(getX() + velocity, getY());
			break;
		case LEFT:
			this.setPosition(getX(), getY() - velocity);
			break;
		case RIGHT:
			this.setPosition(getX(), getY() + velocity);
			break;
		default:
			break;
		
		}
	}

	@Override
	protected void onManagedUpdate(float pSecondsElapsed) {
		// TODO Auto-generated method stub
		super.onManagedUpdate(pSecondsElapsed);
	}

	public int getLineNum() {
		return lineNum;
	}

	public void setLineNum(int lineNum) {
		this.lineNum = lineNum;
	}

	public boolean isOnLine() {
		return isOnLine;
	}

	public void setOnLine(boolean isOnLine) {
		this.isOnLine = isOnLine;
	}

	public int getPid() {
		return pid;
	}

	public void setPid(int pid) {
		this.pid = pid;
	}

	public int getNextLine() {
		return nextLine;
	}

	public void setNextLine(int nextLine) {
		this.nextLine = nextLine;
	}

	public float getTraversedLine() {
		return traversedLine;
	}

	public void setTraversedLine(float traversedLine) {
		this.traversedLine = traversedLine;
	}

	public int getScore() {
		return score;
	}

	public void setScore(int score) {
		this.score = score;
	}
}
