package amidagame.component;

import org.andengine.opengl.vbo.VertexBufferObjectManager;

public class TurningPoint extends Point {
	public LRPosition lr;
	private boolean[] PlayerWentBy;
	private TurningPoint partner;
	
	public enum LRPosition{
		LEFT,
		RIGHT,
		UNKNOWN,
	}
	
	public TurningPoint(float px, float py, LRPosition lr, int pNum,
			VertexBufferObjectManager pVertexBufferObjectManager) {
		super(px, py, pVertexBufferObjectManager);
		this.lr = lr;
		initializePlayerWentBy(pNum);
	}

	public boolean visited(int pid){
		return PlayerWentBy[pid];
	}
	
	public void setPlayerWentBy(int pid) {
		PlayerWentBy[pid] = true;
	}
	
	public void resetPlayerWentBy(){
		initializePlayerWentBy(PlayerWentBy.length);
	}
	
	public void initializePlayerWentBy(int pNum){
		PlayerWentBy = new boolean[pNum];
		for (int i = 0; i < pNum; i++){
			PlayerWentBy[i] = false;
		}
	}

	public TurningPoint getPartner() {
		return partner;
	}

	public void setPartner(TurningPoint partner) {
		this.partner = partner;
	}
}
