package com.example.traingame;

import database.DBProtocolC;
import android.os.AsyncTask;
import android.os.Bundle;
import android.app.Activity;
import android.content.SharedPreferences;
import android.view.Menu;
import android.view.View;
import android.widget.EditText;
import android.widget.Toast;

public class ChangePWActivity extends Activity {

	EditText oldPW;
	EditText newPW;
	EditText confirmNewPW;
	AsyncTask<String, Void, Void> currentTask;
	SharedPreferences sharedPf;
	
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_change_pw);
		oldPW = (EditText) findViewById(R.id.changepwold);
		newPW = (EditText) findViewById(R.id.changepwnew);
		confirmNewPW = (EditText) findViewById(R.id.changepwnewagain);
		currentTask = null;
		sharedPf = getSharedPreferences("currentUser", 0);
	}

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		// Inflate the menu; this adds items to the action bar if it is present.
		getMenuInflater().inflate(R.menu.change_pw, menu);
		return true;
	}
	
	public void ok(View view){
		String o = oldPW.getText().toString();
		String n = newPW.getText().toString();
		String c = confirmNewPW.getText().toString();
		// Check if everything was filled up
		if ((o.isEmpty()) || (n.isEmpty()) || (c.isEmpty())){
			Toast.makeText(getApplicationContext(), "Please finish the table", Toast.LENGTH_SHORT).show();
		} else if (!n.equals(c)){
			// Check if the new passwords match with each other
			Toast.makeText(getApplicationContext(), "Please confirm your new password", Toast.LENGTH_SHORT).show();
		} else {
		
			// Check if the format of the password is available(?)
		
			// Ask the server if the old password is right
			currentTask = new ChangePWTask();
			currentTask.execute(o,n);
		
			// Commit the change
		}
	}
	
	private class ChangePWTask extends AsyncTask<String, Void, Void>{

		@Override
		protected Void doInBackground(String... params) {
			DBProtocolC.connectToDB();
			// Check if the password is right
			if (DBProtocolC.login(sharedPf.getString("username", ""), params[0]).equals("-1")){
				ChangePWActivity.this.runOnUiThread(new Runnable(){
					
					@Override
					public void run() {
						Toast.makeText(getApplicationContext(), "Old password is wrong", Toast.LENGTH_SHORT).show();
					}			
				});	
			} else {
				DBProtocolC.updatePW(sharedPf.getString("uid", ""), params[1]);
				// Go back
				finish();
			}
			return null;
		}
		
	}
	
	public void back(View view){
		// Clear everything
		oldPW.setText("");
		newPW.setText("");
		confirmNewPW.setText("");
		
		// Go back
		finish();
	}
	
	@Override
	protected void onStop() {
		super.onStop();
		if (currentTask!= null){
			currentTask.cancel(true);
		}
	}

}
