package com.example.traingame;

import lanceGameRoomNetworking.RoomClient;
import lanceGameRoomNetworking.packets.TrainLogInRequest;
import chatNetworking.ChatClient;

import com.example.lctnetworktesting.networking.packets.Packet0005Number;
import com.example.lctnetworktesting.networking.packets.Packet0007String;

import creaturegame.CCClient;

import android.os.AsyncTask;
import android.os.Bundle;
import android.app.Activity;
import android.content.Intent;
import android.content.SharedPreferences;
import android.util.Log;
import android.view.Menu;
import android.view.View;
import android.widget.EditText;
import android.widget.ScrollView;
import android.widget.TextView;

public class ChatActivity extends Activity {

	public ChatClient client;
	SharedPreferences sharedPf;

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_chat);
		new clientCreationTask().execute(this);
		sharedPf = getSharedPreferences("currentUser", 0);
	}

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		// Inflate the menu; this adds items to the action bar if it is present.
		getMenuInflater().inflate(R.menu.chat, menu);
		return true;
	}

	@Override
	public void onStop() {
		super.onStop();
		client.client.stop();
	}

	public void goBack(View view) {
		finish();
	}

	/** Called when the user clicks the Send button */
	public void sendChat(View view) {

		new sendMessageTask().execute("");

	}

	private class clientCreationTask extends
			AsyncTask<ChatActivity, Void, ChatClient> {

		@Override
		protected void onPostExecute(ChatClient result) {
			client = result;
		}

		@Override
		protected ChatClient doInBackground(ChatActivity... params) {
			// TODO Auto-generated method stub
			return new ChatClient(params[0]);
		}
	}

	private class sendMessageTask extends AsyncTask<String, Void, Void> {

		@Override
		protected Void doInBackground(String... params) {
			try {
				Thread.sleep(1000);
			} catch (InterruptedException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			String userName = sharedPf.getString("username", "");
			EditText editText = (EditText) findViewById(R.id.inputText);
			String message = userName + ":" + editText.getText().toString();
			ChatActivity.this.runOnUiThread(new Runnable() {

				@Override
				public void run() {
					// TODO Auto-generated method stub
					EditText editText = (EditText) findViewById(R.id.inputText);
					editText.setText("");

				}
			});

			Packet0007String mp = new Packet0007String();
			mp.message = message.toCharArray();
			client.client.sendTCP(mp);
			return null;
		}

	}

	public void setDisplyMessage(String message) {

		TextView textView = (TextView) findViewById(R.id.displayText);
		String displayMessage = new String();
		displayMessage = textView.getText().toString() + "\n" + message;
		textView.setText(displayMessage);

	}

	public void setStartChat(int num) {

		String userName = sharedPf.getString("username", "");
		TextView textView = (TextView) findViewById(R.id.displayText);
		String displayMessage = new String();
		displayMessage = "Welcome to the chat room, " + userName + "." + "\n"
				+ "There are currently " + num + " users in the chat room.";
		textView.setText(displayMessage);

	}

}
