package com.example.traingame;

import java.util.ArrayList;
import java.util.Arrays;

import lanceGameRoomNetworking.GameInfoManager;
import lanceGameRoomNetworking.RoomClient;
import lanceGameRoomNetworking.packets.TrainLogInRequest;
import lanceGameRoomNetworking.packets.TrainRoomInfo;


import com.example.traingame.R;

import android.os.AsyncTask;
import android.os.Bundle;
import android.app.Activity;
import android.app.AlertDialog;
import android.content.DialogInterface;
import android.content.Intent;
import android.util.Log;
import android.view.Menu;
import android.view.View;
import android.widget.ArrayAdapter;
import android.widget.ListView;
import android.widget.TextView;

public class LanceTrainRoomActivity extends Activity {
	TextView trainname;
	ListView gameRooms;
	ArrayAdapter<String> adapter;
	String[] list = new String[]{"THIS", "IS", "SPARTA!"};
	int[] roomids = new int[]{};
	
	RoomClient client;
	
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		
		
		setContentView(R.layout.activity_lance_train_room);
		trainname = (TextView) findViewById(R.id.trainname);
		gameRooms = (ListView) findViewById(R.id.gameRooms);
		
		String extra = getIntent().getExtras().getString("TrainName");
		if (extra != null){
			trainname.setText(extra);
		}
		
		new clientCreationTask().execute(this);
		new sendMessageTask().execute("");
		
		ArrayList<String> lst = new ArrayList<String>();
		lst.addAll(Arrays.asList(list));
		adapter = new ArrayAdapter<String>(this, android.R.layout.simple_list_item_1, lst);
		gameRooms.setAdapter(adapter);
	}

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		// Inflate the menu; this adds items to the action bar if it is present.
		getMenuInflater().inflate(R.menu.train_room, menu);
		return true;
	}
	
	public void comingSoon(View view){
		AlertDialog.Builder builder = new AlertDialog.Builder(this);
		builder.setTitle("ComingSoon");
		builder.setMessage("More Feature Coming Soon!");
		builder.setNegativeButton("OK", new DialogInterface.OnClickListener() {
			
			@Override
			public void onClick(DialogInterface dialog, int which) {
				// TODO Auto-generated method stub
				dialog.dismiss();
			}
		});
		builder.show();
	}
	
	public void updateList(final TrainRoomInfo tri){
		runOnUiThread(new Runnable(){
			@Override
			public void run() {
				// TODO Auto-generated method stub
				Log.i("RoomClient", "I'm firing my laser!");
				roomids = tri.roomIds;
				String[] tempList = new String[tri.existingPlayers.length];
				for (int i = 0; i < tri.existingPlayers.length; i++){
					tempList[i] = GameInfoManager.getInstance().retrieveGameName(tri.gameIds[i]) + " " +tri.existingPlayers[i] + "/" + tri.numOfPlayers[i];		
				}
				ArrayList<String> lst = new ArrayList<String>();
				lst.addAll(Arrays.asList(new String[]{"efe", "paoe", }));
				adapter.clear();
				adapter.addAll(lst);
				adapter.notifyDataSetChanged();
			}
		});
	}

	public char[] getTrainId() {
		return trainname.getText().toString().toCharArray();
	}
	
	private class clientCreationTask extends AsyncTask<LanceTrainRoomActivity, Void, RoomClient>{

		@Override
		protected void onPostExecute(RoomClient result) {
	        client = result;
	     }

		@Override
		protected RoomClient doInBackground(LanceTrainRoomActivity... params) {
			// TODO Auto-generated method stub
			return new RoomClient(params[0]);
		}
	}
	
	private class sendMessageTask extends AsyncTask<String, Void, Void>{

		@Override
		protected Void doInBackground(String... params) {
			try {
				Thread.sleep(2000);
			} catch (InterruptedException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			TrainLogInRequest login = new TrainLogInRequest();
			login.trainid = trainname.getText().toString().toCharArray();
			Log.i("TrainRoomClient", "The train id is" + new String(login.trainid));
			client.client.sendTCP(login);
			return null;
		}
		
	}
	
	public void gotoProfile(View view){
		Intent intent = new Intent(this, ProfileActivity.class);
		startActivityForResult(intent, 1);
	}
	
	public void gotoChat(View view){
		Intent intent = new Intent(this, ChatActivity.class);
		startActivityForResult(intent, 1);
	}
	
	@Override
	protected void onActivityResult(int requestCode, int resultCode, Intent data) 
	{
	     super.onActivityResult(requestCode, resultCode, data);
	     //matches the result code passed from ChildActivity
	     if(resultCode == 1) 
	     {
	    	 Log.i("TrainRoom","Should stop something");
	         LanceTrainRoomActivity.this.finish();
	     }
	}
	
	@Override
	protected void onStop() {
		// TODO Auto-generated method stub
		super.onStop();
		//client.client.stop();
	}
}
