package com.example.traingame;

import database.DBProtocolC;
import android.app.Activity;
import android.content.Intent;
import android.content.SharedPreferences;
import android.os.AsyncTask;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.widget.CheckBox;
import android.widget.EditText;
import android.widget.Toast;

public class Login extends Activity {
	EditText username;
	EditText password;
	
	CheckBox newconfirm;
	EditText pwconfirm;
	
	SharedPreferences sharedPref;
	
	AsyncTask<String, Void, Void> currentTask;
	
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		
		/*
		SharedPreferences SP = MainActivity.getSharedPrefs();
		SharedPreferences.Editor pEditor = SP.edit();
		pEditor.putBoolean("hasName", true);
		pEditor.commit();
		*/
		
	    // Create the text view
	    /*TextView textView = new TextView(this);
	    textView.setTextSize(40);
	    textView.setText("HIII");*/

	    // Set the text view as the activity layout
	    setContentView(R.layout.login_layout);
	    
	    username = (EditText) findViewById(R.id.loginuserfield);
	    password = (EditText) findViewById(R.id.loginpwfield);
	    newconfirm = (CheckBox) findViewById(R.id.loginnewusercheck);
	    pwconfirm = (EditText) findViewById(R.id.loginretypepwfield);
	    
	    sharedPref = getSharedPreferences("currentUser", 0);
	    currentTask = null;
	}
	
	@Override
	protected void onStop() {
		// TODO Auto-generated method stub
		super.onStop();
		if (currentTask!=null){
			currentTask.cancel(true);
		}
	}
	
	public void login(View view){
		String u = username.getText().toString();
		String p = password.getText().toString();		
		if (u.isEmpty()){
			Toast.makeText(getApplicationContext(), "Please enter your username.", Toast.LENGTH_SHORT).show();
		} else if (u.length() > 20){
			Toast.makeText(getApplicationContext(), "Please enter a shorter username", Toast.LENGTH_SHORT).show();
		} else if (p.isEmpty()){
			Toast.makeText(getApplicationContext(), "Please enter your password.", Toast.LENGTH_SHORT).show();
		} else {
			currentTask = new logintask();
			currentTask.execute(u,p);
		}
	}
	
	public void newaccount(View view){

		String u = username.getText().toString();
		String p = password.getText().toString();
		String c = pwconfirm.getText().toString();
		if (!newconfirm.isChecked()){
			Toast.makeText(getApplicationContext(), "Please check the Create New Account box.", Toast.LENGTH_SHORT).show();
		} else if (u.isEmpty()){
			Toast.makeText(getApplicationContext(), "Please enter your username.", Toast.LENGTH_SHORT).show();
		} else if (p.isEmpty()){
			Toast.makeText(getApplicationContext(), "Please enter your password.", Toast.LENGTH_SHORT).show();
		} else if (u.length() > 20){
			Toast.makeText(getApplicationContext(), "Please enter a shorter username", Toast.LENGTH_SHORT).show();
		} else if (!p.equals(c)){
			Toast.makeText(getApplicationContext(), "Please make sure passwords match.", Toast.LENGTH_SHORT).show();
		} else {
			currentTask = new storetask();
			currentTask.execute(u,p);
		}	
	}
	
	class logintask extends AsyncTask<String, Void, Void>{

		@Override
		protected Void doInBackground(String... params) {
			// TODO Auto-generated method stub
			DBProtocolC.connectToDB();
			String myuid = DBProtocolC.login(params[0], params[1]);
			if (myuid.equals("-1")){
				Login.this.runOnUiThread(new Runnable() {
					
					@Override
					public void run() {
						// TODO Auto-generated method stub
						Toast.makeText(getApplicationContext(), "Username or password is not correct", Toast.LENGTH_SHORT).show();
					}
				});
			} else {
				myuid = String.format("%04d", Integer.valueOf(myuid));
				Log.i("Login Screen", "My UID is: "+myuid);
				SharedPreferences.Editor editor = sharedPref.edit();
				editor.putString("uid", myuid);
				editor.putString("username", params[0]);
				editor.commit();
				Intent intent = new Intent(Login.this,QRLoginActivity.class);
				startActivity(intent);
				finish();
			}
			DBProtocolC.close();
			return null;
		}
		
	}
	
	private class storetask extends AsyncTask<String, Void, Void>{

		@Override
		protected Void doInBackground(String... params) {
			// TODO Auto-generated method stub
			DBProtocolC.connectToDB();
			String newuid = DBProtocolC.storeUser(params[0], params[1]);
			if (newuid.equals("-1")){
				Login.this.runOnUiThread(new Runnable(){
					
					@Override
					public void run() {
						// TODO Auto-generated method stub
						Toast.makeText(getApplicationContext(), "User already exists", Toast.LENGTH_SHORT).show();
					}			
				});	
			} else {
				SharedPreferences.Editor editor = sharedPref.edit();
				editor.putString("uid", newuid);
				editor.putString("username", params[0]);
				editor.commit();
				Intent intent = new Intent(Login.this,QRLoginActivity.class);
				startActivity(intent);
				finish();
			}
			DBProtocolC.close();
			return null;
		}
		
	}
	
}
