package com.example.traingame;

import org.andengine.engine.camera.Camera;
import org.andengine.engine.handler.timer.ITimerCallback;
import org.andengine.engine.handler.timer.TimerHandler;
import org.andengine.engine.options.EngineOptions;
import org.andengine.engine.options.ScreenOrientation;
import org.andengine.engine.options.resolutionpolicy.RatioResolutionPolicy;
import org.andengine.entity.scene.Scene;
import org.andengine.opengl.texture.atlas.bitmap.BitmapTextureAtlas;
import org.andengine.opengl.texture.region.ITextureRegion;
import org.andengine.ui.activity.BaseGameActivity;

import com.example.traingame.SceneManager.AllScenes;
import android.content.SharedPreferences;
import android.content.pm.ActivityInfo;
import android.util.Log;
import android.view.WindowManager;


public class MainActivity extends BaseGameActivity{

	Scene scene;
	protected static final int CAM_WIDTH = 800;
	protected static final int CAM_HEIGHT = 480;
	BitmapTextureAtlas playerTex;
	ITextureRegion playerTexRegion;
	static SceneManager sceneMan;
	Camera mCam;	
	AllScenes game;
	

	@Override
	public EngineOptions onCreateEngineOptions() {
	WindowManager windowManager = (WindowManager) getSystemService(WINDOW_SERVICE);
	int WIDTH = windowManager.getDefaultDisplay().getWidth();
	int HEIGHT = windowManager.getDefaultDisplay().getHeight();
	ScreenOrientation initialOrientation;	
	RatioResolutionPolicy ratio;
	
	if (getIntent().getExtras() != null){
		Log.d("testing", "andengine orientation ID = "+ getIntent().getExtras().getInt("gameNameID"));
		switch (getIntent().getExtras().getInt("gameNameID")){
		case 4:
			setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_PORTRAIT);
			initialOrientation = ScreenOrientation.PORTRAIT_FIXED;

	        if (WIDTH < HEIGHT){
	        	this.mCam = new Camera(0, 0, WIDTH, HEIGHT);
	        	ratio = new RatioResolutionPolicy(WIDTH, HEIGHT);
	        } else {
	        	this.mCam = new Camera(0, 0, HEIGHT, WIDTH);
	        	ratio = new RatioResolutionPolicy(HEIGHT, WIDTH);
	        }
			break;
		case 3:
			setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_PORTRAIT);
			initialOrientation = ScreenOrientation.PORTRAIT_FIXED;

	        if (WIDTH < HEIGHT){
	        	this.mCam = new Camera(0, 0, WIDTH, HEIGHT);
	        	ratio = new RatioResolutionPolicy(WIDTH, HEIGHT);
	        } else {
	        	this.mCam = new Camera(0, 0, HEIGHT, WIDTH);
	        	ratio = new RatioResolutionPolicy(HEIGHT, WIDTH);
	        }
			break;
		case 1:
			setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_LANDSCAPE);
			initialOrientation = ScreenOrientation.LANDSCAPE_FIXED;

	        if (WIDTH > HEIGHT){
	        	this.mCam = new Camera(0, 0, WIDTH, HEIGHT);
	        	ratio = new RatioResolutionPolicy(WIDTH, HEIGHT);
	        } else {
	        	this.mCam = new Camera(0, 0, HEIGHT, WIDTH);
	        	ratio = new RatioResolutionPolicy(HEIGHT, WIDTH);
	        }
			break;
		case 5:
			setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_PORTRAIT);
			initialOrientation = ScreenOrientation.PORTRAIT_FIXED;

	        if (WIDTH < HEIGHT){
	        	this.mCam = new Camera(0, 0, WIDTH, HEIGHT);
	        	ratio = new RatioResolutionPolicy(WIDTH, HEIGHT);
	        } else {
	        	this.mCam = new Camera(0, 0, HEIGHT, WIDTH);
	        	ratio = new RatioResolutionPolicy(HEIGHT, WIDTH);
	        }
			break;
		case 2:
			setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_LANDSCAPE);
			initialOrientation = ScreenOrientation.LANDSCAPE_FIXED;

	        if (WIDTH > HEIGHT){
	        	this.mCam = new Camera(0, 0, WIDTH, HEIGHT);
	        	ratio = new RatioResolutionPolicy(WIDTH, HEIGHT);
	        } else {
	        	this.mCam = new Camera(0, 0, HEIGHT, WIDTH);
	        	ratio = new RatioResolutionPolicy(HEIGHT, WIDTH);
	        }
			break;
		default:
			setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_PORTRAIT);
			initialOrientation = ScreenOrientation.PORTRAIT_FIXED;

	        if (WIDTH < HEIGHT){
	        	this.mCam = new Camera(0, 0, WIDTH, HEIGHT);
	        	ratio = new RatioResolutionPolicy(WIDTH, HEIGHT);
	        } else {
	        	this.mCam = new Camera(0, 0, HEIGHT, WIDTH);
	        	ratio = new RatioResolutionPolicy(HEIGHT, WIDTH);
	        }
			break;		
		}
	}
	else {
		Log.d("testing", "andengine intent extras are null. WHY.");
		setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_PORTRAIT);
		initialOrientation = ScreenOrientation.PORTRAIT_FIXED;
        this.mCam = new Camera(0, 0, WIDTH, HEIGHT);

        ratio = new RatioResolutionPolicy(WIDTH, HEIGHT);
	}
	return new EngineOptions(true,initialOrientation, ratio, mCam);
	
	}

	@Override
	public void onCreateResources(
			OnCreateResourcesCallback pOnCreateResourcesCallback)
			throws Exception {

		sceneMan = new SceneManager(this,mEngine,mCam);
		
		game = AllScenes.MENU;
		
		if (getIntent().getExtras() != null){	
			switch (getIntent().getExtras().getInt("gameNameID")){
			case 4:
				game = AllScenes.LAMIDA;
				break;
			case 3:
				game = AllScenes.LCREATURE;
				break;
			case 1:
				game = AllScenes.LPOTATO;
				break;
			case 5:
				game = AllScenes.LPERSISTANT;
				break;
			case 2:
				game = AllScenes.LWIZARD;
				break;
			default:
				game = AllScenes.MENU;
				break;		
			}
		}
		
		// all resources loaded
		pOnCreateResourcesCallback.onCreateResourcesFinished();
	}

	@Override
	public void onCreateScene(OnCreateSceneCallback pOnCreateSceneCallback)
			throws Exception {
		//setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_SENSOR);
		//REMOVE THIS LATER
		SharedPreferences SP = getSharedPrefs();
		SharedPreferences.Editor pEditor = SP.edit();
		if(SP.getBoolean("hasName", false)){
			pEditor.remove("hasName");
			pEditor.commit();
		}
		pOnCreateSceneCallback.onCreateSceneFinished(null);
		
	}
	
	@Override
	public void onPopulateScene(Scene pScene,
			OnPopulateSceneCallback pOnPopulateSceneCallback) throws Exception {
		/*
		sceneMan.setCurrentS(SceneManager.AllScenes.SPLASH);
		
		//I need to pass this class instance to the intent while in a
		//timer handler. If I just use this then it would think I meant
		//the timer handler.		
		mEngine.registerUpdateHandler(new TimerHandler(1f,new ITimerCallback(){
			public void onTimePassed(TimerHandler pTimerHandler){
				mEngine.unregisterUpdateHandler(pTimerHandler);
				//SharedPreferences SP = getSharedPrefs();
				//if(!SP.getBoolean("hasName", false)){
				//	Intent intent = new Intent(m, Login.class);
			    //	startActivity(intent);
				//}
				//else{
				Log.i("MainActivitys", "Starting game: " + game);
					sceneMan.setCurrentS(game);
					//sceneMan.setCurrentS(SceneManager.AllScenes.MENU);
				//}
			}
		})); 
		*/
		
		Log.i("MainActivitys", "Starting game: " + game);
		sceneMan.setCurrentS(game);
		pOnPopulateSceneCallback.onPopulateSceneFinished();
	}
	
	public static SharedPreferences getSharedPrefs(){
		return sceneMan.activity.getSharedPreferences("GamePrefs", 0);		
	}

}

