package com.example.traingame;

import mainmenu.MainMenuActivity;

import com.example.traingame.R;
import database.DBProtocolC;

import android.os.AsyncTask;
import android.os.Bundle;
import android.app.Activity;
import android.app.AlertDialog;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.SharedPreferences;
import android.view.Menu;
import android.view.View;
import android.widget.TextView;

public class ProfileActivity extends Activity {
	TextView username;
	TextView userscore;
	SharedPreferences sharedPf;
	AsyncTask<String, Void, Void> userScoreTask;
	
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_profile);
		
		sharedPf = getSharedPreferences("currentUser", 0);
		
		username = (TextView) findViewById(R.id.pusername);
		username.setText(sharedPf.getString("username", ""));
		
		userscore = (TextView) findViewById(R.id.puserscore);
		userScoreTask = new GetUserScore();
		userScoreTask.execute("");
	}
	
	private class GetUserScore extends AsyncTask<String, Void, Void>{

		@Override
		protected Void doInBackground(String... params) {
			DBProtocolC.connectToDB();
			final String userscorex = DBProtocolC.getUserScore(sharedPf.getString("uid", ""));
			ProfileActivity.this.runOnUiThread(new Runnable() {
				
				@Override
				public void run() {
					// TODO Auto-generated method stub
					userscore.setText("User Score: " + userscorex);
				}
			});
			return null;
		}
		
	}

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		// Inflate the menu; this adds items to the action bar if it is present.
		getMenuInflater().inflate(R.menu.profile, menu);
		return true;
	}

	public void switchTrain(View view){
		AlertDialog.Builder builder = new AlertDialog.Builder(this);
		builder.setMessage("Are you sure you want to switch the train?");
		builder.setPositiveButton("OK", new DialogInterface.OnClickListener() {
			
			@Override
			public void onClick(DialogInterface dialog, int which) {
				// TODO Auto-generated method stub
				switch4real();
			}
		});
		builder.setNegativeButton("Cancel", new DialogInterface.OnClickListener() {
			
			@Override
			public void onClick(DialogInterface dialog, int which) {
				// TODO Auto-generated method stub
				dialog.dismiss();
			}
		});
		builder.show();
	}
	
	public void switch4real(){
		MainMenuActivity.changeTrainRoom();
		Intent intent = new Intent(this, QRLoginActivity.class);
		startActivity(intent);
		setResult(1);
		finish();
	}
	
	public void logout(View view){
		AlertDialog.Builder builder = new AlertDialog.Builder(this);
		builder.setMessage("Are you sure you want to log out?");
		builder.setPositiveButton("OK", new DialogInterface.OnClickListener() {
			
			@Override
			public void onClick(DialogInterface dialog, int which) {
				// TODO Auto-generated method stub
				logout4real();
			}
		});
		builder.setNegativeButton("Cancel", new DialogInterface.OnClickListener() {
			
			@Override
			public void onClick(DialogInterface dialog, int which) {
				// TODO Auto-generated method stub
				dialog.dismiss();
			}
		});
		builder.show();
	}
	
	private void logout4real() {
		// TODO Auto-generated method stub
		sharedPf.edit().clear().commit();
		getSharedPreferences("GamePrefs", 0).edit().clear().commit();
		Intent intent = new Intent(this, Login.class);
		startActivity(intent);
		setResult(1);
		finish();
	}
	
	public void back(View view){
		finish();
	}
	
	public void credit(View view){
		Intent intent = new Intent(this, CreditActivity.class);
		startActivity(intent);
	}
	
	public void switchChangePassword(View view){
		Intent intent = new Intent(this, ChangePWActivity.class);
		startActivity(intent);
	}
	
	@Override
	protected void onStop() {
		// TODO Auto-generated method stub
		super.onStop();
		if (userScoreTask!=null){
			userScoreTask.cancel(true);
		}
	}
}
