package com.example.traingame;

import java.util.ArrayList;
import mainmenu.MainMenuActivity;

import com.example.traingame.R;
import com.google.zxing.integration.android.IntentIntegrator;
import com.google.zxing.integration.android.IntentResult;

import android.os.Bundle;
import android.app.Activity;
import android.content.Intent;
import android.content.SharedPreferences;
import android.graphics.Color;
import android.view.Menu;
import android.view.View;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.LinearLayout;
import android.widget.ListView;
import android.widget.TextView;
import android.widget.Toast;

public class QRLoginActivity extends Activity {
	TextView trainInfo;
	SharedPreferences sharedPref;
	String[] trainIds;
	ArrayList<String> oldTrains;
	
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_qrlogin);
		trainInfo = (TextView) findViewById(R.id.trainInfo);
		
		ListView l = (ListView) findViewById(R.id.usedtrains);
		l.setBackgroundColor(Color.WHITE);
		
		LinearLayout ll = (LinearLayout) findViewById(R.id.usedtrainFrame);
		ll.setBackgroundColor(Color.RED);
		
		sharedPref = getSharedPreferences("QRRoom",0);
		oldTrains = retrieveOldTrains();
		if (oldTrains.isEmpty()){
			trainIds = new String[1];
			trainIds[0] = "Worcester/Framingham Route";
			oldTrains.add("Worcester/Framingham Route");
		}
		ArrayAdapter<String> adapter = new ArrayAdapter<String>(this, android.R.layout.simple_list_item_1, oldTrains);
		l.setAdapter(adapter);
		l.setOnItemClickListener(new AdapterView.OnItemClickListener() {
			@Override
			public void onItemClick(AdapterView<?> parent, View view, int position,
					long id) {
				trainroomingFast(trainIds[position]);
			}
		});
	}

	private ArrayList<String> retrieveOldTrains() {
		// TODO Auto-generated method stub
		ArrayList<String> oldtrainList = new ArrayList<String>();
		ArrayList<String> oldtrainIds = new ArrayList<String>();
		for (String s: sharedPref.getAll().keySet()){
			oldtrainList.add(s+"("+sharedPref.getInt(s, -1)+")");
			oldtrainIds.add(s);
		}
		trainIds = new String[oldtrainIds.size()];
		trainIds = oldtrainIds.toArray(trainIds);
		return oldtrainList;
	}

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		// Inflate the menu; this adds items to the action bar if it is present.
		getMenuInflater().inflate(R.menu.qrlogin, menu);
		return true;
	}
	
	public void scan(View view){
		IntentIntegrator ii = new IntentIntegrator(this);
		ii.initiateScan();
	}
	
	public void gaming(View view){
		Intent intent = new Intent(this, MainActivity.class);

		intent.putExtra("gameNameID", 5);

		startActivity(intent);
	}
	
	public void trainrooming(View view){
		if (trainInfo.getText().length() == 0){
			Toast.makeText(getApplicationContext(), "Please scan the QR code", Toast.LENGTH_LONG).show();
		} else{
			SharedPreferences.Editor editor = sharedPref.edit();
			if (sharedPref.getAll().containsKey(trainInfo.getText().toString())){
				editor.putInt(trainInfo.getText().toString(), sharedPref.getInt(trainInfo.getText().toString(), -1) + 1);
				editor.commit();
			} else {
				editor.putInt(trainInfo.getText().toString(), 0);
				editor.commit();
			}
			
			Intent intent = new Intent(this, MainMenuActivity.class);
			intent.putExtra("trainRoom", trainInfo.getText());
			startActivity(intent);
			finish();
		}
	}
	
	public void trainroomingFast(String trainid){
		SharedPreferences.Editor editor = sharedPref.edit();
		editor.putInt(trainid, sharedPref.getInt(trainid, -1) + 1);
		editor.commit();
		
		Intent intent = new Intent(this, MainMenuActivity.class);
		intent.putExtra("trainRoom", trainid);
		startActivity(intent);
		finish();
	}
	
	@Override
	protected void onActivityResult(int requestCode, int resultCode, Intent data) {
		// TODO Auto-generated method stub
		  IntentResult scanResult = IntentIntegrator.parseActivityResult(requestCode, resultCode, data);
		  if (scanResult != null) {
			  trainInfo.setText(scanResult.getContents());
		  }
	}

}
