package com.example.traingame;

import java.util.HashMap;

import grizzlygame.grizzlySetup;
import loadingscenes.LAmidaSetup;
import loadingscenes.LCreatureSetup;
import loadingscenes.LGrizzlySetup;
import loadingscenes.LMummySetup;
import loadingscenes.LPersistantSetup;
import loadingscenes.LPotatoSetup;
import loadingscenes.LWizardSetup;
import loadingscenes.splashSetup;
import menu.menuSetup;
import mummygame.mummySetup;

import org.andengine.engine.Engine;
import org.andengine.engine.camera.Camera;
import org.andengine.entity.scene.Scene;
import org.andengine.extension.physics.box2d.PhysicsWorld;
import org.andengine.ui.activity.BaseGameActivity;

import persistantgame.persVendSetup;
import persistantgame.persistantSetup;
import potatogame.PNextSetup;
import potatogame.pLossSetup;
import potatogame.pWinSetup;
import potatogame.potatoSetup;
import wizardgame.wizardLoss;
import wizardgame.wizardSetup;
import amidagame.amidaResultSetup;
import amidagame.amidaSetup;
import amidagame.newSmallLineListener;
import android.content.SharedPreferences;
import android.hardware.SensorManager;
import android.util.Log;
import creaturegame.cWinSetup;
import creaturegame.creatureSetup;

public class SceneManager {
	// L indicates a loading screen for the named game
	public enum AllScenes {
		SPLASH, MENU, POTATO, LPOTATO, AMIDA, LAMIDA, CREATURE, CWIN, LCREATURE, WIZARD, LWIZARD, MUMMY, LMUMMY, GRIZZLY, LGRIZZLY, PERSISTANT, LPERSISTANT, PERSVEND, WINPOTATO, LOSSPOTATO, NEXTPOTATO, LOSSWIZARD, OTHERUSERS, SINGLEUSER, AMIDARESULT;
	}

	private AllScenes currentS;
	public BaseGameActivity activity;
	public Engine engine;
	public Camera camera;
	private Scene splashScene, menuScene, potatoScene, LPotatoScene,
			winPotatoScene, lossPotatoScene, nextPotatoScene, lossWizardScene,
			amidaScene, LAmidaScene, creatureScene, creatureWinScene,
			LCreatureScene, wizardScene, LWizardScene, mummyScene, LMummyScene,
			grizzlyScene, LGrizzlyScene, persistantScene, LPersistantScene,
			persVendScene, otherUsersScene, singleUserScene, amidaResultScene;

	// sprite testing
	PhysicsWorld PW;
	SensorManager SM;

	// used to setup any given screen
	private splashSetup splashsetup = new splashSetup(this);
	private mummySetup mummysetup = new mummySetup(this);
	private amidaSetup amidasetup = new amidaSetup(this);
	private creatureSetup creaturesetup = new creatureSetup(this);
	private cWinSetup creaturewinsetup = new cWinSetup(this);
	private grizzlySetup grizzlysetup = new grizzlySetup(this);
	private LAmidaSetup LAmidasetup = new LAmidaSetup(this);
	private LCreatureSetup LCreaturesetup = new LCreatureSetup(this);
	private LGrizzlySetup LGrizzlysetup = new LGrizzlySetup(this);
	private LMummySetup LMummysetup = new LMummySetup(this);
	private LPersistantSetup LPersistantsetup = new LPersistantSetup(this);
	private LPotatoSetup LPotatosetup = new LPotatoSetup(this);
	private LWizardSetup LWizardsetup = new LWizardSetup(this);
	private menuSetup menusetup = new menuSetup(this);
	private persistantSetup persistantsetup = new persistantSetup(this);
	private potatoSetup potatosetup = new potatoSetup(this);
	private wizardSetup wizardsetup = new wizardSetup(this);
	private pLossSetup losspotatosetup = new pLossSetup(this);
	private pWinSetup winpotatosetup = new pWinSetup(this);
	private PNextSetup nextpotatosetup = new PNextSetup(this);
	private persVendSetup persvendsetup = new persVendSetup(this);
	private wizardLoss wizardlosssetup = new wizardLoss(this);
	private amidaResultSetup amidaresultsetup = new amidaResultSetup(this);

	// track how many players have connected when you create a game
	private int potatoPlayers = 5;
	private int potatoStart = 5;
	private int potatoUser = 5;
	private HashMap<Integer, char[]> pMap = new HashMap<Integer, char[]>();
	private Integer pGameID = 0;
	private Integer pUID = 0;
	
	//track number of players and starting player for wizard along with gameID
	private boolean twoPlay = false;
	private boolean startingPlay = false;
	private Integer wGameID = 0;

	public SceneManager(BaseGameActivity act, Engine eng, Camera cam) {
		this.activity = act;
		this.engine = eng;
		this.camera = cam;
	}

	public AllScenes getCurrentS() {
		return currentS;
	}

	public void setCurrentS(AllScenes currentS) {
		this.currentS = currentS;
		switch (currentS) {
		case SPLASH:
			if (splashScene == null) {
				splashsetup.load();
			}

			splashScene = splashsetup.create();
			engine.setScene(splashScene);
			break;
		case MENU:
			if (menuScene == null) {
				menusetup.load();
				menuScene = menusetup.create();
			}
			engine.setScene(menuScene);
			break;
		case POTATO:
			if (potatoScene == null) {
				potatosetup = new potatoSetup(this, potatoPlayers);
				potatosetup.load();
			}
			potatosetup.setP(potatoPlayers, potatoStart, potatoUser);
			potatosetup.setGameID(pGameID, pUID);
			potatosetup.setHash(pMap);
			potatoScene = potatosetup.create();
			engine.setScene(potatoScene);
			break;
		case LPOTATO:
			if (LPotatoScene == null) {
				LPotatosetup.load();
			}
			LPotatoScene = LPotatosetup.create();
			engine.setScene(LPotatoScene);
			break;
		case AMIDA:
			if (amidaScene == null) {
				amidasetup.load();
			}

			amidaScene = amidasetup.create();
			amidaScene.setOnSceneTouchListener(new newSmallLineListener(this));
			engine.setScene(amidaScene);
			break;
		case LAMIDA:
			if (LAmidaScene == null) {
				LAmidasetup.load();
			}

			LAmidaScene = LAmidasetup.create();
			engine.setScene(LAmidaScene);
			break;
		case CREATURE:
			if (creatureScene == null) {
				creaturesetup.load();
			}

			creatureScene = creaturesetup.create();
			engine.setScene(creatureScene);
			break;
		case LCREATURE:
			if (LCreatureScene == null) {
				LCreaturesetup.load();
			}

			LCreatureScene = LCreaturesetup.create();
			engine.setScene(LCreatureScene);
			break;
		case CWIN:
			if (creatureWinScene == null) {
				creaturewinsetup.load();
			}

			creatureWinScene = creaturewinsetup.create();
			engine.setScene(creatureWinScene);
			break;
		case WIZARD:
			if (wizardScene == null) {
				wizardsetup.setPlay(twoPlay);
				wizardsetup.setTurn(startingPlay);
				wizardsetup.setID(wGameID);
				wizardsetup.load();
			}

			wizardScene = wizardsetup.create();
			engine.setScene(wizardScene);
			break;
		case LWIZARD:
			if (LWizardScene == null) {
				LWizardsetup.load();
			}

			LWizardScene = LWizardsetup.create();
			engine.setScene(LWizardScene);
			break;
		case LOSSWIZARD:
			if (lossWizardScene == null) {
				wizardlosssetup.load();
			}
			lossWizardScene = wizardlosssetup.create();
			engine.setScene(lossWizardScene);
			break;
		case MUMMY:
			if (mummyScene == null) {
				mummysetup.load();
			}

			mummyScene = mummysetup.create();
			engine.setScene(mummyScene);
			break;
		case LMUMMY:
			if (LMummyScene == null) {
				LMummysetup.load();
			}

			LMummyScene = LMummysetup.create();
			engine.setScene(LMummyScene);
			break;
		case GRIZZLY:
			if (grizzlyScene == null) {
				grizzlysetup.load();
			}
			grizzlyScene = grizzlysetup.create();
			engine.setScene(grizzlyScene);
			break;
		case LGRIZZLY:
			if (LGrizzlyScene == null) {
				LGrizzlysetup.load();
			}
			LGrizzlyScene = LGrizzlysetup.create();
			engine.setScene(LGrizzlyScene);
			break;
		case PERSISTANT:
			if (persistantScene == null) {
				persistantsetup.load();
			}
			persistantScene = persistantsetup.create();
			engine.setScene(persistantScene);
			break;
		case LPERSISTANT:
			if (LPersistantScene == null) {
				LPersistantsetup.load();
			}
			LPersistantScene = LPersistantsetup.create();
			engine.setScene(LPersistantScene);
			break;
		case PERSVEND:
			if (persVendScene == null) {
				persvendsetup.load();
			}
			persVendScene = persvendsetup.create();
			engine.setScene(persVendScene);
			break;
		case WINPOTATO:
			if (winPotatoScene == null) {
				winpotatosetup.load();
			}
			winPotatoScene = winpotatosetup.create();
			engine.setScene(winPotatoScene);
			break;
		case LOSSPOTATO:
			if (lossPotatoScene == null) {
				losspotatosetup.load();
			}
			lossPotatoScene = losspotatosetup.create();
			engine.setScene(lossPotatoScene);
			break;
		case NEXTPOTATO:
			if (nextPotatoScene == null) {
				nextpotatosetup.load();
			}
			nextPotatoScene = nextpotatosetup.create();
			engine.setScene(nextPotatoScene);
			break;
		case AMIDARESULT:
			if (amidaResultScene == null) {
				amidaresultsetup.load();
			}
			amidaResultScene = amidaresultsetup.create();
			engine.setScene(amidaResultScene);
			break;
		default:
			break;
		}
	}

	public void setWinS(AllScenes currentS, int[] selections) {
		this.currentS = currentS;
		switch (currentS) {
		case CWIN:
			if (creatureWinScene == null) {
				creaturewinsetup.load();
			}

			creatureWinScene = creaturewinsetup.create();
			creaturewinsetup.setWin(selections);
			engine.setScene(creatureWinScene);
			break;
		default:
			break;
		}
	}

	public amidaSetup getAmidasetup() {
		return amidasetup;
	}
	
	public potatoSetup getPotatosetup(){
		return potatosetup;
	}

	public void setAmidasetup(amidaSetup amidasetup) {
		this.amidasetup = amidasetup;
	}

	public Scene getAmidaScene() {
		return amidaScene;
	}

	public void setAmidaScene(Scene amidaScene) {
		this.amidaScene = amidaScene;
	}

	public wizardSetup getWizardSetup() {
		return wizardsetup;
	}

	public void setPotatoPlayers(int i, int i2, int i3) {
		potatoPlayers = i;
		potatoStart = i2;
		potatoUser = i3;
	}
	
	public void setPHash(HashMap<Integer, char[]> hm){
		pMap = hm;
	}
	
	public void setPGameID(Integer i, Integer i2){
		pGameID = i;
		pUID = i2;
	}
	
	public void setWizardPlayers(boolean b1, boolean b2, Integer gid){
		twoPlay = b1;
		startingPlay = b2;
		wGameID = gid;
	}
}