package creaturegame;

import java.io.IOException;
import java.util.LinkedList;

import com.esotericsoftware.kryo.Kryo;
import com.esotericsoftware.kryonet.Connection;
import com.esotericsoftware.kryonet.Server;
import com.esotericsoftware.minlog.Log;
import com.example.lctnetworktesting.networking.packets.*;

public class CCServer {
	private Server server;
	public LinkedList<Connection> cList;
	public LinkedList<Connection> cList2;
	private int count;

	public CCServer() throws IOException {
		server = new Server();

		cList = new LinkedList<Connection>();
		cList2 = new LinkedList<Connection>();
		count = 0;
		registerPackets();
		// TODO
		CCListenerS l = new CCListenerS(this);
		server.addListener(l);
		server.bind(9999);
		server.start();
	}

	private void registerPackets() {
		Kryo kryo = server.getKryo();
		kryo.register(Packet0000LogInfo.class);
		kryo.register(Packet0001LogInAccepted.class);
		kryo.register(Packet0002Message.class);
		kryo.register(Packet0003SyncReq.class);
		kryo.register(Packet0004Ack.class);
		kryo.register(Packet0005Number.class);
		kryo.register(Packet0006AssignParts.class);
		kryo.register(Packet0009Ready.class);
	}

	public void broadcastOnce() {
		for (Connection c : cList) {
			Packet0002Message p = new Packet0002Message();
			p.message = "Two Person Play! Size is " + cList.size();
			c.sendTCP(p);
		}
		cList.clear();
		count = 0;
	}

	public void broadcastAgain() {
		Packet0002Message p = new Packet0002Message();
		p.message = "Two Person Play! Size is " + cList.size();
		server.sendToAllTCP(p);
	}

	public int getCount() {
		return count;
	}

	public void setCount(int count) {
		this.count = count;
	}

	public static void main(String [] args){
		
		try {
			new CCServer();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

	}
}
