package database;

import networking.packets.Packet0006Long;
import networking.packets.Packet0007String;

import com.esotericsoftware.kryonet.Connection;
import com.esotericsoftware.kryonet.Listener;
import com.example.lctnetworktesting.networking.packets.Packet0000LogInfo;
import com.example.lctnetworktesting.networking.packets.Packet0001LogInAccepted;
import com.example.lctnetworktesting.networking.packets.Packet0002Message;
import com.example.lctnetworktesting.networking.packets.Packet0003SyncReq;
import com.example.lctnetworktesting.networking.packets.Packet0004Ack;
import com.example.lctnetworktesting.networking.packets.Packet0005Number;


public class DBListenerS extends Listener {
	private DBServer server;
	boolean connecting;
	private int pid = 0;

	public DBListenerS(DBServer server) {
		this.server = server;
		connecting = true;
	}

	public void connected(Connection arg0) {
		// DO SOMETHING
		System.out.println("AAAA-S");
	}

	public void disconnected(Connection arg0) {
		// DO SOMETHING
		System.out.println("BBBB-S");
	}

	public void received(Connection arg0, Object arg1) {
		// DO SOMETHING
		System.out.println("CCCC-S");
		if (arg1 instanceof Packet0000LogInfo) {
			Packet0001LogInAccepted p = new Packet0001LogInAccepted();
			p.accepted = true;
			arg0.sendTCP(p);			
			server.cList.add(arg0);
		}
		if (arg1 instanceof Packet0002Message) {
			String message = ((Packet0002Message) arg1).message;
			if (message.equals("wow wow")) {
				System.out.println("VENUS");
			} else if (message.equals("Exit")) {
				connecting = false;
			}
			System.out.println("The meEEEEEssage is: " + message);
		}
		if (arg1 instanceof Packet0005Number) {
			int id = ((Packet0005Number) arg1).id;
			int value = ((Packet0005Number) arg1).value;
			System.out.println("The number is: " + id + " " + value);
			for (Connection c : server.cList) {
				System.out.println("sent to client");
				Packet0005Number p = new Packet0005Number();
				p.id = id;
				p.value = value;
				c.sendTCP(p);
			}
		}
		if (arg1 instanceof Packet0003SyncReq) {
			server.setCount(server.getCount() + 1);
			server.cList.add(arg0);
			if (server.getCount() >= 2) {
				server.broadcastAgain();
			}
		}
		if (arg1 instanceof Packet0004Ack) {
			System.out.println("Ack received!");

			SThread st = new SThread(arg0);
			st.start();
		}
		if (arg1 instanceof Packet0006Long) {			
			long messageLong = ((Packet0006Long) arg1).message;
			System.out.println("Int received to DBLS! " + messageLong);
			String message = String.valueOf(messageLong);
			DBProtocolS.handleMessage(arg0, message);
		}
		if (arg1 instanceof Packet0007String) {			
			char[] messageChar = ((Packet0007String) arg1).message;
			String message = new String(messageChar);
			System.out.println("String received to DBLS! " + message);
			DBProtocolS.handleMessage(arg0, message);
		}
	}

	public class SThread extends Thread {
		Connection con;

		public SThread(Connection con) {
			this.con = con;
		}

		@Override
		public void run() {
			// TODO Auto-generated method stub
			try {
				Thread.sleep(1000);
			} catch (InterruptedException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}

			Packet0004Ack p = new Packet0004Ack();
			p.connecting = connecting;
			con.sendTCP(p);

			System.out.println("Ack sent");
		}

	}
	
}

