package database;

import java.util.LinkedList;

import networking.packets.Packet0006Long;
import networking.packets.Packet0007String;
import android.util.Log;

public class DBProtocolC {
	//THIS IS IN ANDROID
	private static DBClient client = new DBClient();
	
	//General
	public static void connectToDB() {
		sendInt("10");
	}
	
	public static void close() {
		sendInt("11");
	}
	
	//Storage
	public static String storeUser(String username, String password) {
		sendString("36" + username + "%" + password);
		String returnVal = retrieveInt();
		if (returnVal != "-1") { //zerofill UID
			String.format("%04d", Integer.valueOf(returnVal));
		}
		return returnVal;
	}
	
	public static String updatePW(String UID, String password) {
		sendString("21" + UID + password);
		return retrieveInt();
	}
	
	public static String updateUserScore(String UID, String user_score) {
		sendInt("22" + UID + user_score);
		return retrieveInt();
	}
	
	public static String updateCurrTrainScore(String UID, String curr_train_score) {
		sendInt("23" + UID + curr_train_score);
		return retrieveInt();
	}
	
	public static String removeUser(String UID) {
		sendInt("24" + UID);
		return retrieveInt();
	}
	
	public static void updatePlays(String UID1, String UID2) {
		sendInt("25" + UID1 + UID2);
	}
	
	public static void updateCargoTrades(String UID1, String UID2) {
		sendInt("26" + UID1 + UID2);
	}
	
	public static void storeScore(String UID, String GID, String score) {
		sendInt("27" + UID + GID + score);
	}
	
	//Retrieval
	public static String getUsername(String UID) {
		sendInt("30" + UID);
		return retrieveString();
	}
	
	public static String getUsername(Integer UID) {
		String UIDStr = String.format("%04d", UID);
		sendInt("30" + UIDStr);
		return retrieveString();
	}
	
	public static String getUserScore(String UID) {
		sendInt("31" + UID);
		return retrieveInt();
	}
	
	public static String getCurrTrainScore(String UID) {
		sendInt("32" + UID);
		return retrieveInt();
	}
	
	public static String getPlays(String UID1, String UID2) {
		sendInt("33" + UID1 + UID2);
		return retrieveInt();
	}
	
	public static String getPlays(Integer UIDa, Integer UIDb) {
		String UID1 = String.format("%04d", UIDa);
		String UID2 = String.format("%04d", UIDb);
		sendInt("33" + UID1 + UID2);
		return retrieveInt();
	}
	
	public static String getCargoTrades(String UID1, String UID2) {
		sendInt("34" + UID1 + UID2);
		return retrieveInt();
	}
	
	public static LinkedList<Pair<String, String>> getHighscores(String UID) {
		sendString("35" + UID);
		String scoresString = retrieveString();
		LinkedList<Pair<String, String>> scores = new LinkedList<Pair<String, String>>();
		
		String[] gidScores = scoresString.split("%");
		for (String gidScore : gidScores) {
			if (gidScore.contentEquals("")) {
				continue;
			}
			String GID = gidScore.substring(0, 1);
			String score = gidScore.substring(1);
			scores.add(new Pair<String, String>(GID, score));
		}
				
		return scores;
	}
	
	public static String login(String username, String password) {
		sendString("37" + username + "%" + password);
		String returnVal = retrieveInt();
		if (returnVal != "-1") { //zerofill UID
			String.format("%04d", Integer.valueOf(returnVal));
		}
		return returnVal;
	}
	
	/**
	 * send the message to the server
	 * @param message
	 */
	public static void sendInt(String message){
		long messageInt = Long.parseLong(message);
		Packet0006Long mp = new Packet0006Long();
		mp.message = messageInt;
		client.client.sendTCP(mp);
	}
	
	public static void sendString(String message) {
		char[] messageChar = message.toCharArray();
		Packet0007String mp = new Packet0007String();
		mp.message = messageChar;
		client.client.sendTCP(mp);
	}
	
	/**
	 * retrieve DB data from the server
	 * @param message
	 */
	public static String retrieveInt(){
		long replyInt = -2;
		//TODO: timeout
		Log.d("testing", "before recieved value is: " + replyInt);
		while (replyInt == -2) {
			replyInt = DBListenerC.getReceivedInt();
		}		
		Log.d("testing", "recieved value is: " + replyInt);
		String message = String.valueOf(replyInt);		
		return message;		
	}
	
	/**
	 * retrieve DB data from the server
	 * @param message
	 */
	public static String retrieveString(){		
		String replyString = null;
		//TODO: timeout
		Log.d("testing", "before recieved value");
		while (replyString == null) {
			replyString = DBListenerC.getReceivedString();
		}		
		Log.d("testing", "recieved value is: " + replyString);
		return replyString;		
	}
}
