/**
 * 
 */
package database;

import java.util.LinkedList;

import networking.packets.Packet0006Long;
import networking.packets.Packet0007String;

import com.esotericsoftware.kryonet.Connection;

/**
 * @author Merrielle
 * 
 */
public class DBProtocolS {

	// THIS IS ON THE SERVER

	public static void handleMessage(Connection con, String message) {
		System.out.println("handling message");		
		String headerS = message.substring(0, 1);
		int header = Integer.valueOf(headerS);		
		
		switch (header) {
		case 1:
			handleStandardMessage(message);
			break;				
		case 2:
			handleStorageMessage(con, message);
			break;
		case 3: 
			System.out.println("3 received \n");
			handleRetreiveMessage(con, message);
			break;
		default:
			//TODO: error
			break;		
		}		
	}	
	
	public static void handleStandardMessage(String message) {		
		String headerS = message.substring(0, 2);		
		int header = Integer.valueOf(headerS);
		
		switch (header) {
		case 10:
			try {
				MySQLAccess.connectToDB();
			} catch (Exception e) {
			}
			break;
		case 11:
			try {
				MySQLAccess.close();
			} catch (Exception e) {
			}
			break;
		default:
			//TODO: unrecognized command. Error!
			break;
		}
	}

	public static void handleStorageMessage(Connection con, String message) {
		
		String headerS = message.substring(0, 2);
		int header = Integer.valueOf(headerS);		
		String body = message.substring(2);
		String UID, UID2, GID, password, score, 
		    userscore, curr_train_score, success;
		
		switch (header) {				
		case 21:
			UID = body.substring(0, 4);
			password = body.substring(4);
			try {
				success = MySQLAccess.updatePW(UID, password);
				sendInt(con, success);
			} catch (Exception e) {
			}
			break;			
		case 22:
			UID = body.substring(0, 4);
			userscore = body.substring(4);
			try {
				success = MySQLAccess.updateUserScore(UID, userscore);
				sendInt(con, success);
			} catch (Exception e) {
			}
			break;	
		case 23:
			UID = body.substring(0, 4);
			curr_train_score = body.substring(4);
			try {
				success = MySQLAccess.updateCurrTrainScore(UID, curr_train_score);
				sendInt(con, success);
			} catch (Exception e) {
			}
			break;	
		case 24:
			UID = body;
			try {
				success = MySQLAccess.removeUser(UID);
				sendInt(con, success);
			} catch (Exception e) {
			}
			break;
		case 25:
			UID = body.substring(0, 4);
			UID2 = body.substring(4, 8);
			try {
				MySQLAccess.updatePlays(UID, UID2);
			} catch (Exception e) {
			}
			break;
		case 26:
			UID = body.substring(0, 4);
			UID2 = body.substring(4, 8);
			try {
				MySQLAccess.updateCargoTrades(UID, UID2);
			} catch (Exception e) {
			}
			break;
		case 27:
			UID = body.substring(0, 4);
			GID = body.substring(4, 5);
			score = body.substring(5);
			try {
				MySQLAccess.storeScore(UID, GID, score);
			} catch (Exception e) {
			}
			break;	
			
			
			
		default:
			//TODO: unrecognized command. Error!
			break;
		}
	}
	
	public static void handleRetreiveMessage(Connection con, String message) {	
		System.out.println("in hRM");
		String headerS = message.substring(0, 2);
		int header = Integer.valueOf(headerS);
		System.out.println("header is " + header);
		String body = message.substring(2);
		String username, password, userscore, UID, UID2, GID, curr_train_score,
			score, all_scores, num_plays, num_cargo_trades;
		LinkedList<Pair<String, String>> highscores = new LinkedList<Pair<String, String>>();

		switch (header) {		
		case 30:
			UID = body;
			try {
				System.out.println("handling message 33");
				username = MySQLAccess.getUsername(UID);
				sendString(con, username);
			} catch (Exception e) {
			}
			break;
		case 31:
			UID = body;
			try {
				userscore = MySQLAccess.getUserScore(UID);
				sendInt(con, userscore);
			} catch (Exception e) {
			}
			break;
		case 32:
			UID = body;
			try {
				curr_train_score = MySQLAccess.getCurrTrainScore(UID);
				sendInt(con, curr_train_score);
			} catch (Exception e) {
			}
			break;
		case 33:			
			UID = body.substring(0, 4);
			UID2 = body.substring(4);
			try {
				num_plays = MySQLAccess.getPlays(UID, UID2);
				sendInt(con, num_plays);
			} catch (Exception e) {
			}
			break;
		case 34:
			UID = body.substring(0, 4);
			UID2 = body.substring(4);
			try {
				num_cargo_trades = MySQLAccess.getCargoTrades(UID, UID2);
				sendInt(con, num_cargo_trades);
			} catch (Exception e) {
			}
			break;
		case 35:
			UID = body;
			int i;
			try {
				highscores = MySQLAccess.getHighscores(UID);
				all_scores = "";
				for (i = 0; i < highscores.size(); i++) {
					Pair<String, String> scorePair = highscores.get(i);
					GID = scorePair.getFirst();
					score = scorePair.getSecond();
					if (i < highscores.size() - 1) {
						all_scores = all_scores + GID + score + "%";
					}
				}
				sendString(con, all_scores);
			} catch (Exception e) {
			}
			break;
		case 36:
			// TODO: error checking? Nah...
			String[] params = body.split("%");
			username = params[0];
			password = params[1];
			try {
				UID = MySQLAccess.storeUser(username, password);
				sendInt(con, UID);
			} catch (Exception e) {
			}
			break;
		case 37: 
			// TODO: error checking? Nah...
			String[] params1 = body.split("%");
			username = params1[0];
			password = params1[1];
			try {
				UID = MySQLAccess.login(username, password);
				sendInt(con, UID);
			} catch (Exception e) {
			}
			break;
		default:
			//TODO: unrecognized command. Error!
			break;
		}
	}

	/**
	 * actually send the message to the server
	 * 
	 * @param message
	 */
	public static void sendInt(Connection con, String message) {
		// TODO: how do you choose who to send to?
		long messageInt = Long.valueOf(message);
		Packet0006Long mp = new Packet0006Long();
		mp.message = messageInt;
		con.sendTCP(mp);
		System.out.println("Int sent: " + messageInt);
	}
	
	public static void sendString(Connection con, String message) {
		// TODO: how do you choose who to send to?
		char[] messageChar = message.toCharArray();
		Packet0007String mp = new Packet0007String();
		mp.message = messageChar;
		System.out.println("String almost sent: " + message);
		con.sendTCP(mp);
		System.out.println("String sent: " + message);
	}
}
