package database;

import java.io.IOException;
import java.util.LinkedList;

import networking.packets.Packet0006Long;
import networking.packets.Packet0007String;

import com.esotericsoftware.kryo.Kryo;
import com.esotericsoftware.kryonet.Connection;
import com.esotericsoftware.kryonet.Server;
import com.example.lctnetworktesting.networking.packets.Packet0000LogInfo;
import com.example.lctnetworktesting.networking.packets.Packet0001LogInAccepted;
import com.example.lctnetworktesting.networking.packets.Packet0002Message;
import com.example.lctnetworktesting.networking.packets.Packet0003SyncReq;
import com.example.lctnetworktesting.networking.packets.Packet0004Ack;
import com.example.lctnetworktesting.networking.packets.Packet0005Number;

public class DBServer {
	private Server server;
	public LinkedList<Connection> cList;
	public LinkedList<Connection> cList2;
	private int count;

	public DBServer() throws IOException {
		server = new Server();

		cList = new LinkedList<Connection>();
		cList2 = new LinkedList<Connection>();
		count = 0;
		registerPackets();
		// TODO
		DBListenerS l = new DBListenerS(this);
		server.addListener(l);
		server.bind(1111);
		server.start();
	}

	private void registerPackets() {
		Kryo kryo = server.getKryo();
		kryo.register(Packet0000LogInfo.class);
		kryo.register(Packet0001LogInAccepted.class);
		kryo.register(Packet0002Message.class);
		kryo.register(Packet0003SyncReq.class);
		kryo.register(Packet0004Ack.class);
		kryo.register(Packet0005Number.class);
		kryo.register(Packet0006Long.class);
		kryo.register(Packet0007String.class);
		kryo.register(char[].class);
	}

	public void broadcastOnce() {
		for (Connection c : cList) {
			Packet0002Message p = new Packet0002Message();
			p.message = "Two Person Play! Size is " + cList.size();
			c.sendTCP(p);
		}
		cList.clear();
		count = 0;
	}

	public void broadcastAgain() {
		Packet0002Message p = new Packet0002Message();
		p.message = "Two Person Play! Size is " + cList.size();
		server.sendToAllTCP(p);
	}

	public int getCount() {
		return count;
	}

	public void setCount(int count) {
		this.count = count;
	}

	public static void main(String [] args){
		
		try {
			new DBServer();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

	}
}
