package lanceGameRoomNetworking;

import lanceGameRoomNetworking.packets.GameRoomInfo;

public class GameRoom {
	private int[] userSpace;
	private int numOfPlayers;
	private int gameroomid;
	private int gameId;
	
	public GameRoom(int gameroomid, int gameId, int numOfPlayers) {
		this.userSpace = new int[numOfPlayers];
		resetGameRoom();
		this.setNumOfPlayers(numOfPlayers);
		this.setGameId(gameId);
		this.setGameroomid(gameroomid);
	}
	
	public GameRoomInfo getInfo(){
		GameRoomInfo result = new GameRoomInfo();
		
		result.userIds = userSpace;
		result.gameId = gameId;
		result.roomId = gameroomid;
		
		return result;
	}

	private void resetGameRoom() {
		for (int i = 0; i < numOfPlayers; i++){
			userSpace[i] = -1;
		}
	}

	public void start(){
		if (getExistingPlayers() > 0){
			//TODO Tell server to start the game
		}
	}
	
	public void addUser(int uid){
		for (int i = 0; i < numOfPlayers; i++){
			if (userSpace[i] == -1){
				userSpace[i] = uid;
				return;
			}
		}
		System.out.println("Room is full");
	}
	
	public void deleteUser(int uid){
		for (int i = 0; i < numOfPlayers; i++){
			if (userSpace[i] == uid){
				userSpace[i] = -1;
			}
		}
	}

	public int[] getUserSpace() {
		return userSpace;
	}

	public void setUserSpace(int[] userSpace) {
		this.userSpace = userSpace;
	}

	public int getNumOfPlayers() {
		return numOfPlayers;
	}

	public void setNumOfPlayers(int numOfPlayers) {
		this.numOfPlayers = numOfPlayers;
	}

	public int getExistingPlayers() {
		int result = 0;
		for (int i: userSpace){
			if (i!= -1){
				result++;
			}
		}
		return result;
	}

	public int getGameId() {
		return gameId;
	}

	public void setGameId(int gameId) {
		this.gameId = gameId;
	}

	public int getGameroomid() {
		return gameroomid;
	}

	public void setGameroomid(int gameroomid) {
		this.gameroomid = gameroomid;
	}
	
	@Override
	public int hashCode() {
		return gameroomid;
	}
}
