package lanceGameRoomNetworking;


import java.io.IOException;
import java.util.Scanner;

import lanceGameRoomNetworking.packets.GameLogInRequest;
import lanceGameRoomNetworking.packets.GameRoomExitRequest;
import lanceGameRoomNetworking.packets.GameRoomInfo;
import lanceGameRoomNetworking.packets.GameRoomStartRequest;
import lanceGameRoomNetworking.packets.GameStartRequest;
import lanceGameRoomNetworking.packets.GameUpdateRequest;
import lanceGameRoomNetworking.packets.TrainLogInRequest;
import lanceGameRoomNetworking.packets.TrainRoomInfo;
import lanceGameRoomNetworking.packets.TrainUpdateRequest;

import networking.packets.*;


import com.esotericsoftware.kryo.Kryo;
import com.esotericsoftware.kryonet.Client;
import com.esotericsoftware.minlog.Log;
import com.example.traingame.LanceTrainRoomActivity;

public class RoomClient {
	public Client client;
	public static Scanner scanner;
	private LanceTrainRoomActivity tra;

	public RoomClient(LanceTrainRoomActivity trainRoomActivity) {
		// TODO Auto-generated constructor stub
		tra = trainRoomActivity;
		
		scanner = new Scanner(System.in);
		client = new Client();
		register();
		
		RoomListenerC l = new RoomListenerC();
		l.init(this);
		client.addListener(l);
		
		client.start();
		
		try {
			System.out.println("ip?");
			client.connect(5000, "133.1.177.132", 23333);
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			client.stop();
		}
	}

	private void register() {
		Kryo kryo = client.getKryo();
		kryo.register(GameLogInRequest.class);
		kryo.register(GameRoomExitRequest.class);
		kryo.register(GameRoomInfo.class);
		kryo.register(GameRoomStartRequest.class);
		kryo.register(GameUpdateRequest.class);
		kryo.register(TrainLogInRequest.class);
		kryo.register(TrainRoomInfo.class);
		kryo.register(TrainUpdateRequest.class);
		kryo.register(GameStartRequest.class);
		kryo.register(char[].class);
		kryo.register(int[].class);
	}
	
	public void pauseClient(){
		client.stop();
	}
	public void reconnect(){
		try {
			client.reconnect();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

	public LanceTrainRoomActivity getTra() {
		return tra;
	}

	public void setTra(LanceTrainRoomActivity tra) {
		this.tra = tra;
	}
	
	
}
