package lanceGameRoomNetworking;
import java.util.LinkedList;

import lanceGameRoomNetworking.packets.*;

import networking.packets.*;

import com.esotericsoftware.kryonet.Connection;
import com.esotericsoftware.kryonet.Listener;

public class RoomListenerS extends Listener {
	private RoomServer server;
	
	public RoomListenerS(RoomServer server){
		this.server = server;
	}
	
	public void connected(Connection arg0){
		// DO SOMETHING
		System.out.println("AAAA-S");
	}
	
	public void disconnected(Connection arg0){
		// DO SOMETHING
		System.out.println("BBBB-S");
	}
	
	public void received(Connection arg0, Object arg1){
		// DO SOMETHING
		System.out.println("CCCC-S");
		if (arg1 instanceof GameLogInRequest){
			// If the game room is -1, Create a new gameroom
			// Else, check the existance of the game room.
			// If exist, return the game room info to the client
			
			GameLogInRequest packet = (GameLogInRequest) arg1;
			int gameroomid = -1;
			
			if (packet.gameroomid == -1){
				gameroomid = server.getTrainworld().retrieveTrainRoom(packet.trainid).host(packet.gameid);
			} else {
				gameroomid = packet.gameroomid;
			}
			server.getTrainworld().retrieveTrainRoom(packet.trainid).getGameRoom(gameroomid).addUser(packet.userid);
			arg0.sendTCP(server.getTrainworld().retrieveTrainRoom(packet.trainid).getGameRoom(gameroomid).getInfo());
			
		} else if (arg1 instanceof GameRoomExitRequest){
			// Tell back the player to exit the game
			// And delete this user from the list
			GameRoomExitRequest packet = (GameRoomExitRequest) arg1;
			
			if (server.getTrainworld().retrieveTrainRoom(packet.trainid).getGameRoom(packet.gameroomid) != null){
				server.getTrainworld().retrieveTrainRoom(packet.trainid).getGameRoom(packet.gameroomid).deleteUser(packet.uid);
			}
			
		} else if (arg1 instanceof GameRoomStartRequest){
			// Tell back the player to start the game
			// And delete this game room
			GameRoomStartRequest packet = (GameRoomStartRequest) arg1;
			
			if (!server.cList.containsKey(packet.gameroomid)){
				server.cList.put(packet.gameroomid, new LinkedList<Connection>());
			}
			
			server.setCount(server.getCount()+1);
			server.cList.get(packet.gameroomid).add(arg0);
			if (server.getCount() >= packet.numOfPlayers){
				server.broadcastOnce(packet.gameroomid, packet.trainid);
			}
			
		} else if (arg1 instanceof GameUpdateRequest){
			// Return the game room information
			// Act as an acknowledgment information
			GameUpdateRequest packet = (GameUpdateRequest) arg1;
			arg0.sendTCP(server.getTrainworld().retrieveTrainRoom(packet.trainid).getGameRoom(packet.roomid).getInfo());
		} else if (arg1 instanceof TrainLogInRequest){
			// If the train room exists, return the train room info
			// Else, create a new trainroom and return the message
			
			TrainLogInRequest packet = (TrainLogInRequest) arg1;
			arg0.sendTCP(server.getTrainworld().retrieveTrainRoom(packet.trainid).getInfo());
			
		} else if (arg1 instanceof TrainUpdateRequest){
			// Return the train room information
			// Act as an acknowledgement information
			
			TrainUpdateRequest packet = (TrainUpdateRequest) arg1;
			arg0.sendTCP(server.getTrainworld().retrieveTrainRoom(packet.trainId).getInfo());			
		}
	}
}
