package loadingscenes;

import org.andengine.engine.handler.timer.ITimerCallback;
import org.andengine.engine.handler.timer.TimerHandler;
import org.andengine.entity.scene.Scene;
import org.andengine.entity.scene.background.Background;
import org.andengine.entity.sprite.Sprite;
import org.andengine.opengl.texture.atlas.bitmap.BitmapTextureAtlas;
import org.andengine.opengl.texture.atlas.bitmap.BitmapTextureAtlasTextureRegionFactory;
import org.andengine.opengl.texture.region.ITextureRegion;

import com.example.traingame.SceneManager;
import com.example.traingame.Setup;

public class LCreatureSetup extends Setup {
	private BitmapTextureAtlas loadingTA;
	private ITextureRegion loadingTR;
	
	public LCreatureSetup(SceneManager SM){
		this.sm = SM;
	}

	@Override
	public void load(){
		BitmapTextureAtlasTextureRegionFactory.setAssetBasePath("gfx/creature/");
		loadingTA = new BitmapTextureAtlas(sm.activity.getTextureManager(),
				2048, 2048);
		loadingTR = BitmapTextureAtlasTextureRegionFactory.createFromAsset(
				loadingTA, sm.activity, "creature creator loading.png", 0, 0);
		loadingTA.load();
	}
	
	@Override
	public Scene create(){
		Scene loadingScene = new Scene();
		loadingScene.setBackground(new Background(0,0,0));
		
		Sprite sIcon = new Sprite(0,0,loadingTR,sm.engine.getVertexBufferObjectManager());
		sIcon.setScale(sm.camera.getWidth()/sIcon.getWidth(), sm.camera.getHeight()/sIcon.getHeight());
		sIcon.setPosition((sm.camera.getWidth() - sIcon.getWidth())/2, (sm.camera.getHeight() - sIcon.getHeight())/2);
		loadingScene.attachChild(sIcon);
		sm.engine.registerUpdateHandler(new TimerHandler(3f,new ITimerCallback(){
			public void onTimePassed(TimerHandler pTimerHandler){
				sm.engine.unregisterUpdateHandler(pTimerHandler);
				sm.setCurrentS(SceneManager.AllScenes.CREATURE);
			}
		})); 
		return loadingScene;
	}
}
