package loadingscenes;

import java.util.HashMap;

import org.andengine.entity.scene.Scene;
import org.andengine.entity.scene.background.Background;
import org.andengine.entity.sprite.Sprite;
import org.andengine.opengl.texture.atlas.bitmap.BitmapTextureAtlas;
import org.andengine.opengl.texture.atlas.bitmap.BitmapTextureAtlasTextureRegionFactory;
import org.andengine.opengl.texture.region.ITextureRegion;

import potatogame.PacketGStart;
import potatogame.PacketInt;
import potatogame.lPotatoClient;
import android.content.SharedPreferences;
import android.util.Log;

import com.example.traingame.SceneManager;
import com.example.traingame.Setup;


public class LPotatoSetup extends Setup {
	private BitmapTextureAtlas loadingTA;
	private ITextureRegion loadingTR;
	private int users = 0;
	private int waiting = 3;
	private int userNum = 0;
	private lPotatoClient pc;
	private int gameID = 42;
	private String uID;
	private String uName;
	private HashMap<Integer, char[]> hm = new HashMap<Integer, char[]>();
	
	public LPotatoSetup(SceneManager SM){
		this.sm = SM;
	}
	
	@Override
	public void load(){
		pc = new lPotatoClient(this);
		BitmapTextureAtlasTextureRegionFactory.setAssetBasePath("gfx/");
		loadingTA = new BitmapTextureAtlas(sm.activity.getTextureManager(),
				2048, 2048);
		loadingTR = BitmapTextureAtlasTextureRegionFactory.createFromAsset(
				loadingTA, sm.activity, "bomb pass loading.png", 0, 0);
		loadingTA.load();
	}
	
	@Override
	public Scene create(){
		getGameInfo();
		users = 0;
		Scene loadingScene = new Scene();
		loadingScene.setBackground(new Background(0,0,0));
		
		Sprite sIcon = new Sprite(0,0,loadingTR,sm.engine.getVertexBufferObjectManager());
		sIcon.setPosition((sm.camera.getWidth() - sIcon.getWidth())/2, (sm.camera.getHeight() - sIcon.getHeight())/2);
		sIcon.setScale(sm.camera.getWidth()/sIcon.getWidth(), sm.camera.getHeight()/sIcon.getHeight());
		loadingScene.attachChild(sIcon);
		PacketGStart pi = new PacketGStart();
		pi.i = 100;
		pi.i2 = gameID;
		Integer temp2 = Integer.parseInt(uID);
		pi.i3 = temp2.intValue();
		pi.i4 = waiting;
		pi.i5 = uName.toCharArray();
		pc.pclient.sendTCP(pi); 
		return loadingScene;
	}
	
	public void setSelfNum(int i){
		userNum = i;
		Log.i("RAWR1", "un: " + userNum);
	}

	
	public void getGameInfo(){
		SharedPreferences sp = sm.activity.getSharedPreferences("currentUser", 0);
		String un = sp.getString("username", "");
		String ui = sp.getString("uid", "");
		if (sm.activity.getIntent().getExtras() != null){	
			gameID = sm.activity.getIntent().getExtras().getInt("gameID");
			waiting = sm.activity.getIntent().getExtras().getInt("numPlayers");
		}
		uID = ui;
		uName = un;
	}
	
	public void start(){
		sm.setPotatoPlayers(waiting - 1,1, userNum);
		users = 0;
		PacketInt pi = new PacketInt();
		pi.i = 200;
		pc.pclient.sendTCP(pi);
		Integer t = Integer.parseInt(uID);
		sm.setPGameID(gameID, t);
		sm.setCurrentS(SceneManager.AllScenes.POTATO);
	}
	
	public void setHash(HashMap<Integer, char[]> h){
		hm = h;
		sm.setPHash(h);
		Log.i("HASH", "HASHMAP SET");
	}
}
