package loadingscenes;

import org.andengine.engine.handler.timer.ITimerCallback;
import org.andengine.engine.handler.timer.TimerHandler;
import org.andengine.entity.scene.Scene;
import org.andengine.entity.scene.background.Background;
import org.andengine.entity.sprite.Sprite;
import org.andengine.opengl.texture.atlas.bitmap.BitmapTextureAtlas;
import org.andengine.opengl.texture.atlas.bitmap.BitmapTextureAtlasTextureRegionFactory;
import org.andengine.opengl.texture.region.ITextureRegion;

import wizardgame.PacketInt;

import wizardgame.lWizardClient;

import android.content.SharedPreferences;
import android.util.Log;

import com.example.traingame.SceneManager;
import com.example.traingame.Setup;

public class LWizardSetup extends Setup {
	private BitmapTextureAtlas loadingTA;
	private ITextureRegion loadingTR;
	private lWizardClient wc;
	private int connected = 0;
	private int waiting = 1;
	private boolean turn = false;
	private boolean twoP = false;
	private boolean set =false;
	private int gameID = 42;
	private String uID;
	private String uName;
	
	public LWizardSetup(SceneManager SM){
		this.sm = SM;
	}
	
	@Override
	public void load(){
		wc = new lWizardClient(this);
		BitmapTextureAtlasTextureRegionFactory.setAssetBasePath("gfx/");
		loadingTA = new BitmapTextureAtlas(sm.activity.getTextureManager(),
				2048, 2048);
		loadingTR = BitmapTextureAtlasTextureRegionFactory.createFromAsset(
				loadingTA, sm.activity, "elemancer loading.png", 0, 0);
		loadingTA.load();
	}
	
	@Override
	public Scene create(){
		getGameInfo();
		Scene loadingScene = new Scene();
		loadingScene.setBackground(new Background(0,0,0));
		Sprite sIcon = new Sprite(0,0,loadingTR,sm.engine.getVertexBufferObjectManager());
		sIcon.setPosition((sm.camera.getWidth() - sIcon.getWidth())/2, (sm.camera.getHeight() - sIcon.getHeight())/2);
		sIcon.setScale(sm.camera.getWidth()/sIcon.getWidth(), sm.camera.getHeight()/sIcon.getHeight());
		loadingScene.attachChild(sIcon);
		PacketInt pi = new PacketInt();
		String temp = "1" + gameID;
		Integer temp2 = Integer.decode(temp);
		pi.i = temp2.intValue();
		wc.wclient.sendTCP(pi);
		
		sm.engine.registerUpdateHandler(new TimerHandler(1f,new ITimerCallback(){
			public void onTimePassed(TimerHandler pTimerHandler){
				if(connected >= waiting  && set){
					set = false;
					connected = 0;
					sm.engine.unregisterUpdateHandler(pTimerHandler);
					sm.setWizardPlayers(twoP, turn,gameID);
					sm.setCurrentS(SceneManager.AllScenes.WIZARD);
				}
				else{
					pTimerHandler.reset();
				}
			}
		})); 
		return loadingScene;
	}
	
	public void setTurn(boolean pt){
		set = true;
		turn = pt;
	}
	
	public void addConnect(int c){
		connected = c;
	}
	
	public void getGameInfo(){
		SharedPreferences sp = sm.activity.getSharedPreferences("currentUser", 0);
		String un = sp.getString("username", "");
		String ui = sp.getString("uid", "");
		if (sm.activity.getIntent().getExtras() != null){	
			gameID = sm.activity.getIntent().getExtras().getInt("gameID");
			waiting = sm.activity.getIntent().getExtras().getInt("numPlayers");
		}
		uID = ui;
		uName = un;
		if(waiting == 2){
			twoP = true;
		}
		else{
			twoP = false;
		}
		//twoP = false;
		//waiting = 1;
	}
}
