package loadingscenes;

import org.andengine.entity.scene.Scene;
import org.andengine.entity.scene.background.Background;
import org.andengine.entity.sprite.Sprite;
import org.andengine.opengl.texture.atlas.bitmap.BitmapTextureAtlas;
import org.andengine.opengl.texture.atlas.bitmap.BitmapTextureAtlasTextureRegionFactory;
import org.andengine.opengl.texture.region.ITextureRegion;
import com.example.traingame.*;

import com.example.traingame.Setup;

public class splashSetup extends Setup{

	private BitmapTextureAtlas splashTA;
	private ITextureRegion splashTR;

	public splashSetup(SceneManager SM){
		this.sm = SM;
	}
	
	@Override
	public void load(){
		BitmapTextureAtlasTextureRegionFactory.setAssetBasePath("gfx/");
		splashTA = new BitmapTextureAtlas(sm.activity.getTextureManager(),
				512, 512);
		splashTR = BitmapTextureAtlasTextureRegionFactory.createFromAsset(
				splashTA, sm.activity, "loading.jpg", 0, 0);
		splashTA.load();
	}
	
	@Override
	public Scene create(){
		Scene splashScene = new Scene();
		splashScene.setBackground(new Background(0,0,0));
		
		Sprite sIcon = new Sprite(0,0,splashTR,sm.engine.getVertexBufferObjectManager());
		sIcon.setPosition((sm.camera.getWidth() - sIcon.getWidth())/2, (sm.camera.getHeight() - sIcon.getHeight())/2);
		splashScene.attachChild(sIcon);
		return splashScene;
	}
}
