package mainmenu;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.LinkedList;

import viewUsers.OtherUser;
import viewUsers.ViewUsersActivity;


import mainmenu.networking.Game;
import mainmenu.networking.GameData;
import mainmenu.networking.GameJoinClient;
import android.app.Activity;
import android.content.Intent;
import android.content.SharedPreferences;
import android.os.AsyncTask;
import android.os.Bundle;
import android.util.Log;
import android.view.Menu;
import android.view.View;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.ListView;
import android.widget.TextView;
import android.widget.Toast;

import com.example.traingame.ChatActivity;
import com.example.traingame.LanceTrainRoomActivity;
import com.example.traingame.MainActivity;
import com.example.traingame.ProfileActivity;
import com.example.traingame.R;

import database.DBProtocolC;

public class MainMenuActivity extends Activity {
	private static GameJoinClient client;
	private static boolean hosting = false;
	private static boolean ready = false;
	private static LinkedList<Integer> gameIDs = new LinkedList<Integer>();	
	private static LinkedList<Integer> UIDs = new LinkedList<Integer>();	
	private static ArrayAdapter<String> adapter;
	private static Integer readyGameID = -1;
	private static HashMap<Integer, OtherUser> users = new HashMap<Integer, OtherUser>();
	private static ListView listview;
	private static String trainRoom = "loading";
	String[] userArray;
	String gameName;
	private static String readyGameString;

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		Log.d("testing", "ENTERING ONCREATE");
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_mainmenu);		
		
		//create gamejoin client and join train room
		if (client == null) {
			Log.d("testing", "making client");
			
			if (getIntent().getExtras() != null) { 
				Log.d("gjs", "TRAINROOM INTENT FOUND");
				trainRoom = getIntent().getExtras().getString("trainRoom");
			}
			else {
				trainRoom = "Default";
			}
			Log.d("gjs", "SENDING TRAIN ROOM " + trainRoom);
			
			new clientCreationTask().execute(this);
			try {
				Thread.sleep(1000);
			} catch (InterruptedException e) {				
			}
		}
		Log.d("testing", "ready bool is " + ready);		
		
		//set up train room text
		TextView trainRoomView = (TextView) findViewById(R.id.main_view_users);
		trainRoomView.setText("View users in room: " + trainRoom);
		
		//Handle Intents
		if (getIntent().getExtras() != null) {
			Integer gameNameID = getIntent().getExtras().getInt("hostGame");
			boolean readyIntent = getIntent().getExtras().getBoolean("ready");
			boolean leavingIntent = getIntent().getExtras().getBoolean("leaving");
			Log.d("testing", "gnID = " + gameNameID);
			if (gameNameID != 0) {				
				new gameCreationTask().execute(gameNameID);
				Log.d("testing", "hostnewgame sent");				
			}
			if (readyIntent && ready == false) {				
				Log.d("testing", "joining game " + readyGameID);
				new joinGameTask().execute(readyGameID);												
			}
			if (leavingIntent) {
				Log.d("testing", "leavingintent");
				if (ready) {
					Log.d("testing", "leaving game " + readyGameID);
					new leaveGameTask().execute(readyGameID);	
				}
				ready = false;
			}
		}		
		Log.d("testing", "onCreate readyGameID = " + readyGameID);
		
		//Get games
		new getGamesTask().execute(this);				
	}

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		// Inflate the menu; this adds items to the action bar if it is present.
		getMenuInflater().inflate(R.menu.main, menu);
		return true;
	}
	
	public void playGame(int gameID, int gameNameID, int numPlayers) {
		if (gameNameID != 5) { 
			ready = false;
			hosting = false;
			readyGameID = -1;
			Log.d("user", "ADDING PLAYS FOR GAMEID " + gameNameID);
			//add plays for other users
			new addPlaysTask().execute(gameID);			
		}
		Intent intent = new Intent(this, MainActivity.class);
		intent.putExtra("gameID", gameID);
		intent.putExtra("gameNameID", gameNameID);
		intent.putExtra("numPlayers", numPlayers);
		startActivity(intent);		
	}
	
	public void switchToProfile(View view) {
	    Intent intent = new Intent(this, ProfileActivity.class);
	    startActivityForResult(intent, 1);
	}
	
	public void switchToChat(View view) {
	    Intent intent = new Intent(this, ChatActivity.class);	    
	    startActivityForResult(intent, 1);
	}
	
	public void switchToViewUsers(View view) {
		new getUsersTask().execute();
		Intent intent = new Intent(this, ViewUsersActivity.class);	
		intent.putExtra("trainRoom", trainRoom);
	    startActivityForResult(intent, 1);
	}
	
	public void switchToViewUsers() {		
		int[] UIDIntent = new int[UIDs.size()];
		for (int i = 0; i < UIDs.size(); i++) {
			UIDIntent[i] = (int)UIDs.get(i);
			Log.d("users", "passing from Menu: " + UIDs.get(i));
		}
		Intent intent = new Intent(this, ViewUsersActivity.class);	
		intent.putExtra("trainRoom", trainRoom);
		intent.putExtra("UIDs", UIDIntent); //TODO: test is this works
		intent.putExtra("myUID", client.gjpc.getMyUID());
	    startActivityForResult(intent, 1);
	}
	
	public void switchToTrain(View view) {
	    playGame(0, 5, 1);
	}
	
	public void switchToBPP(View view) {
	    playGame(0, 1, 4);
	}
	
	public void switchToE(View view) {
	    playGame(0, 2, 2);
	}
	
	public void switchToCC(View view) {
	    playGame(0, 3, 3);
	}
	
	public void switchToTT(View view) {
	    playGame(0, 4, 4);
	}
	
	/**
	 * Three functions:
	 * 1. Host a new game
	 * 2. View the game you're hosting
	 * 3. Start the game if enough players are ready
	 * @param view
	 */
	public void switchToHost(View view) {		
		if (hosting) {
			int gameReady = GameJoinClient.games.get(readyGameID).timer;
			if (gameReady ==0) { //0 = ready, 1 = not ready)
				new startGameTask().execute();
				client.activity.runOnUiThread(new Runnable() {			
					@Override
					public void run() {	
						Toast.makeText(getApplicationContext(), "Game started!", Toast.LENGTH_SHORT).show();
					}
				});	
			}
			else {
				Log.d("testing", "switch to host gameID = " + readyGameID);
				switchToReadyActivity(readyGameID);	
			}
		}
		else {
			Intent intent = new Intent(this, HostActivity.class);	
			startActivityForResult(intent, 1);
		}
	}
	
	public void joinRandomGame(View view) {
		if (gameIDs.isEmpty()) {
			Log.d("testing", "joinRandomGame no gameIDs found");			
		}
		else {			
			Integer gameID = gameIDs.get(0);
			Log.d("testing", "joinRandomGame readyActivity for " + gameID);
			switchToReadyActivity(gameID);
		}
	}
	
	public void switchToReadyActivity(Integer gameID) {
		Game game = client.games.get(gameID);
		if (game == null) {
			Log.d("testing", "game not found in hashmap. ID = " + gameID);
		}
	    gameName = client.gameData.get(game.gameNameID).name;
	    Log.d("testing", "gameName" + gameName);
	    LinkedList<Integer> users = game.userList;
	    users.add(0, game.host);
	    Integer[] UIDs = users.toArray(new Integer[users.size()]);
	    new getUsernameTask().execute(UIDs);
	    try { //wait for users to come in
			Thread.sleep(500);
		} catch (InterruptedException e) {				
		}
	    readyIntent();
	}
	
	public void readyIntent() {
		Intent intent = new Intent(this, ReadyActivity.class);		    
	    intent.putExtra("usernames", userArray);
	    intent.putExtra("gameName", gameName);
	    startActivityForResult(intent, 1);
	}
	
	public void updateGames() {
		this.runOnUiThread(new Runnable() {			
			@Override
			public void run() {	
				Log.d("gjs", "UPDATE GAMES CALLED");
				LinkedList<Integer> gameOrder = new LinkedList<Integer>();
				adapter.clear();				
				gameOrder.clear();				
				ArrayList<String> gameInfoStrings = new ArrayList<String>();
				for (Game game : MainMenuActivity.this.client.games.values()) {					
					if (gameOrder.contains(game.gameID)) {
						Log.d("gjs", "gameOrder already has gameID");
						continue;
					}
					GameData gameData = client.gameData.get(game.gameNameID);
					String gameInfoString;
					if (gameData.minPlayers == gameData.maxPlayers) {
						gameInfoString = "#" + game.gameID + "    " + gameData.name + " (" + gameData.minPlayers + "player) " + (game.userList.size() + 1) + " Ready";
					}
					else {
						gameInfoString = "#" + game.gameID + "    " + gameData.name + " (" + gameData.minPlayers + 
								"-" + gameData.maxPlayers + " player) " + (game.userList.size() + 1) + " Ready";
					}
					if (!gameInfoStrings.contains(gameInfoString)) {
						gameInfoStrings.add(gameInfoString);
					}
					Log.d("gjs", "num game strings after adding = " + gameInfoStrings.size());
					Log.d("gjs", "game string = " + gameInfoString);
					gameOrder.add(game.gameID);
					if (game.host == client.gjpc.getMyUID()) {
						readyGameID = game.gameID;
						readyGameString = gameInfoString;
						TextView hostGameView = (TextView) findViewById(R.id.main_host_game);
						if (game.timer == 0) { //0 = ready, 1 = not ready
							hostGameView.setText("START NOW (auto-start 20s): " + readyGameString);
						}
						else {
							hostGameView.setText("Hosting: " + readyGameString);
						}
					}
				}				
				MainMenuActivity.gameIDs = gameOrder;				
				adapter.addAll(gameInfoStrings);								
				adapter.notifyDataSetChanged();	
				Log.d("gjs", "adapter size is " + adapter.getCount());
				if (adapter.getCount() == 0) {
					TextView joinGameView = (TextView) findViewById(R.id.main_join_game);
					joinGameView.setText("No games yet. Start one!");
				}				
			}
		});
		
	}

	
	private class clientCreationTask extends AsyncTask<MainMenuActivity, Void, Void>{

		@Override
		protected Void doInBackground(MainMenuActivity... params) {			
			client =  new GameJoinClient(params[0]);			
			client.gjpc.joinTrainRoom(trainRoom);
			return null;
		}
	}
	
	private class gameCreationTask extends AsyncTask<Integer, Void, Void>{		
		
		@Override
		protected Void doInBackground(Integer... params) {			
			hosting = true;
			ready = true;
			client.gjpc.hostNewGame(params[0]);			
			return null;
		}
	}	

	private class getGamesTask extends AsyncTask<MainMenuActivity, Void, Void>{		
		
		@Override
		protected Void doInBackground(MainMenuActivity... params) {			
			final MainMenuActivity activity = params[0];					
			activity.runOnUiThread(new Runnable() {			
				@Override
				public void run() {					
					listview = (ListView) findViewById(R.id.main_listview);					
					adapter = new ArrayAdapter<String>(activity, R.layout.list_game, new ArrayList<String>());
					listview.setAdapter(adapter);	
				    listview.setClickable(true);
				    listview.setOnItemClickListener(new AdapterView.OnItemClickListener() {
				    	  @Override
				    	  public void onItemClick(AdapterView<?> arg0, final View arg1, int position, long id) {
				    		  Log.d("testing", "list item clicked! pos " + position);
				    		  if (position < gameIDs.size()) {
					    		  Integer gameID = gameIDs.get(position);
					    		  readyGameID = gameID;	    		  
					    		  switchToReadyActivity(gameID);
				    		  }
				    		  else {
				    			  Toast.makeText(getApplicationContext(), "Sorry, bug. Click another game.", Toast.LENGTH_SHORT).show();
				    		  }
				    	  }
			    	});				    
				}
			});
			client.gjpc.getGames();	
			return null;
		}
	}
	
	private class joinGameTask extends AsyncTask<Integer, Void, Void>{		
			
			@Override
			protected Void doInBackground(Integer... params) {
				Log.d("testing", "readygameid = " + params[0]);				
				client.gjpc.joinGame(params[0]);				
				ready = true;
				return null;
			}		
	}	

	private class leaveGameTask extends AsyncTask<Integer, Void, Void>{		
		
		@Override
		protected Void doInBackground(Integer... params) {			
			client.gjpc.leaveGame(params[0]);			
			return null;
		}		
	}
	
	private class startGameTask extends AsyncTask<Void, Void, Void>{		
		@Override
		protected Void doInBackground(Void... params) {
			Log.d("gjs", "sending starting game " + readyGameID);				
			client.gjpc.hostStartsGame(readyGameID);			
			return null;
		}
	}	

	private class getUsernameTask extends AsyncTask<Integer, Void, Void>{
		@Override
		protected Void doInBackground(Integer... params) {			
			DBProtocolC.connectToDB();
			LinkedList<String> userStrings = new LinkedList<String>();	
			String username;
			for (Integer UID : params) {
  			  if (!users.containsKey(UID)) {
  				username = DBProtocolC.getUsername(UID);
  				String playcount = DBProtocolC.getPlays(UID, client.gjpc.getMyUID());
  				users.put(UID, new OtherUser(UID, username, playcount));
  			  }
  			  else {
  				username = users.get(UID).getUsername();
  			  }
  			 userStrings.add(username);
			}
			DBProtocolC.close();
		    userArray = userStrings.toArray(new String[userStrings.size()]);
		    Log.d("ready", "user array len " + userArray.length);
		    Log.d("ready", "user array value " + userArray[0]);		    
			return null;
		}
	}
	
	private class getUsersTask extends AsyncTask<Void, Void, Void>{

		@Override
		protected Void doInBackground(Void... params) {			
			UIDs = null;
			client.gjpc.getTrainRoomUsers(trainRoom);
			while (UIDs == null) {
				try {
					Thread.sleep(100);
				} catch (InterruptedException e) {					
					e.printStackTrace();
				}
			}
			switchToViewUsers();
			return null;
		}
	}
	
	private class addPlaysTask extends AsyncTask<Integer, Void, Void>{		
		@Override
		protected Void doInBackground(Integer... params) {
			Integer gameID = params[0];
			Game game = client.games.get(gameID);
			LinkedList<Integer> gameUIDs = game.userList;
			gameUIDs.add(game.host);
			Integer myUID = client.gjpc.getMyUID();
			DBProtocolC.connectToDB();
			for (Integer UID : gameUIDs) {
				if (UID == myUID) {
					continue;
				}
				DBProtocolC.updatePlays(String.format("%04d", UID), String.format("%04d", myUID));
			}
			DBProtocolC.close();
			return null;
		}
	}
	
	public SharedPreferences getSharedPrefs() {
		return this.getSharedPreferences("currentUser", 0);
	}
	
	@Override
	protected void onActivityResult(int requestCode, int resultCode, Intent data) 
	{
	     super.onActivityResult(requestCode, resultCode, data);
	     //matches the result code passed from ChildActivity
	     if(resultCode == 1) 
	     {
	    	 Log.i("TrainRoom","Should stop something");
	         MainMenuActivity.this.finish();
	     }
	}
	
	public String createGameString(Game game) {
		return null;
	}

	public void leaveGameCompleteOrJoinGameFailure() {
		readyGameID = -1;
		ready = false;
		hosting = false;
	}

	public static HashMap<Integer, OtherUser> getUsers() {
		return users;
	}
	
	/**
	 * @param users the users to set
	 */
	public static void setUsers(HashMap<Integer, OtherUser> users) {
		MainMenuActivity.users = users;
	}
	
	/**
	 * @param uIDs the uIDs to set
	 */
	public static void setUIDs(LinkedList<Integer> uIDs) {
		UIDs = uIDs;
	}
	
	public static void changeTrainRoom() {
		hosting = false;
		ready = false;
		readyGameID = -1;
		client.client.stop();
		client = null;
	}
}
