package mainmenu.networking;

import java.util.LinkedList;

public class Game {
	public int gameID;	
	public int gameNameID;
	public LinkedList<Integer> userList = new LinkedList<Integer>(); //list of UIDs of ready players, not host
	public int timer;
	public int host;
	public String trainRoom;	
	
	//for server
	public Game(int gameID, int gameNameID, int host, String trainRoom) {
		this.gameID = gameID;
		this.gameNameID = gameNameID;		
		this.host = host;
		this.timer = -1;
		this.trainRoom = trainRoom;
	}
	
	//for client
	public Game(int gameID, int gameNameID, int timer, int host, LinkedList<Integer> users) {
		this.gameID = gameID;
		this.gameNameID = gameNameID;		
		this.host = host;
		this.timer = timer;
		this.host = host;
		this.userList = users;
	}
	
	public LinkedList<Integer> toLinkedList() {
		LinkedList<Integer> thisGame = new LinkedList<Integer>();
		thisGame.add(this.gameID);
		thisGame.add(this.gameNameID);
		if (this.timer == -1) { //is the game ready to play?
			thisGame.add(0); //0 = ready, 1 = not ready
		} else {
			thisGame.add(1);		
		}
		thisGame.add(this.host);
		for (Integer user : this.userList) {
			thisGame.add(user);
		}
		return thisGame;
	}
	
}
