package mainmenu.networking;

import java.io.IOException;
import java.util.HashMap;
import java.util.LinkedList;
import java.util.Scanner;

import mainmenu.MainMenuActivity;
import networking.packets.Packet0006Long;
import networking.packets.Packet0007String;
import networking.packets.Packet0008Games;
import android.util.Log;

import com.esotericsoftware.kryo.Kryo;
import com.esotericsoftware.kryonet.Client;
import com.example.lctnetworktesting.networking.packets.Packet0000LogInfo;
import com.example.lctnetworktesting.networking.packets.Packet0001LogInAccepted;
import com.example.lctnetworktesting.networking.packets.Packet0002Message;
import com.example.lctnetworktesting.networking.packets.Packet0003SyncReq;
import com.example.lctnetworktesting.networking.packets.Packet0004Ack;
import com.example.lctnetworktesting.networking.packets.Packet0005Number;

public class GameJoinClient {
	public Client client;
	public static Scanner scanner;
	public static HashMap<Integer, Game> games = new HashMap<Integer, Game>();	
	public HashMap<Integer, GameData> gameData = new HashMap<Integer, GameData>();
	static HashMap<Integer, String> usernames; //uid, username
	public GameJoinProtocolC gjpc;
	public MainMenuActivity activity;
		
	public GameJoinClient(MainMenuActivity activity){
		this.activity = activity;
		scanner = new Scanner(System.in);
		client = new Client();		
		register();		
		
		GameJoinListenerC l = new GameJoinListenerC();
		l.init(this);
		client.addListener(l);
		
		client.start();
		
		try {
			//System.out.println("ip?");
			client.connect(6000, "traingame.cs.wpi.edu", 9001);
		} catch (IOException e) {			
			e.printStackTrace();
			client.stop();
		}
		
		gameData.put(1, new GameData("Bomb Pass Panic", 4, 6));
		gameData.put(2, new GameData("Elemancer", 1, 2));
		gameData.put(3, new GameData("Creature Creator", 3, 3));
		gameData.put(4, new GameData("Treasure Trap", 4, 4));
		
		Log.i("Debug","HEEEEEEEEEEEERE");
		gjpc = new GameJoinProtocolC(this);
	}

	private void register() {
		Kryo kryo = client.getKryo();
		kryo.register(Packet0000LogInfo.class);
		kryo.register(Packet0001LogInAccepted.class);
		kryo.register(Packet0002Message.class);
		kryo.register(Packet0003SyncReq.class);
		kryo.register(Packet0004Ack.class);
		kryo.register(Packet0005Number.class);
		kryo.register(Packet0006Long.class);
		kryo.register(Packet0007String.class);
		kryo.register(char[].class);
		kryo.register(LinkedList.class);
		kryo.register(Packet0008Games.class);
	}

	public void sendMessage(String message){
		Packet0002Message mp = new Packet0002Message();
		mp.message = message;
		client.sendTCP(mp);
	}
	
	/**
	 * the server tells the client it's time to start a game!
	 * @param gameID 
	 */
	public void startGame(int gameID) {		
		Game game = games.get(gameID);
		int gameNameID = game.gameNameID;
		int UID = gjpc.getMyUID();
		Integer numPlayers = game.userList.size() + 1;
		activity.playGame(gameID, gameNameID, numPlayers);
	}
	
	/**
	 * the server tells the client to remove a game
	 */
	public void removeGame(int gameID) {
		games.remove(gameID);
		Log.d("gjs", "size of games hashmap is " + games.size());
		activity.updateGames();
	}
	
}
