package mainmenu.networking;

import java.util.LinkedList;

import networking.packets.Packet0006Long;
import networking.packets.Packet0007String;
import networking.packets.Packet0008Games;
import android.util.Log;

import com.esotericsoftware.kryonet.Connection;
import com.esotericsoftware.kryonet.Listener;
import com.example.lctnetworktesting.networking.packets.Packet0000LogInfo;
import com.example.lctnetworktesting.networking.packets.Packet0001LogInAccepted;
import com.example.lctnetworktesting.networking.packets.Packet0002Message;
import com.example.lctnetworktesting.networking.packets.Packet0004Ack;
import com.example.lctnetworktesting.networking.packets.Packet0005Number;

public class GameJoinListenerC extends Listener {
	private GameJoinClient client;
	private static long receivedInt = -1;
	private static String receivedString = null;

	public void connected(Connection arg0) {
		// DO SOMETHING
		Log.i("Clinet", "Connected with server!" + arg0.toString());
		client.client.sendTCP(new Packet0000LogInfo());
	}

	public void disconnected(Connection arg0) {
		// DO SOMETHING
		Log.i("Client", "Disconnect from server");
	}

	public void received(Connection arg0, Object arg1) {
		// DO SOMETHING
		Log.i("Client", "Received something frmo the server");
		if (arg1 instanceof Packet0001LogInAccepted) {
			boolean answer = ((Packet0001LogInAccepted) arg1).accepted;

			// TODO Something to be finished

			if (answer == true) {
				client.client.sendTCP(new Packet0004Ack());
			} else {
				client.client.close();
			}
		}
		if (arg1 instanceof Packet0002Message) {
			String message = ((Packet0002Message) arg1).message;
			Log.i("Client", "The message is: " + message);
		}		
		if (arg1 instanceof Packet0005Number) {
			int id = ((Packet0005Number) arg1).id;
			int value = ((Packet0005Number) arg1).value;
			Log.i("Client", "The number is: " + id + " " + value);			
		}
		if (arg1 instanceof Packet0004Ack) {
			Log.i("Client", "Ack Received!");

			boolean connecting = ((Packet0004Ack) arg1).connecting;

			if (connecting) {
				SThread st = new SThread();
				st.start();
			}
		}
		if (arg1 instanceof Packet0006Long) {			
			long message = ((Packet0006Long) arg1).message;
			//set var in db class
			receivedInt = message;
			Log.i("Client", "Int Received to DBLC! " + message);
		}
		if (arg1 instanceof Packet0007String) {			
			char[] messageChar = ((Packet0007String) arg1).message;
			String message = new String(messageChar);
			//set var in db class
			receivedString = message;
			Log.i("Client", "String Received to DBLC! " + message);
		}
		if (arg1 instanceof Packet0008Games) {			
			LinkedList<LinkedList<Integer>> messageGame = ((Packet0008Games) arg1).games;
			Log.d("gjs", "LISTENER: game received, id = " + messageGame.get(0).get(0));
			client.gjpc.handleRecievedGame(messageGame);
		}
	}

	public void init(GameJoinClient client) {
		this.client = client;
	}

	/*
	 * private void enterMessage(){ Log.i("Client", "Say something!");
	 * 
	 * while(true) { if (LCTClient.scanner.hasNext()){ Packet0002Message mp =
	 * new Packet0002Message(); mp.message = LCTClient.scanner.nextLine(); if
	 * (mp.message.equals("Sync")){ client.sendTCP(new Packet0003SyncReq());
	 * break; } client.sendTCP(mp); Log.i("Client", "Say something more!"); } }
	 * }
	 */

	public class SThread extends Thread {
		@Override
		public void run() {
			// TODO Auto-generated method stub
			try {
				Thread.sleep(1000);
			} catch (InterruptedException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}

			client.client.sendTCP(new Packet0004Ack());
			Log.i("Client", "Ack sent!");
		}

	}
	
	/**
	 * Return int value from server
	 * Return -1 if value has not been obtained
	 * @return
	 */
	public static long getReceivedInt(){
		long message = receivedInt;		
		receivedInt = -1;
		return message;
	}

	/**
	 * Return String val from server
	 * @return
	 */
	public static String getReceivedString() {
		String message = receivedString;		
		receivedString = null;
		return message;
	}
}
