package mainmenu.networking;

import java.util.LinkedList;
import java.util.Map;

import networking.packets.Packet0007String;
import networking.packets.Packet0008Games;

import com.esotericsoftware.kryonet.Connection;
import com.esotericsoftware.kryonet.Listener;
import com.example.lctnetworktesting.networking.packets.Packet0000LogInfo;
import com.example.lctnetworktesting.networking.packets.Packet0001LogInAccepted;
import com.example.lctnetworktesting.networking.packets.Packet0002Message;
import com.example.lctnetworktesting.networking.packets.Packet0003SyncReq;
import com.example.lctnetworktesting.networking.packets.Packet0004Ack;
import com.example.lctnetworktesting.networking.packets.Packet0005Number;


public class GameJoinListenerS extends Listener {
	private GameJoinServer server;
	boolean connecting;

	public GameJoinListenerS(GameJoinServer server) {
		this.server = server;
		connecting = true;
	}

	public void connected(Connection arg0) {
		// DO SOMETHING
		System.out.println("AAAA-S");
	}

	public void disconnected(Connection arg0) {
		System.out.println("disconnect function started");		
		//remove user from trainroom, userdata, and game list
		for (Map.Entry<Integer, ServerUserData> entry : server.userData.entrySet()) {
			if (entry.getValue().connection == arg0) {				
				Integer leavingUID = entry.getKey();
				System.out.println("User found" + leavingUID);
				ServerUserData userInfo = entry.getValue();				
				if (!userInfo.trainRoom.equals("none")) {
					LinkedList<Integer> users = server.trainRooms.get(userInfo.trainRoom);
					users.remove(leavingUID);
					server.trainRooms.put(userInfo.trainRoom, users);
					System.out.println("Removing user from trainRoom");
				}
				if (userInfo.gameID != -1) {
					GameJoinProtocolS.leaveGame(server, arg0, userInfo.gameID, leavingUID, true);
					System.out.println("Removing user from game");
				}
				server.userData.remove(leavingUID);
				System.out.println("Users present is now " + server.userData.size());
				break;	
			}				
		}
	}

	public void received(Connection arg0, Object arg1) {
		// DO SOMETHING
		//System.out.println("CCCC-S");
		if (arg1 instanceof Packet0000LogInfo) {
			Packet0001LogInAccepted p = new Packet0001LogInAccepted();
			p.accepted = true;
			arg0.sendTCP(p);			
			server.cList.add(arg0);
		}
		if (arg1 instanceof Packet0002Message) {
			String message = ((Packet0002Message) arg1).message;
			if (message.equals("wow wow")) {
				System.out.println("VENUS");
			} else if (message.equals("Exit")) {
				connecting = false;
			}
			System.out.println("The meEEEEEssage is: " + message);
		}
		if (arg1 instanceof Packet0005Number) {
			int id = ((Packet0005Number) arg1).id;
			int value = ((Packet0005Number) arg1).value;
			System.out.println("The number is: " + id + " " + value);
			for (Connection c : server.cList) {
				System.out.println("sent to client");
				Packet0005Number p = new Packet0005Number();
				p.id = id;
				p.value = value;
				c.sendTCP(p);
			}
		}
		if (arg1 instanceof Packet0003SyncReq) {
			server.setCount(server.getCount() + 1);
			server.cList.add(arg0);
			if (server.getCount() >= 2) {
				server.broadcastAgain();
			}
		}
		if (arg1 instanceof Packet0004Ack) {
			//System.out.println("Ack received!");

			SThread st = new SThread(arg0);
			st.start();
		}
		if (arg1 instanceof Packet0008Games) {
			System.out.println("Game received!");
			LinkedList<LinkedList<Integer>> contents = ((Packet0008Games) arg1).games;
			for (Integer num : contents.get(0)) {
				System.out.println("got " + num);
			}
			
			Integer UID = contents.get(1).get(1);
			if (server.userData.containsKey(UID) == false) {				
				System.out.println("ADDING user " + UID + ", size is now " + server.userData.size());
			}
			
			GameJoinProtocolS.handleMessage(server, arg0, contents);
		}
		if (arg1 instanceof Packet0007String) { //TrainRoom request			
			char[] messageChar = ((Packet0007String) arg1).message;
			String message = new String(messageChar);
			System.out.println("received string: " + message);
			Integer UID = Integer.parseInt(message.substring(0, 4));
			String trainRoom = message.substring(4);
			LinkedList<Integer> users;
			
			if (UID == 0) {
				LinkedList<LinkedList<Integer>> sendContents = new LinkedList<LinkedList<Integer>>();
				users = server.trainRooms.get(trainRoom);
				users.add(0, -2);
				sendContents.add(users);
				
				Packet0008Games mp = new Packet0008Games();
				mp.games = sendContents;				
				arg0.sendTCP(mp);
				System.out.println("UIDs sent.");
			}
			else {
				if (server.userData.containsKey(UID) == false) {					
					server.userData.put(UID, new ServerUserData(arg0));
					System.out.println("User not found, adding " + UID + ", size is now " + server.userData.size());
				}
				
				if (server.trainRooms.containsKey(trainRoom)) {
					users = server.trainRooms.get(trainRoom);
					System.out.println("trainRoom found");
				}
				else {
					users = new LinkedList<Integer>();				
				}
				users.add(UID);
				server.trainRooms.put(trainRoom, users);
				
				//update user info
				ServerUserData userInfo = server.userData.get(UID);
				userInfo.trainRoom = trainRoom;
				server.userData.put(UID, userInfo);
				System.out.println("Train Room received: " + trainRoom);
				System.out.println("User updated. UID = " + UID + ", room = " + server.userData.get(UID).trainRoom);
			}
		}
	}

	public class SThread extends Thread {
		Connection con;

		public SThread(Connection con) {
			this.con = con;
		}

		@Override
		public void run() {			
			try {
				Thread.sleep(1000);
			} catch (InterruptedException e) {				
				e.printStackTrace();
			}

			Packet0004Ack p = new Packet0004Ack();
			p.connecting = connecting;
			con.sendTCP(p);
			//System.out.println("Ack sent");
		}

	}
	
}

