package mainmenu.networking;

import java.util.HashMap;
import java.util.LinkedList;
import networking.packets.Packet0008Games;

import com.esotericsoftware.kryonet.Connection;

public class GameJoinProtocolS {

	public static void handleMessage(GameJoinServer server, Connection con, LinkedList<LinkedList<Integer>> contents) {
		System.out.println("handling message");
		LinkedList<Connection> connections = new LinkedList<Connection>();
		LinkedList<LinkedList<Integer>> sendContents = new LinkedList<LinkedList<Integer>>();		
		HashMap<Integer, Game> games = server.games;
		Integer gameID, UID;
		Game game;
		ServerUserData userInfo;
		LinkedList<Integer> data = contents.getFirst();
		int id = data.getFirst();
		
		switch (id) {
		case 0:	//send all games			
			//Each game in the map of games becomes new List of int
			data = contents.get(1);
			UID = data.get(0);
			
			if (games.isEmpty()) {
				LinkedList<Integer> noGames = new LinkedList<Integer>();
				noGames.add(-3);
				sendContents.add(noGames);
			}
			else {
				for (Game thisGame : games.values()) {																
					sendContents.add(thisGame.toLinkedList());
				}		
			}			
			connections.add(con);
			send(connections, sendContents);
			break;
			
		case 1:	//add ready user to game	
			//unpack
			data = contents.get(1);
			gameID = data.get(0);
			UID = data.get(1);
			if (!server.games.containsKey(gameID)) { //game not found
				sendLeave(con); 
				break;
			}
			game = server.games.get(gameID);
			userInfo = null;
			
			userInfo = server.userData.get(UID);
			
			System.out.println("gamenameid is " + game.gameNameID);
			Integer maxPlayers = server.gameData.get(game.gameNameID).maxPlayers;
			Integer minPlayers = server.gameData.get(game.gameNameID).minPlayers;
			
			if (game.userList.contains(UID) || game.host == UID || userInfo.gameID != -1) { //user already in the game
				sendLeave(con);
				break;
			}
			if (game.userList.size() + 1 < maxPlayers) {
				game.userList.add(UID);			
				if (game.userList.size() + 1 == minPlayers) {
					server.setGameTimer(gameID);
				}
				server.games.put(gameID, game);
				userInfo.gameID = gameID;
				server.userData.put(UID, userInfo);
				System.out.println("ADD PLAYER. HASHMAP SIZE IS NOW " + server.games.size());
				System.out.println("added " + UID + " to players. Num players = " + game.userList.size() + 1);
				connections = server.getRoomConnections(game.trainRoom);
				sendContents.add(game.toLinkedList());
				send(connections, sendContents);
			} 
			else { //too many users				
				sendLeave(con);
			}			
			break;
			
		case 2:	//user leaves game			
			System.out.println("IN handle : 2");
			data = contents.get(1);
			gameID = data.get(0);
			UID = data.get(1);	
			if (!server.games.containsKey(gameID)) {
				sendError(con);
				System.out.println("Sending error");
				break;
			}
			leaveGame(server, con, gameID, UID, false);
			sendLeave(con);
			break;
		case 3: //host makes new game
			System.out.println("making new game");
			data = contents.get(1);
			Integer gameNameID = data.get(0);
			UID = data.get(1);
			
			if (server.userData.containsKey(UID)) {
				userInfo = server.userData.get(UID);
				System.out.println("user info found");
			}
			else {
				sendLeave(con);
				break;
			}
			
			if (userInfo.trainRoom.equals("none")) { //user does not have a train room. Can't make a game.
				System.out.println("trainRoom is null, sending error");
				sendLeave(con);
				break;
			}
			
			if (userInfo.gameID == -1) { //user can host
			
				gameID = server.nextKey();
				System.out.println("new game is " + gameID + " gnid " + gameNameID + " uid " + UID + " room " + userInfo.trainRoom);
				game = new Game(gameID, gameNameID, UID, userInfo.trainRoom);
				server.games.put(gameID, game);
				userInfo.gameID = gameID;
				server.userData.put(UID, userInfo);
				
				System.out.println("New game. HASHMAP SIZE IS NOW " + server.games.size());
				
				//if elemancer start timer			
				Integer minPlayers1 = server.gameData.get(game.gameNameID).minPlayers;
				if (game.userList.size() + 1 == minPlayers1) {
					System.out.println("STARTING ELEMANCER");
					server.setGameTimer(gameID);
				}
				
				connections = server.getRoomConnections(game.trainRoom);
				System.out.println("connection size " + connections.size());
				sendContents.add(game.toLinkedList());
				send(connections, sendContents);
			}
			else { //user is already in a game. Cannot make a new one.
				sendLeave(con);
			}
			break;	
			
		case 4: //host force starts game
			data = contents.get(1);
			gameID = data.get(0);
			UID = data.get(1);
			if (!server.games.containsKey(gameID)) {
				sendError(con);
				break;
			}
			game = server.games.get(gameID);
			if (game.host == UID && game.timer != -1) {			
				server.startGame(gameID);	
			}
			else sendError(con);
			break;
		default:
			break;
		}		
		//{packet ID}, {gameID, gamenameID, ready?, uids}
		//{packet ID}, {gameID, uid}
		
	}
	
	public static void leaveGame(GameJoinServer server, Connection con, Integer gameID, Integer UID, boolean force) {
		Game game = server.games.get(gameID);
		Integer timer = game.timer;
		
		if (timer == -1 || force) { //okay, remove user
			if (game.host == UID) { //remove host
				if (game.userList.isEmpty()) { //remove game
					server.removeGame(gameID);
					return;
				}
				else {
					int nextHost = game.userList.remove();
					game.host = nextHost;					
				}
			}
			else {
				game.userList.remove(UID); //remove regular user				
			}
			
			server.games.put(gameID, game);
			ServerUserData userInfo = server.userData.get(UID);
			userInfo.gameID = -1;
			server.userData.put(UID, userInfo);
			LinkedList<Connection> connections = server.getRoomConnections(game.trainRoom);			
			LinkedList<LinkedList<Integer>> sendContents = new LinkedList<LinkedList<Integer>>();
			sendContents.add(game.toLinkedList());
			send(connections, sendContents);
		}
		else { //too late to leave
			sendError(con);
		}	 
	}

	public static void send(LinkedList<Connection> connections, LinkedList<LinkedList<Integer>> message) {
		for (Connection con : connections) {			
			Packet0008Games mp = new Packet0008Games();
			mp.games = message;
			System.out.println("about to send to " + con);
			con.sendTCP(mp);
			System.out.println("Games sent. ID " + message.get(0).get(0));
		}
	}
	
	public static void sendError(Connection con) {
		LinkedList<Connection> connections = new LinkedList<Connection>();
		connections.add(con);
		LinkedList<Integer> error = new LinkedList<Integer>();
		error.add(-1);
		LinkedList<LinkedList<Integer>> sendContents = new LinkedList<LinkedList<Integer>>();
		sendContents.add(error);
		send(connections, sendContents);
		System.out.println("Game Error sent");
	}
	
	public static void sendLeave(Connection con) {
		LinkedList<Connection> connections = new LinkedList<Connection>();
		connections.add(con);
		LinkedList<Integer> error = new LinkedList<Integer>();
		error.add(-5);
		LinkedList<LinkedList<Integer>> sendContents = new LinkedList<LinkedList<Integer>>();
		sendContents.add(error);
		send(connections, sendContents);
		System.out.println("Game Error sent");
	}
}
