package menu;

import org.andengine.entity.scene.Scene;
import org.andengine.entity.scene.background.Background;
import org.andengine.entity.sprite.Sprite;
import org.andengine.input.touch.TouchEvent;
import org.andengine.opengl.texture.atlas.bitmap.BitmapTextureAtlas;
import org.andengine.opengl.texture.atlas.bitmap.BitmapTextureAtlasTextureRegionFactory;
import org.andengine.opengl.texture.region.ITextureRegion;

import android.util.Log;

import com.example.traingame.SceneManager;
import com.example.traingame.Setup;

import database.DBProtocolC;

public class menuSetup extends Setup {
	private BitmapTextureAtlas amidaTA;
	private ITextureRegion amidaReg;
	private BitmapTextureAtlas creatureTA;
	private ITextureRegion creatureReg;
	private BitmapTextureAtlas grizzlyTA;
	private ITextureRegion grizzlyReg;
	private BitmapTextureAtlas mummyTA;
	private ITextureRegion mummyReg;
	private BitmapTextureAtlas wizardTA;
	private ITextureRegion wizardReg;
	private BitmapTextureAtlas potatoTA;
	private ITextureRegion potatoReg;
	private BitmapTextureAtlas persistantTA;
	private ITextureRegion persistantReg;

	public menuSetup(SceneManager SM) {
		this.sm = SM;
	}

	public void load() {
		BitmapTextureAtlasTextureRegionFactory.setAssetBasePath("gfx/");
		// ** WIDTH AND HEIGHT MUST BE A POWER OF 2 **
		creatureTA = new BitmapTextureAtlas(sm.activity.getTextureManager(),
				128, 64);
		creatureReg = BitmapTextureAtlasTextureRegionFactory.createFromAsset(
				creatureTA, sm.activity, "CreatureLogo.jpg", 0, 0);
		creatureTA.load();
		grizzlyTA = new BitmapTextureAtlas(sm.activity.getTextureManager(),
				128, 64);
		grizzlyReg = BitmapTextureAtlasTextureRegionFactory.createFromAsset(
				grizzlyTA, sm.activity, "GrizzlyLogo.jpg", 0, 0);
		grizzlyTA.load();
		amidaTA = new BitmapTextureAtlas(sm.activity.getTextureManager(), 128,
				64);
		amidaReg = BitmapTextureAtlasTextureRegionFactory.createFromAsset(
				amidaTA, sm.activity, "AmidaLogo.jpg", 0, 0);
		amidaTA.load();
		mummyTA = new BitmapTextureAtlas(sm.activity.getTextureManager(), 128,
				64);
		mummyReg = BitmapTextureAtlasTextureRegionFactory.createFromAsset(
				mummyTA, sm.activity, "MummyLogo.jpg", 0, 0);
		mummyTA.load();
		wizardTA = new BitmapTextureAtlas(sm.activity.getTextureManager(), 128,
				64);
		wizardReg = BitmapTextureAtlasTextureRegionFactory.createFromAsset(
				wizardTA, sm.activity, "WizardLogo.jpg", 0, 0);
		wizardTA.load();
		potatoTA = new BitmapTextureAtlas(sm.activity.getTextureManager(), 128,
				64);
		potatoReg = BitmapTextureAtlasTextureRegionFactory.createFromAsset(
				potatoTA, sm.activity, "PotatoLogo.jpg", 0, 0);
		potatoTA.load();
		persistantTA = new BitmapTextureAtlas(sm.activity.getTextureManager(),
				128, 64);
		persistantReg = BitmapTextureAtlasTextureRegionFactory.createFromAsset(
				persistantTA, sm.activity, "TrainGameLogo.jpg", 0, 0);
		persistantTA.load();

	}

	public Scene create() {
		Scene menuScene = new Scene();

		// 800 by 480 screen. 128 by 64 screen.
		menuScene.setBackground(new Background(255, 255, 255));

		Sprite crLogo = new Sprite(100, 100, creatureReg,
				sm.activity.getVertexBufferObjectManager()) {
			@Override
			public boolean onAreaTouched(final TouchEvent pSceneTouchEvent,
					final float pTouchAreaLocalX, final float pTouchAreaLocalY) {
				sm.setCurrentS(SceneManager.AllScenes.LCREATURE);
				return true;
			}
		};
		menuScene.attachChild(crLogo);
		menuScene.registerTouchArea(crLogo);

		Sprite amLogo = new Sprite(100, 100, amidaReg,
				sm.activity.getVertexBufferObjectManager()) {
			@Override
			public boolean onAreaTouched(final TouchEvent pSceneTouchEvent,
					final float pTouchAreaLocalX, final float pTouchAreaLocalY) {
				sm.setCurrentS(SceneManager.AllScenes.LAMIDA);
				return true;
			}
		};
		amLogo.setX((sm.camera.getWidth() - amLogo.getWidth()) / 2);
		menuScene.attachChild(amLogo);
		menuScene.registerTouchArea(amLogo);

		Sprite grLogo = new Sprite(0, 100, grizzlyReg,
				sm.activity.getVertexBufferObjectManager()) {
			@Override
			public boolean onAreaTouched(final TouchEvent pSceneTouchEvent,
					final float pTouchAreaLocalX, final float pTouchAreaLocalY) {
				sm.setCurrentS(SceneManager.AllScenes.LGRIZZLY);
				return true;
			}
		};
		grLogo.setX(sm.camera.getWidth() - 100 - grLogo.getWidth());
		menuScene.attachChild(grLogo);
		menuScene.registerTouchArea(grLogo);

		Sprite wiLogo = new Sprite(100, 300, wizardReg,
				sm.activity.getVertexBufferObjectManager()) {
			@Override
			public boolean onAreaTouched(final TouchEvent pSceneTouchEvent,
					final float pTouchAreaLocalX, final float pTouchAreaLocalY) {
				sm.setCurrentS(SceneManager.AllScenes.LWIZARD);
				return true;
			}
		};
		wiLogo.setY(sm.camera.getHeight() - 100 - wiLogo.getHeight());
		menuScene.attachChild(wiLogo);
		menuScene.registerTouchArea(wiLogo);

		Sprite muLogo = new Sprite(100, 300, mummyReg,
				sm.activity.getVertexBufferObjectManager()) {
			@Override
			public boolean onAreaTouched(final TouchEvent pSceneTouchEvent,
					final float pTouchAreaLocalX, final float pTouchAreaLocalY) {
				sm.setCurrentS(SceneManager.AllScenes.OTHERUSERS);
				return true;
			}
		};
		muLogo.setX((sm.camera.getWidth() - muLogo.getWidth()) / 2);
		muLogo.setY(sm.camera.getHeight() - 100 - muLogo.getHeight());
		menuScene.attachChild(muLogo);
		menuScene.registerTouchArea(muLogo);

		Sprite poLogo = new Sprite(100, 300, potatoReg,
				sm.activity.getVertexBufferObjectManager()) {
			@Override
			public boolean onAreaTouched(final TouchEvent pSceneTouchEvent,
					final float pTouchAreaLocalX, final float pTouchAreaLocalY) {
				sm.setCurrentS(SceneManager.AllScenes.LPOTATO);
				return true;
			}
		};
		poLogo.setX(sm.camera.getWidth() - 100 - poLogo.getWidth());
		poLogo.setY(sm.camera.getHeight() - 100 - poLogo.getHeight());
		menuScene.attachChild(poLogo);
		menuScene.registerTouchArea(poLogo);

		Sprite peLogo = new Sprite(100, 300, persistantReg,
				sm.activity.getVertexBufferObjectManager()) {
			@Override
			public boolean onAreaTouched(final TouchEvent pSceneTouchEvent,
					final float pTouchAreaLocalX, final float pTouchAreaLocalY) {
				sm.setCurrentS(SceneManager.AllScenes.LPERSISTANT);
				return true;
			}
		};
		peLogo.setX((sm.camera.getWidth() - peLogo.getWidth()) / 2);
		peLogo.setY((sm.camera.getHeight() - peLogo.getHeight()) / 2);
		menuScene.attachChild(peLogo);
		menuScene.registerTouchArea(peLogo);

		return menuScene;
	}
}
