package networking.component;

import java.io.IOException;
import java.util.Scanner;

import networking.packets.*;

import com.esotericsoftware.kryo.Kryo;
import com.esotericsoftware.kryonet.Client;
import com.esotericsoftware.minlog.Log;

public class LCTClient {
	public Client client;
	public static Scanner scanner;
	
	public LCTClient(){
		scanner = new Scanner(System.in);
		client = new Client();
		register();
		
		LCTListenerC l = new LCTListenerC();
		l.init(client);
		client.addListener(l);
		
		client.start();
		
		try {
			System.out.println("ip?");
			client.connect(5000, scanner.nextLine(), 2333);
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			client.stop();
		}
	}

	private void register() {
		Kryo kryo = client.getKryo();
		kryo.register(Packet0000LogInfo.class);
		kryo.register(Packet0001LogInAccepted.class);
		kryo.register(Packet0002Message.class);
		kryo.register(Packet0003SyncReq.class);
	}

	public static void main(String[] args){
		new LCTClient();
		Log.set(Log.LEVEL_TRACE);
	}
}
