package networking.component;

import java.io.IOException;
import java.util.LinkedList;

import networking.packets.*;

import com.esotericsoftware.kryo.Kryo;
import com.esotericsoftware.kryonet.Connection;
import com.esotericsoftware.kryonet.Server;
import com.esotericsoftware.minlog.Log;

public class LCTServer {
	private Server server;
	public LinkedList<Connection> cList;
	private int count;
	
	public LCTServer() throws IOException{
		server = new Server();
		
		cList = new LinkedList<Connection>();
		count = 0;
		registerPackets();
		//TODO
		LCTListenerS l = new LCTListenerS(this);
		server.addListener(l);
		server.bind(2333);
		System.out.println("ARRIVED HERE");
		server.start();
	}
	
	private void registerPackets(){
		Kryo kryo = server.getKryo();
		kryo.register(Packet0000LogInfo.class);
		kryo.register(Packet0001LogInAccepted.class);
		kryo.register(Packet0002Message.class);
		kryo.register(Packet0003SyncReq.class);
	}
	
	public void broadcastOnce(){
		for (Connection c: cList){
			Packet0002Message p = new Packet0002Message();
			p.message = "Two Person Play! Size is " + cList.size();
			c.sendTCP(p);
		}
		cList.clear();
		count = 0;
	}
	
	public void broadcastAgain(){
		Packet0002Message p = new Packet0002Message();
		p.message = "Two Person Play! Size is " + cList.size();
		server.sendToAllTCP(p);
	}

	public int getCount() {
		return count;
	}

	public void setCount(int count) {
		this.count = count;
	}

	public static void main(String[] args){
		try {
			new LCTServer();
			Log.set(Log.LEVEL_DEBUG);
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
}
