package persistantgame;

import android.content.SharedPreferences;

import com.example.traingame.MainActivity;

public class TrainStats {
	//STARTING VALUES
	//stats
	private static int health;
	private static int speed;
	private static int cargo;
	private static int foreignCargo;
	private static int money;
	private static long updateTimeStamp;
	private static long resetTimeStamp;
	//every "turn" get "income". increase money by amt. equal to number of cargo
	
	//prices
	private static int healthPrice;
	private static int speedPrice;
	private static int cargoBuyPrice;
	private static int cargoSellPrice;
	private static int foreignCargoSellPrice;
	
	//scores. Might need decimals.
	private static int totalScore;
	private static int distance;
		
	//curent event
	private static String currEventText;

	//shared preferences instance for storage
	SharedPreferences sharedPref = MainActivity.getSharedPrefs();
	SharedPreferences.Editor prefEditor = sharedPref.edit();
	
	//sole instance of this game
	private static TrainStats trainStats = new TrainStats();
	
	
	/**
	 * this is a singleton class
	 */
	private TrainStats() {		
		loadFromPrefs();		
	}
		
	
	/**
	 * Get sole instance of trainstats
	 * @return
	 */
	public static TrainStats getInstance() {
		return trainStats;
	}

	/**
	 * @return the health
	 */
	public int getHealth() {
		return health;
	}

	/**
	 * @param health the health to set
	 */
	public void setHealth(int health) {
		TrainStats.health = health;
		prefEditor.putInt("health", health);
		prefEditor.commit();
	}

	/**
	 * @return the speed
	 */
	public int getSpeed() {
		return speed;
	}

	/**
	 * @param speed the speed to set
	 */
	public void setSpeed(int speed) {
		TrainStats.speed = speed;
		prefEditor.putInt("speed", speed);
		prefEditor.commit();
	}

	/**
	 * @return the cargo
	 */
	public int getCargo() {
		return cargo;
	}

	/**
	 * @param cargo the cargo to set
	 */
	public void setCargo(int cargo) {
		TrainStats.cargo = cargo;
		prefEditor.putInt("cargo", cargo);
		prefEditor.commit();
	}

	/**
	 * @return the foreignCargo
	 */
	public int getForeignCargo() {
		return foreignCargo;
	}

	/**
	 * @param foreignCargo the foreignCargo to set
	 */
	public void setForeignCargo(int foreignCargo) {
		TrainStats.foreignCargo = foreignCargo;
		prefEditor.putInt("foreignCargo", foreignCargo);
		prefEditor.commit();
	}

	/**
	 * @return the money
	 */
	public int getMoney() {
		return money;
	}

	/**
	 * @param money the money to set
	 */
	public void setMoney(int money) {
		TrainStats.money = money;
		prefEditor.putInt("money", money);
		prefEditor.commit();
	}

	/**
	 * @return the healthPrice
	 */
	public int getHealthPrice() {
		return healthPrice;
	}

	/**
	 * @param healthPrice the healthPrice to set
	 */
	public void setHealthPrice(int healthPrice) {
		TrainStats.healthPrice = healthPrice;
		prefEditor.putInt("healthPrice", healthPrice);
		prefEditor.commit();
	}

	/**
	 * @return the speedPrice
	 */
	public int getSpeedPrice() {
		return speedPrice;
	}

	/**
	 * @param speedPrice the speedPrice to set
	 */
	public void setSpeedPrice(int speedPrice) {
		TrainStats.speedPrice = speedPrice;
		prefEditor.putInt("speedPrice", speedPrice);
		prefEditor.commit();
	}

	/**
	 * @return the cargoBuyPrice
	 */
	public int getCargoBuyPrice() {
		return cargoBuyPrice;
	}

	/**
	 * @param cargoBuyPrice the cargoBuyPrice to set
	 */
	public void setCargoBuyPrice(int cargoBuyPrice) {
		TrainStats.cargoBuyPrice = cargoBuyPrice;
		prefEditor.putInt("cargoBuyPrice", cargoBuyPrice);
		prefEditor.commit();
	}

	/**
	 * @return the cargoSellPrice
	 */
	public int getCargoSellPrice() {
		return cargoSellPrice;
	}

	/**
	 * @param cargoSellPrice the cargoSellPrice to set
	 */
	public void setCargoSellPrice(int cargoSellPrice) {
		TrainStats.cargoSellPrice = cargoSellPrice;
		prefEditor.putInt("cargoSellPrice", cargoSellPrice);
		prefEditor.commit();
	}

	/**
	 * @return the foreignCargoSellPrice
	 */
	public int getForeignCargoSellPrice() {
		return foreignCargoSellPrice;
	}

	/**
	 * @param foreignCargoSellPrice the foreignCargoSellPrice to set
	 */
	public void setForeignCargoSellPrice(int foreignCargoSellPrice) {
		TrainStats.foreignCargoSellPrice = foreignCargoSellPrice;
		prefEditor.putInt("foreignCargoSellPrice", foreignCargoSellPrice);
		prefEditor.commit();
	}

	/**
	 * @return the totalScore
	 */
	public double getTotalScore() {
		return totalScore;
	}

	/**
	 * @param totalScore the totalScore to set
	 */
	public void setTotalScore(int totalScore) {
		TrainStats.totalScore = totalScore;
		prefEditor.putInt("totalScore", totalScore);
		prefEditor.commit();
	}

	/**
	 * @return the distance
	 */
	public int getDistance() {
		return distance;
	}

	/**
	 * @param distance the distance to set
	 */
	public void setDistance(int distance) {
		TrainStats.distance = distance;
		prefEditor.putInt("distance", distance);
		prefEditor.commit();
	}

	/**
	 * @return the currEventText
	 */
	public String getCurrEventText() {
		return currEventText;
	}

	/**
	 * @param currEventText the currEventText to set
	 */
	public void setCurrEventText(String currEventText) {
		TrainStats.currEventText = currEventText;
		prefEditor.putString("currEventText", currEventText);
		prefEditor.commit();		

	}
	
	/**
	 * @return the updateTimeStamp
	 */
	public long getUpdateTimeStamp() {
		return updateTimeStamp;
	}

	/**
	 * @param updateTimeStamp the updateTimeStamp to set
	 */
	public void setUpdateTimeStamp(long updateTimeStamp) {
		TrainStats.updateTimeStamp = updateTimeStamp;
		prefEditor.putLong("updateTimeStamp", updateTimeStamp);
		prefEditor.commit();		

	}
	
	/**
	 * @return the resetTimeStamp
	 */
	public long getResetTimeStamp() {
		return resetTimeStamp;
	}

	/**
	 * @param resetTimeStamp the resetTimeStamp to set
	 */
	public void setResetTimeStamp(long resetTimeStamp) {
		TrainStats.resetTimeStamp = resetTimeStamp;
		prefEditor.putLong("resetTimeStamp", resetTimeStamp);
		prefEditor.commit();		

	}
	
	
	
	public void loadFromPrefs() {
		if (sharedPref.getInt("distance", -1) == -1) {
			startNewGame();
		}
		TrainStats.health = sharedPref.getInt("health", -1);
		TrainStats.speed = sharedPref.getInt("speed", -1);
		TrainStats.cargo = sharedPref.getInt("cargo", -1);
		TrainStats.foreignCargo = sharedPref.getInt("foreignCargo", -1);
		TrainStats.money = sharedPref.getInt("money", -1);		
		TrainStats.healthPrice = sharedPref.getInt("healthPrice", -1);
		TrainStats.speedPrice = sharedPref.getInt("speedPrice", -1);
		TrainStats.cargoBuyPrice = sharedPref.getInt("cargoBuyPrice", -1);
		TrainStats.cargoSellPrice = sharedPref.getInt("cargoSellPrice", -1);
		TrainStats.foreignCargoSellPrice = sharedPref.getInt("foreignCargoSellPrice", -1);
		TrainStats.totalScore = sharedPref.getInt("totalScore", -1);
		TrainStats.distance = sharedPref.getInt("distance", -1);
		TrainStats.currEventText = sharedPref.getString("currEventText", null);
		TrainStats.updateTimeStamp = sharedPref.getLong("updateTimeStamp", -1);
		TrainStats.resetTimeStamp = sharedPref.getLong("resetTimeStamp", -1);
	}
	
	public void startNewGame() {
		setHealth(50);
		setSpeed(1);
		setCargo(0);
		setForeignCargo(0);
		setMoney(100);
		setHealthPrice(4);
		setSpeedPrice(25);
		setCargoBuyPrice(10);
		setCargoSellPrice(5);
		setForeignCargoSellPrice(50);
		setTotalScore(0);
		setDistance(0);
		setCurrEventText("None");
		setUpdateTimeStamp(System.nanoTime());
		setResetTimeStamp(System.nanoTime());
	}
	
}
