package persistantgame;

import java.util.Random;

import org.andengine.engine.handler.timer.ITimerCallback;
import org.andengine.engine.handler.timer.TimerHandler;
import org.andengine.entity.primitive.Rectangle;
import org.andengine.entity.scene.Scene;
import org.andengine.entity.scene.background.Background;
import org.andengine.entity.sprite.AnimatedSprite;
import org.andengine.entity.sprite.Sprite;
import org.andengine.entity.text.Text;
import org.andengine.entity.text.TextOptions;
import org.andengine.input.touch.TouchEvent;
import org.andengine.opengl.font.Font;
import org.andengine.opengl.font.FontFactory;
import org.andengine.opengl.texture.atlas.bitmap.BitmapTextureAtlas;
import org.andengine.opengl.texture.atlas.bitmap.BitmapTextureAtlasTextureRegionFactory;
import org.andengine.opengl.texture.region.ITextureRegion;
import org.andengine.opengl.texture.region.TextureRegion;
import org.andengine.opengl.texture.region.TiledTextureRegion;
import org.andengine.util.HorizontalAlign;
import org.andengine.util.color.Color;

import android.graphics.Typeface;
import android.util.Log;

import com.example.traingame.SceneManager;
import com.example.traingame.Setup;

public class persVendSetup extends Setup {
	//background
	private TextureRegion bgReg;
	private BitmapTextureAtlas bgTA;
	
	private Font font;
	private Font font2;
	private Font font3;
	
	private Text money;
	private Text cargo;
	private Text speed;
	private Text health;
	
	private int mVal = 0;
	private int cVal = 0;
	private int sVal = 0;
	private int hVal = 0;
	
	private BitmapTextureAtlas addSubTA;
	private TiledTextureRegion addSubReg;
	private BitmapTextureAtlas healthTA;
	private ITextureRegion healthReg;
	private BitmapTextureAtlas moneyTA;
	private BitmapTextureAtlas speedTA;
	private ITextureRegion speedReg;
	private BitmapTextureAtlas cargoTA;
	private ITextureRegion cargoReg;
	private BitmapTextureAtlas checkTA;
	private ITextureRegion checkReg;
	private BitmapTextureAtlas check2TA;
	private ITextureRegion check2Reg;
	private BitmapTextureAtlas doorTA;
	private TiledTextureRegion doorReg;
	
	private BitmapTextureAtlas logoTA;
	private TextureRegion logoReg;
	
	private BitmapTextureAtlas backbuttonTA;
	private TextureRegion backbuttonReg;
	
	private BitmapTextureAtlas backgroundTA;
	private TextureRegion backgroundReg;
	
	private Sprite pCargo;
	private Sprite pHealth;
	private Sprite pSpeed;
	private Sprite pCargo2;
	private Sprite pHealth2;
	private Sprite pSpeed2;
	private Sprite pCargo3;
	private Sprite pHealth3;
	private Sprite pSpeed3;

	
	private AnimatedSprite plus1;
	private AnimatedSprite plus2;
	private AnimatedSprite plus3;
	private AnimatedSprite minus1;
	private AnimatedSprite minus2;
	private AnimatedSprite minus3; 
	private AnimatedSprite door; 
	
	private Scene pVendScene;
	private Random r = new Random();
	private TimerHandler tm;
	
	private Sprite checkout;
	private Sprite checkout2;
	private Text checklable;
	
	private TrainStats ts;
	
	public persVendSetup(SceneManager SM){
		this.sm = SM;
	}
	
	public void load(){
		
		bgTA = new BitmapTextureAtlas(sm.activity.getTextureManager(), 2048, 2048);
		bgReg = BitmapTextureAtlasTextureRegionFactory.createFromAsset(
					bgTA, sm.activity, "vendingMachine.png", 0, 0);
		bgTA.load();
		
		font = FontFactory.create(sm.engine.getFontManager(), sm.engine.getTextureManager(), 256, 256, Typeface.create(Typeface.DEFAULT, Typeface.BOLD), 32,Color.WHITE.hashCode());
		font.load();
		
		font2 = FontFactory.create(sm.engine.getFontManager(), sm.engine.getTextureManager(), 256, 256, Typeface.create(Typeface.DEFAULT, Typeface.BOLD), 20,Color.WHITE.hashCode());
		font2.load();
		
		font3 = FontFactory.create(sm.engine.getFontManager(), sm.engine.getTextureManager(), 256, 256, Typeface.create(Typeface.DEFAULT, Typeface.BOLD), 40,Color.WHITE.hashCode());
		font3.load();
		
		addSubTA = new BitmapTextureAtlas(sm.activity.getTextureManager(), 512, 512);
		addSubReg = BitmapTextureAtlasTextureRegionFactory.createTiledFromAsset(
				addSubTA, sm.activity, "addSub.png", 0, 0,2,2);
		addSubTA.load();
		
		healthTA = new BitmapTextureAtlas(sm.activity.getTextureManager(), 512, 512);
		healthReg = BitmapTextureAtlasTextureRegionFactory.createFromAsset(
				healthTA, sm.activity, "health icon.png", 0, 0);
		healthTA.load();
		
		
		speedTA = new BitmapTextureAtlas(sm.activity.getTextureManager(), 512, 512);
		speedReg = BitmapTextureAtlasTextureRegionFactory.createFromAsset(
				speedTA, sm.activity, "speed icon.png", 0, 0);
		speedTA.load();
		
		cargoTA = new BitmapTextureAtlas(sm.activity.getTextureManager(), 512, 512);
		cargoReg = BitmapTextureAtlasTextureRegionFactory.createFromAsset(
				cargoTA, sm.activity, "train cargo.png", 0, 0);
		cargoTA.load();
		
		moneyTA = new BitmapTextureAtlas(sm.activity.getTextureManager(), 512, 512);
		moneyTA.load();
		
		checkTA = new BitmapTextureAtlas(sm.activity.getTextureManager(), 128, 128);
		checkReg = BitmapTextureAtlasTextureRegionFactory.createFromAsset(
				checkTA, sm.activity, "checkout.png", 0, 0);
		checkTA.load();
		check2TA = new BitmapTextureAtlas(sm.activity.getTextureManager(), 128, 128);
		check2Reg = BitmapTextureAtlasTextureRegionFactory.createFromAsset(
				check2TA, sm.activity, "checkout2.png", 0, 0);
		check2TA.load();
		
		doorTA = new BitmapTextureAtlas(sm.activity.getTextureManager(), 1024, 1024);
		doorReg = BitmapTextureAtlasTextureRegionFactory.createTiledFromAsset(
				doorTA, sm.activity, "door.png", 0, 0,1,2);
		doorTA.load();
		
		logoTA = new BitmapTextureAtlas(sm.activity.getTextureManager(), 2048, 2048);
		logoReg = BitmapTextureAtlasTextureRegionFactory.createFromAsset(
				logoTA, sm.activity, "trainLogo.png", 0, 0);
		logoTA.load();
		
		backbuttonTA = new BitmapTextureAtlas(sm.activity.getTextureManager(), 512, 256);
		backbuttonReg = BitmapTextureAtlasTextureRegionFactory.createFromAsset(
				backbuttonTA, sm.activity, "back button.png", 0, 0);
		backbuttonTA.load();
		
		backgroundTA = new BitmapTextureAtlas(sm.activity.getTextureManager(), 2048, 2048);
		backgroundReg = BitmapTextureAtlasTextureRegionFactory.createFromAsset(
				backgroundTA, sm.activity, "generic bw background.png", 0, 0);
		backgroundTA.load();
	}
	
	public Scene create(){
		ts = TrainStats.getInstance();
		pVendScene = new Scene();
		
		Sprite gbg = new Sprite(0,0,backgroundReg,sm.activity.getVertexBufferObjectManager());
		pVendScene.attachChild(gbg);
		
		int cX = (int)(sm.camera.getWidth() - bgReg.getWidth())/2;
		int cY = (int)(sm.camera.getHeight() - bgReg.getHeight())/2; 
		Log.i("testing", "CX is: " + cX);
		Log.i("testing", "CY is: " + cY);
		Sprite bg = new Sprite(cX, cY,  bgReg, sm.activity.getVertexBufferObjectManager());
		bg.setScale(0.5f);
		pVendScene.attachChild(bg);
		pVendScene.setBackground(new Background(255,0,0));
		//Y + 560
		money = new Text(cX + 680, cY + 1180,font,"00000g",new TextOptions(HorizontalAlign.RIGHT), sm.engine.getVertexBufferObjectManager());
		cargo = new Text(cX + 705, cY + 1080,font,"00",new TextOptions(HorizontalAlign.RIGHT), sm.engine.getVertexBufferObjectManager());
		speed = new Text(cX + 705, cY + 940,font,"00",new TextOptions(HorizontalAlign.RIGHT), sm.engine.getVertexBufferObjectManager());
		health = new Text(cX + 705, cY + 795,font,"00",new TextOptions(HorizontalAlign.RIGHT), sm.engine.getVertexBufferObjectManager());
		cargo.setText("0");
		speed.setText("0");
		health.setText("0");
		money.setText("0g");
		pVendScene.attachChild(money);
		pVendScene.attachChild(cargo);
		pVendScene.attachChild(speed);
		pVendScene.attachChild(health);
		
		Text cargoP = new Text(cX + 556, cY + 1125,font2,"" + ts.getCargoBuyPrice() + "g",new TextOptions(HorizontalAlign.RIGHT), sm.engine.getVertexBufferObjectManager());
		Text speedP = new Text(cX + 556, cY + 991,font2,"" + ts.getSpeedPrice() + "g",new TextOptions(HorizontalAlign.RIGHT), sm.engine.getVertexBufferObjectManager());
		Text healthP = new Text(cX + 556, cY + 850,font2,"" + ts.getHealthPrice() + "g",new TextOptions(HorizontalAlign.RIGHT), sm.engine.getVertexBufferObjectManager());
		pVendScene.attachChild(cargoP);
		pVendScene.attachChild(speedP);
		pVendScene.attachChild(healthP);
		
		plus1 = new AnimatedSprite(cX + 530, cY+944, addSubReg, sm.activity.getVertexBufferObjectManager()){
			@Override
			public boolean onAreaTouched(final TouchEvent pSceneTouchEvent, final float pTouchAreaLocalX, final float pTouchAreaLocalY) {
				if(pSceneTouchEvent.getAction() == TouchEvent.ACTION_DOWN){
					click(this, true, cargo);
				}
				return true;
			}
		};
		pVendScene.registerTouchArea(plus1);
		plus1.setScale(.2f);
		if(ts.getMoney() < ts.getCargoBuyPrice()){
			plus1.setCurrentTileIndex(2);
		}
		else{
			plus1.setCurrentTileIndex(0);
		}
		pVendScene.attachChild(plus1);
		
		plus2 = new AnimatedSprite(cX + 530, cY + 808, addSubReg, sm.activity.getVertexBufferObjectManager()){
			@Override
			public boolean onAreaTouched(final TouchEvent pSceneTouchEvent, final float pTouchAreaLocalX, final float pTouchAreaLocalY) {
				if(pSceneTouchEvent.getAction() == TouchEvent.ACTION_DOWN){
					click(this,true,speed);
				}
				return true;
			}
		};
		plus2.setScale(.2f);
		if(ts.getMoney() < ts.getSpeedPrice()){
			plus2.setCurrentTileIndex(2);
		}
		else{
			plus2.setCurrentTileIndex(0);
		}
		pVendScene.attachChild(plus2);
		pVendScene.registerTouchArea(plus2);
		
		plus3 = new AnimatedSprite(cX + 530, cY + 662, addSubReg, sm.activity.getVertexBufferObjectManager()){
			@Override
			public boolean onAreaTouched(final TouchEvent pSceneTouchEvent, final float pTouchAreaLocalX, final float pTouchAreaLocalY) {
				if(pSceneTouchEvent.getAction() == TouchEvent.ACTION_DOWN){
					click(this,true,health);
				}
				return true;
			}
		};
		plus3.setScale(.2f);
		if(ts.getMoney() < ts.getHealthPrice()){
			plus3.setCurrentTileIndex(2);
		}
		else{
			plus3.setCurrentTileIndex(0);
		}
		pVendScene.attachChild(plus3);
		pVendScene.registerTouchArea(plus3);
		
		minus1 = new AnimatedSprite(cX + 530, cY + 996, addSubReg, sm.activity.getVertexBufferObjectManager()){
			@Override
			public boolean onAreaTouched(final TouchEvent pSceneTouchEvent, final float pTouchAreaLocalX, final float pTouchAreaLocalY) {
				if(pSceneTouchEvent.getAction() == TouchEvent.ACTION_DOWN){
					click(this,false,cargo);
				}
				return true;
			}
		};
		minus1.setScale(.2f);
		minus1.setCurrentTileIndex(3);
		pVendScene.attachChild(minus1);
		pVendScene.registerTouchArea(minus1);
		
		minus2 = new AnimatedSprite(cX + 530, cY + 860, addSubReg, sm.activity.getVertexBufferObjectManager()){
			@Override
			public boolean onAreaTouched(final TouchEvent pSceneTouchEvent, final float pTouchAreaLocalX, final float pTouchAreaLocalY) {
				if(pSceneTouchEvent.getAction() == TouchEvent.ACTION_DOWN){
					click(this,false,speed);
				}
				return true;
			}
		};
		minus2.setScale(.2f);
		minus2.setCurrentTileIndex(3);
		pVendScene.attachChild(minus2);
		pVendScene.registerTouchArea(minus2);
		
		minus3 = new AnimatedSprite(cX + 530, cY + 718, addSubReg, sm.activity.getVertexBufferObjectManager()){
			@Override
			public boolean onAreaTouched(final TouchEvent pSceneTouchEvent, final float pTouchAreaLocalX, final float pTouchAreaLocalY) {
				if(pSceneTouchEvent.getAction() == TouchEvent.ACTION_DOWN){
					click(this,false,health);
				}
				return true;
			}
		};
		minus3.setScale(.2f);
		minus3.setCurrentTileIndex(3);
		pVendScene.attachChild(minus3);
		pVendScene.registerTouchArea(minus3);
		
		checkout = new Sprite(cX + 350, cY + 1145, checkReg, sm.activity.getVertexBufferObjectManager()){
			@Override
			public boolean onAreaTouched(final TouchEvent pSceneTouchEvent, final float pTouchAreaLocalX, final float pTouchAreaLocalY) {
				if(pSceneTouchEvent.getAction() == TouchEvent.ACTION_DOWN){
					checkOut();
				}
				return true;
			}
		};
		checkout.setScale(1.9f, .75f);
		
		checklable =  new Text(checkout.getX() - 22, checkout.getY() + 30,font3,"Checkout",new TextOptions(HorizontalAlign.LEFT), sm.engine.getVertexBufferObjectManager());
		
		pVendScene.attachChild(checkout);
		pVendScene.registerTouchArea(checkout);
		
		checkout2 =  new Sprite(cX + 350, cY + 1145, check2Reg, sm.activity.getVertexBufferObjectManager()){
			@Override
			public boolean onAreaTouched(final TouchEvent pSceneTouchEvent, final float pTouchAreaLocalX, final float pTouchAreaLocalY) {
				if(pSceneTouchEvent.getAction() == TouchEvent.ACTION_UP){
					pVendScene.detachChild(checkout);
					pVendScene.detachChild(checkout2);
					pVendScene.attachChild(checkout);
					pVendScene.unregisterTouchArea(checkout2);
					pVendScene.unregisterTouchArea(checkout);
					pVendScene.registerTouchArea(checkout);
					//label is currently layered behind, put it in front.
					pVendScene.detachChild(checklable);
					pVendScene.attachChild(checklable);
				}
				return true;
			}
		};
		checkout2.setScale(1.9f, .75f);
		
		pVendScene.attachChild(checklable);
		
		/*
		Sprite tLogo = new Sprite(0,0, logoReg, sm.activity.getVertexBufferObjectManager());
		tLogo.setScale(.115f);
		tLogo.setPosition((sm.camera.getWidth() - logoReg.getWidth())/2,   - sm.camera.getWidth() * .75f);
		pVendScene.attachChild(tLogo);
		*/
		
		door = new AnimatedSprite(cX + 200,  cY + 1150, doorReg, sm.activity.getVertexBufferObjectManager());
		door.setScale(.4f);
		pVendScene.attachChild(door);
		
		pCargo = new Sprite(0, cY + 1160, cargoReg, sm.activity.getVertexBufferObjectManager()){
			@Override
			public boolean onAreaTouched(final TouchEvent pSceneTouchEvent, final float pTouchAreaLocalX, final float pTouchAreaLocalY) {
				if(pSceneTouchEvent.getAction() == TouchEvent.ACTION_DOWN){
					pVendScene.unregisterTouchArea(pCargo);
					pVendScene.detachChild(pCargo);
				}
				return true;
			}
		};
		pCargo2 = new Sprite(0, cY + 1160, cargoReg, sm.activity.getVertexBufferObjectManager()){
			@Override
			public boolean onAreaTouched(final TouchEvent pSceneTouchEvent, final float pTouchAreaLocalX, final float pTouchAreaLocalY) {
				if(pSceneTouchEvent.getAction() == TouchEvent.ACTION_DOWN){
					pVendScene.unregisterTouchArea(pCargo2);
					pVendScene.detachChild(pCargo2);
				}
				return true;
			}
		};
		pCargo3 = new Sprite(0, cY + 1160, cargoReg, sm.activity.getVertexBufferObjectManager()){
			@Override
			public boolean onAreaTouched(final TouchEvent pSceneTouchEvent, final float pTouchAreaLocalX, final float pTouchAreaLocalY) {
				if(pSceneTouchEvent.getAction() == TouchEvent.ACTION_DOWN){
					pVendScene.unregisterTouchArea(pCargo3);
					pVendScene.detachChild(pCargo3);
				}
				return true;
			}
		};
		
		pHealth = new Sprite(0, cY + 1160, healthReg, sm.activity.getVertexBufferObjectManager()){
			@Override
			public boolean onAreaTouched(final TouchEvent pSceneTouchEvent, final float pTouchAreaLocalX, final float pTouchAreaLocalY) {
				if(pSceneTouchEvent.getAction() == TouchEvent.ACTION_DOWN){
					pVendScene.unregisterTouchArea(pHealth);
					pVendScene.detachChild(pHealth);
				}
				return true;
			}
		};
		pHealth2 = new Sprite(0, cY + 1160, healthReg, sm.activity.getVertexBufferObjectManager()){
			@Override
			public boolean onAreaTouched(final TouchEvent pSceneTouchEvent, final float pTouchAreaLocalX, final float pTouchAreaLocalY) {
				if(pSceneTouchEvent.getAction() == TouchEvent.ACTION_DOWN){
					pVendScene.unregisterTouchArea(pHealth2);
					pVendScene.detachChild(pHealth2);
				}
				return true;
			}
		};
				
		pHealth3 = new Sprite(0, cY + 1160, healthReg, sm.activity.getVertexBufferObjectManager()){
			@Override
			public boolean onAreaTouched(final TouchEvent pSceneTouchEvent, final float pTouchAreaLocalX, final float pTouchAreaLocalY) {
				if(pSceneTouchEvent.getAction() == TouchEvent.ACTION_DOWN){
					pVendScene.unregisterTouchArea(pHealth3);
					pVendScene.detachChild(pHealth3);
				}
				return true;
			}
		};
		
		pSpeed = new Sprite(0, cY + 1160, speedReg, sm.activity.getVertexBufferObjectManager()){
			@Override
			public boolean onAreaTouched(final TouchEvent pSceneTouchEvent, final float pTouchAreaLocalX, final float pTouchAreaLocalY) {
				if(pSceneTouchEvent.getAction() == TouchEvent.ACTION_DOWN){
					pVendScene.unregisterTouchArea(pSpeed);
					pVendScene.detachChild(pSpeed);
				}
				return true;
			}
		};
		pSpeed2 = new Sprite(0, cY + 1160, speedReg, sm.activity.getVertexBufferObjectManager()){
			@Override
			public boolean onAreaTouched(final TouchEvent pSceneTouchEvent, final float pTouchAreaLocalX, final float pTouchAreaLocalY) {
				if(pSceneTouchEvent.getAction() == TouchEvent.ACTION_DOWN){
					pVendScene.unregisterTouchArea(pSpeed2);
					pVendScene.detachChild(pSpeed2);
				}
				return true;
			}
		};
		pSpeed3 = new Sprite(0, cY + 1160, speedReg, sm.activity.getVertexBufferObjectManager()){
			@Override
			public boolean onAreaTouched(final TouchEvent pSceneTouchEvent, final float pTouchAreaLocalX, final float pTouchAreaLocalY) {
				if(pSceneTouchEvent.getAction() == TouchEvent.ACTION_DOWN){
					pVendScene.unregisterTouchArea(pSpeed3);
					pVendScene.detachChild(pSpeed3);
				}
				return true;
			}
		};
		
		
		
		//BE SURE TO UNREGISTER ONCE YOU HAVE A WAY TO LEAVE THE SCREEN
		tm = new TimerHandler(5f,new ITimerCallback(){
			public void onTimePassed(TimerHandler pTimerHandler){
				pVendScene.unregisterTouchArea(pCargo);
				pVendScene.detachChild(pCargo);
				pVendScene.unregisterTouchArea(pCargo2);
				pVendScene.detachChild(pCargo2);
				pVendScene.unregisterTouchArea(pCargo3);
				pVendScene.detachChild(pCargo3);
				pVendScene.unregisterTouchArea(pHealth);
				pVendScene.detachChild(pHealth);
				pVendScene.unregisterTouchArea(pHealth2);
				pVendScene.detachChild(pHealth2);
				pVendScene.unregisterTouchArea(pHealth3);
				pVendScene.detachChild(pHealth3);
				pVendScene.unregisterTouchArea(pSpeed);
				pVendScene.detachChild(pSpeed);
				pVendScene.unregisterTouchArea(pSpeed2);
				pVendScene.detachChild(pSpeed2);
				pVendScene.unregisterTouchArea(pSpeed3);
				pVendScene.detachChild(pSpeed3);
			}
		});
		sm.engine.registerUpdateHandler(tm); 
		
		// Back to Main Screen button
		Sprite backbutton = new Sprite(25, 25, backbuttonReg, sm.activity.getVertexBufferObjectManager()){
			@Override
			public boolean onAreaTouched(final TouchEvent pSceneTouchEvent,
				final float pTouchAreaLocalX, final float pTouchAreaLocalY) {
				Log.i("DEBUG", "EEEEEEEEEEEEEEEEEEEEEEEEEEEEEE");
				sm.setCurrentS(SceneManager.AllScenes.PERSISTANT);
				return true;
			}
		};
		backbutton.setPosition(sm.camera.getWidth()/2 - backbutton.getWidth()/2, 30 - backbutton.getHeight()/2);
		backbutton.setScale(0.3f);
		pVendScene.attachChild(backbutton);
		pVendScene.registerTouchArea(backbutton);
		
		return pVendScene;
	}
	
	public void click(AnimatedSprite sp, Boolean inc, Text te){
		if(inc){
			if(te==cargo && cVal < 99 && ((mVal + ts.getCargoBuyPrice()) <= ts.getMoney())){
				cVal++;
				te.setText("" + cVal);
				mVal += ts.getCargoBuyPrice();
				minus1.setCurrentTileIndex(1);
			}
			if(te == health && hVal < 99 && ts.getHealth() + hVal < 100 && ((mVal + ts.getHealthPrice()) <= ts.getMoney())){
				hVal++;
				te.setText("" + hVal);
				mVal += ts.getHealthPrice();
				minus3.setCurrentTileIndex(1);
			}
			if(te==speed && ts.getSpeed() + sVal < 20 && ((mVal + ts.getSpeedPrice()) <= ts.getMoney())){
				sVal++;
				te.setText(""+sVal);
				mVal += ts.getSpeedPrice();
				minus2.setCurrentTileIndex(1);
			}
			
			//see if any pluses need to turn red
			if(!(cVal < 99 && ((mVal + ts.getCargoBuyPrice()) <= ts.getMoney()))){
				plus1.setCurrentTileIndex(2);
			}
			if(!( hVal < 99 && ts.getHealth() + hVal < 100 && ((mVal + ts.getHealthPrice()) <= ts.getMoney()))){
				plus3.setCurrentTileIndex(2);
			}
			if(!( ts.getSpeed() + sVal < 20 && ((mVal + ts.getSpeedPrice()) <= ts.getMoney()))){
				plus2.setCurrentTileIndex(2);
			}
		}
		else{
			
			if(te==cargo && cVal > 0){
				cVal--;
				te.setText("" + cVal);
				mVal -= ts.getCargoBuyPrice();
				if(cVal < 1)
					sp.setCurrentTileIndex(3);
			}
			if(te == health && hVal > 0){
				hVal--;
				te.setText("" + hVal);
				mVal -= ts.getHealthPrice();
				if(hVal < 1)
					sp.setCurrentTileIndex(3);
			}
			if(te==speed && sVal > 0){
				sVal--;
				te.setText(""+sVal);
				mVal -= ts.getSpeedPrice();
				if(sVal < 1)
					sp.setCurrentTileIndex(3);
			}
			
			//see if any pluses need to turn blue
			if(cVal < 99 && ((mVal + ts.getCargoBuyPrice()) <= ts.getMoney())){
				plus1.setCurrentTileIndex(0);
			}
			if( hVal < 99 && ts.getHealth() + hVal < 100 && ((mVal + ts.getHealthPrice()) <= ts.getMoney())){
				plus3.setCurrentTileIndex(0);
			}
			if(ts.getSpeed() + sVal < 20 && ((mVal + ts.getSpeedPrice()) <= ts.getMoney())){
				plus2.setCurrentTileIndex(0);
			}
			
		}
		money.setText(""+mVal + "g");
	}
	
	public void checkOut(){
		tm.reset();
		
		pVendScene.unregisterTouchArea(pCargo);
		pVendScene.detachChild(pCargo);
		pVendScene.unregisterTouchArea(pCargo2);
		pVendScene.detachChild(pCargo2);
		pVendScene.unregisterTouchArea(pCargo3);
		pVendScene.detachChild(pCargo3);
		pVendScene.unregisterTouchArea(pHealth);
		pVendScene.detachChild(pHealth);
		pVendScene.unregisterTouchArea(pHealth2);
		pVendScene.detachChild(pHealth2);
		pVendScene.unregisterTouchArea(pHealth3);
		pVendScene.detachChild(pHealth3);
		pVendScene.unregisterTouchArea(pSpeed);
		pVendScene.detachChild(pSpeed);
		pVendScene.unregisterTouchArea(pSpeed2);
		pVendScene.detachChild(pSpeed2);
		pVendScene.unregisterTouchArea(pSpeed3);
		pVendScene.detachChild(pSpeed3);
		
		pVendScene.detachChild(checkout);
		//just to be safe
		pVendScene.detachChild(checkout2);
		pVendScene.attachChild(checkout2);
		pVendScene.unregisterTouchArea(checkout2);
		pVendScene.unregisterTouchArea(checkout);
		pVendScene.registerTouchArea(checkout2);
		//label is currently layered behind, put it in front.
		pVendScene.detachChild(checklable);
		pVendScene.attachChild(checklable);
		
		
		
		long time[] = {100,200,100};
		int frame[] = {0,1,0};
		door.animate(time,frame,false);
		ts.setMoney(ts.getMoney() - mVal);
		ts.setCargo(ts.getCargo() + cVal);
		ts.setSpeed(ts.getSpeed() + sVal);
		ts.setHealth(ts.getHealth() + hVal);
		
		if (cVal > 0){
			float j = r.nextFloat() * .4f + .09f;
			pCargo.setScale(.3f);
			pCargo.setX(sm.camera.getWidth() * j);
			pVendScene.attachChild(pCargo);
			pVendScene.registerTouchArea(pCargo);
		}
		if(hVal > 0){
			float j = r.nextFloat() * .4f + .09f;
			pHealth.setScale(.3f);
			pHealth.setX(sm.camera.getWidth() * j);
			pVendScene.attachChild(pHealth);
			pVendScene.registerTouchArea(pHealth);
		}
		if(sVal > 0){
			float j = r.nextFloat() * .4f + .09f;
			pSpeed.setScale(.3f);
			pSpeed.setX(sm.camera.getWidth() * j);
			pVendScene.attachChild(pSpeed);
			pVendScene.registerTouchArea(pSpeed);
		}
		if (cVal > 1){
			float j = r.nextFloat() * .4f + .09f;
			pCargo2.setScale(.3f);
			pCargo2.setX(sm.camera.getWidth() * j);
			pVendScene.attachChild(pCargo2);
			pVendScene.registerTouchArea(pCargo2);
		}
		if(hVal > 1){
			float j = r.nextFloat() * .4f + .09f;
			pHealth2.setScale(.3f);
			pHealth2.setX(sm.camera.getWidth() * j);
			pVendScene.attachChild(pHealth2);
			pVendScene.registerTouchArea(pHealth2);
		}
		if(sVal > 1){
			float j = r.nextFloat() * .4f + .09f;
			pSpeed2.setScale(.3f);
			pSpeed2.setX(sm.camera.getWidth() * j);
			pVendScene.attachChild(pSpeed2);
			pVendScene.registerTouchArea(pSpeed2);
		}
		if (cVal > 2){
			float j = r.nextFloat() * .4f + .09f;
			pCargo3.setScale(.3f);
			pCargo3.setX(sm.camera.getWidth() * j);
			pVendScene.attachChild(pCargo3);
			pVendScene.registerTouchArea(pCargo3);
		}
		
		if(hVal > 2){
			float j = r.nextFloat() * .4f + .09f;
			pHealth3.setScale(.3f);
			pHealth3.setX(sm.camera.getWidth() * j);
			pVendScene.attachChild(pHealth3);
			pVendScene.registerTouchArea(pHealth3);
		}
		if(sVal > 2){
			float j = r.nextFloat() * .4f + .09f;
			pSpeed3.setScale(.3f);
			pSpeed3.setX(sm.camera.getWidth() * j);
			pVendScene.attachChild(pSpeed3);
			pVendScene.registerTouchArea(pSpeed3);
		}
		
		mVal = 0;
		cVal = 0;
		hVal = 0;
		sVal = 0;
		money.setText(""+mVal+"g");
		cargo.setText(""+cVal);
		health.setText(""+hVal);
		speed.setText(""+sVal);
		
		minus1.setCurrentTileIndex(3);
		minus2.setCurrentTileIndex(3);
		minus3.setCurrentTileIndex(3);
	}
}
