package persistantgame;

import java.util.Calendar;
import java.util.Random;

import org.andengine.entity.primitive.Rectangle;
import org.andengine.entity.scene.Scene;
import org.andengine.entity.scene.background.SpriteBackground;
import org.andengine.entity.sprite.AnimatedSprite;
import org.andengine.entity.sprite.Sprite;
import org.andengine.entity.text.Text;
import org.andengine.entity.text.TextOptions;
import org.andengine.input.touch.TouchEvent;
import org.andengine.opengl.font.Font;
import org.andengine.opengl.font.FontFactory;
import org.andengine.opengl.texture.atlas.bitmap.BitmapTextureAtlas;
import org.andengine.opengl.texture.atlas.bitmap.BitmapTextureAtlasTextureRegionFactory;
import org.andengine.opengl.texture.region.ITextureRegion;
import org.andengine.opengl.texture.region.TiledTextureRegion;
import org.andengine.util.HorizontalAlign;

import android.graphics.Color;
import android.graphics.Typeface;
import android.util.Log;

import com.example.traingame.SceneManager;
import com.example.traingame.Setup;

import events.EventsManager;

public class persistantSetup extends Setup {

	private int health;
	private int speed;
	private int cargo;
	private int money;
	private int distance;

	private Text healthText;
	private Text speedText;
	private Text cargoText;
	private Text moneyText;
	private Text distanceText;

	private Text eventText;
	private String eventName;
	private events.Event currentEvent = null;

	private BitmapTextureAtlas shopButtonTA;
	private ITextureRegion shopButtonReg;

	private BitmapTextureAtlas backButtonTA;
	private ITextureRegion backButtonReg;

	private BitmapTextureAtlas backgroundTA;
	private ITextureRegion backgroundReg;

	private BitmapTextureAtlas treesTA;
	private TiledTextureRegion treesTR;

	private BitmapTextureAtlas cloudsTA;
	private TiledTextureRegion cloudsTR;

	private BitmapTextureAtlas trainTA;
	private TiledTextureRegion trainTR;

	private BitmapTextureAtlas healthIconTA;
	private ITextureRegion healthIconReg;

	private BitmapTextureAtlas moneyIconTA;
	private ITextureRegion moneyIconReg;

	private BitmapTextureAtlas speedIconTA;
	private ITextureRegion speedIconReg;

	private BitmapTextureAtlas cargoIconTA;
	private ITextureRegion cargoIconReg;

	private BitmapTextureAtlas distanceIconTA;
	private ITextureRegion distanceIconReg;

	private String treesSheet = "tree background.png";
	private String cloudsSheet = "cloud background.png";
	private String trainSheet = "train car 1 sheet.png";

	private String healthIcon = "health icon copy.png";
	private String moneyIcon = "money icon copy.png";
	private String speedIcon = "speed icon copy.png";
	private String cargoIcon = "train cargo copy.png";
	private String distanceIcon = "distance icon copy.png";

	private AnimatedSprite treeSprite;
	private AnimatedSprite cloudSprite;
	private AnimatedSprite trainSprite;

	private Font mFont;
	private Font mFont2;

	TrainStats statsInstance;

	private long timeStamp;
	private long currentTime;
	private long timeDiff;
	private long resetTimer;

	private int boxheight;

	public persistantSetup(SceneManager SM) {
		this.sm = SM;
		eventName = "";
	}

	public void load() {
		statsInstance = TrainStats.getInstance();
		resetStats();
		health = statsInstance.getHealth();
		speed = statsInstance.getSpeed();
		cargo = statsInstance.getCargo();
		money = statsInstance.getMoney();
		distance = statsInstance.getDistance();

		timeStamp = statsInstance.getUpdateTimeStamp();
		currentTime = System.nanoTime();
		timeDiff = (currentTime - timeStamp) / 1000000000;
		statsInstance.setUpdateTimeStamp(currentTime);

		BitmapTextureAtlasTextureRegionFactory
				.setAssetBasePath("gfx/persistant/");

		mFont = FontFactory.create(this.sm.engine.getFontManager(),
				this.sm.engine.getTextureManager(), 256, 256,
				Typeface.create(Typeface.DEFAULT, Typeface.BOLD), 40, true,
				Color.YELLOW);
		mFont.load();
		mFont2 = FontFactory.create(this.sm.engine.getFontManager(),
				this.sm.engine.getTextureManager(), 256, 256,
				Typeface.create(Typeface.DEFAULT, Typeface.BOLD), 20, true,
				Color.YELLOW);
		mFont2.load();

		backgroundTA = new BitmapTextureAtlas(sm.activity.getTextureManager(),
				2048, 2048);
		backgroundReg = BitmapTextureAtlasTextureRegionFactory.createFromAsset(
				backgroundTA, sm.activity, "generic bw background.png", 0, 0);
		backgroundTA.load();

		// shop button
		shopButtonTA = new BitmapTextureAtlas(sm.activity.getTextureManager(),
				512, 256);
		shopButtonReg = BitmapTextureAtlasTextureRegionFactory.createFromAsset(
				shopButtonTA, sm.activity, "store button.png", 0, 0);
		shopButtonTA.load();

		backButtonTA = new BitmapTextureAtlas(sm.activity.getTextureManager(),
				512, 256);
		backButtonReg = BitmapTextureAtlasTextureRegionFactory.createFromAsset(
				backButtonTA, sm.activity, "back button.png", 0, 0);
		backButtonTA.load();

		healthIconTA = new BitmapTextureAtlas(sm.activity.getTextureManager(),
				64, 64);
		healthIconReg = BitmapTextureAtlasTextureRegionFactory.createFromAsset(
				healthIconTA, sm.activity, healthIcon, 0, 0);
		healthIconTA.load();

		moneyIconTA = new BitmapTextureAtlas(sm.activity.getTextureManager(),
				64, 64);
		moneyIconReg = BitmapTextureAtlasTextureRegionFactory.createFromAsset(
				moneyIconTA, sm.activity, moneyIcon, 0, 0);
		moneyIconTA.load();

		speedIconTA = new BitmapTextureAtlas(sm.activity.getTextureManager(),
				64, 64);
		speedIconReg = BitmapTextureAtlasTextureRegionFactory.createFromAsset(
				speedIconTA, sm.activity, speedIcon, 0, 0);
		speedIconTA.load();

		cargoIconTA = new BitmapTextureAtlas(sm.activity.getTextureManager(),
				64, 64);
		cargoIconReg = BitmapTextureAtlasTextureRegionFactory.createFromAsset(
				cargoIconTA, sm.activity, cargoIcon, 0, 0);
		cargoIconTA.load();

		distanceIconTA = new BitmapTextureAtlas(
				sm.activity.getTextureManager(), 64, 64);
		distanceIconReg = BitmapTextureAtlasTextureRegionFactory
				.createFromAsset(distanceIconTA, sm.activity, distanceIcon, 0,
						0);
		distanceIconTA.load();

		treesTA = new BitmapTextureAtlas(sm.activity.getTextureManager(), 2048,
				2048);
		treesTR = BitmapTextureAtlasTextureRegionFactory.createTiledFromAsset(
				treesTA, sm.activity.getAssets(), treesSheet, 0, 0, 3, 2);
		treesTA.load();

		cloudsTA = new BitmapTextureAtlas(sm.activity.getTextureManager(),
				2048, 2048);
		cloudsTR = BitmapTextureAtlasTextureRegionFactory.createTiledFromAsset(
				cloudsTA, sm.activity.getAssets(), cloudsSheet, 0, 0, 3, 2);
		cloudsTA.load();

		trainTA = new BitmapTextureAtlas(sm.activity.getTextureManager(), 1024,
				2048);
		trainTR = BitmapTextureAtlasTextureRegionFactory.createTiledFromAsset(
				trainTA, sm.activity.getAssets(), trainSheet, 0, 0, 1, 6);
		trainTA.load();
	}

	public Scene create() {
		boxheight = 2;
		Scene persistantScene = new Scene();
		int cX = (int) (sm.camera.getWidth() - backgroundReg.getWidth()) / 2;
		int cY = (int) (sm.camera.getHeight() - backgroundReg.getHeight()) / 2;
		Sprite bgSprite = new Sprite(cX, cY, backgroundReg,
				sm.activity.getVertexBufferObjectManager());
		bgSprite.setScaleX(sm.camera.getWidth() / bgSprite.getWidth());
		bgSprite.setScaleY(sm.camera.getHeight() / bgSprite.getHeight());
		SpriteBackground bg = new SpriteBackground(bgSprite);
		persistantScene.setBackground(bg);

		updateStats();

		cloudSprite = new AnimatedSprite(0, 0, cloudsTR,
				sm.activity.getVertexBufferObjectManager());
		cloudSprite.setScaleX(sm.camera.getWidth() / cloudSprite.getWidth());
		cloudSprite.setPosition(
				(sm.camera.getWidth() - cloudSprite.getWidth()) / 2, 0);
		persistantScene.attachChild(cloudSprite);
		cloudSprite.animate(1000);

		treeSprite = new AnimatedSprite(0, 0, treesTR,
				sm.activity.getVertexBufferObjectManager());
		treeSprite.setScaleX(sm.camera.getWidth() / treeSprite.getWidth());
		treeSprite.setPosition(
				(sm.camera.getWidth() - treeSprite.getWidth()) / 2, 0);
		persistantScene.attachChild(treeSprite);
		treeSprite.animate(200);

		trainSprite = new AnimatedSprite(0, 0, trainTR,
				sm.activity.getVertexBufferObjectManager());
		trainSprite.setScale(sm.camera.getWidth() / trainSprite.getWidth());
		trainSprite.setPosition(
				(sm.camera.getWidth() - trainSprite.getWidth()) / 2,
				(treeSprite.getHeight() - trainSprite.getHeight()));
		persistantScene.attachChild(trainSprite);
		trainSprite.animate(100);

		Sprite shopButton = new Sprite(100, 100, shopButtonReg,
				sm.activity.getVertexBufferObjectManager()) {
			@Override
			public boolean onAreaTouched(final TouchEvent pSceneTouchEvent,
					final float pTouchAreaLocalX, final float pTouchAreaLocalY) {
				sm.setCurrentS(SceneManager.AllScenes.PERSVEND);
				return true;
			}
		};
		shopButton.setScale(0.5f);
		shopButton.setPosition(
				(sm.camera.getWidth() * 4 / 5 - shopButton.getWidth() / 2),
				(sm.camera.getHeight() * 7 / 8 - shopButton.getHeight() / 2));
		persistantScene.attachChild(shopButton);
		persistantScene.registerTouchArea(shopButton);

		Sprite backButton = new Sprite(100, 100, backButtonReg,
				sm.activity.getVertexBufferObjectManager()) {
			@Override
			public boolean onAreaTouched(final TouchEvent pSceneTouchEvent,
					final float pTouchAreaLocalX, final float pTouchAreaLocalY) {
				sm.activity.finish();
				return true;
			}
		};
		backButton.setScale(0.5f);
		backButton.setPosition(
				(sm.camera.getWidth() * 1 / 3 - backButton.getWidth()),
				(sm.camera.getHeight() * 7 / 8 - backButton.getHeight() / 2));
		persistantScene.attachChild(backButton);
		persistantScene.registerTouchArea(backButton);

		healthText = new Text(sm.camera.getWidth() * 1 / 3,
				sm.camera.getHeight() * 5 / 10, mFont, "Health: " + health,
				new TextOptions(HorizontalAlign.CENTER),
				this.sm.engine.getVertexBufferObjectManager());
		persistantScene.attachChild(healthText);

		Sprite healthImg = new Sprite(0, 0, healthIconReg,
				sm.activity.getVertexBufferObjectManager());
		healthImg.setPosition(
				sm.camera.getWidth() * 1 / 3 - healthImg.getWidth(),
				sm.camera.getHeight() * 5 / 10);
		persistantScene.attachChild(healthImg);

		speedText = new Text(sm.camera.getWidth() * 1 / 3,
				sm.camera.getHeight() * 6 / 10, mFont, "Speed: " + speed,
				new TextOptions(HorizontalAlign.CENTER),
				this.sm.engine.getVertexBufferObjectManager());
		persistantScene.attachChild(speedText);

		Sprite speedImg = new Sprite(0, 0, speedIconReg,
				sm.activity.getVertexBufferObjectManager());
		speedImg.setPosition(
				sm.camera.getWidth() * 1 / 3 - speedImg.getWidth(),
				sm.camera.getHeight() * 6 / 10);
		persistantScene.attachChild(speedImg);

		cargoText = new Text(sm.camera.getWidth() * 1 / 3,
				sm.camera.getHeight() * 7 / 10, mFont, "Cargo: " + cargo,
				new TextOptions(HorizontalAlign.CENTER),
				this.sm.engine.getVertexBufferObjectManager());
		persistantScene.attachChild(cargoText);

		Sprite cargoImg = new Sprite(0, 0, cargoIconReg,
				sm.activity.getVertexBufferObjectManager());
		cargoImg.setPosition(
				sm.camera.getWidth() * 1 / 3 - cargoImg.getWidth(),
				sm.camera.getHeight() * 7 / 10);
		persistantScene.attachChild(cargoImg);

		moneyText = new Text(sm.camera.getWidth() * 1 / 3,
				sm.camera.getHeight() * 8 / 10, mFont, "Money: " + money,
				new TextOptions(HorizontalAlign.CENTER),
				this.sm.engine.getVertexBufferObjectManager());
		persistantScene.attachChild(moneyText);

		Sprite moneyImg = new Sprite(0, 0, moneyIconReg,
				sm.activity.getVertexBufferObjectManager());
		moneyImg.setPosition(
				sm.camera.getWidth() * 1 / 3 - moneyImg.getWidth(),
				sm.camera.getHeight() * 8 / 10);
		persistantScene.attachChild(moneyImg);

		distanceText = new Text(sm.camera.getWidth() * 1 / 3,
				sm.camera.getHeight() * 9 / 10, mFont, "Distance: " + distance,
				new TextOptions(HorizontalAlign.CENTER),
				this.sm.engine.getVertexBufferObjectManager());
		persistantScene.attachChild(distanceText);

		Sprite distanceImg = new Sprite(0, 0, distanceIconReg,
				sm.activity.getVertexBufferObjectManager());
		distanceImg.setPosition(
				sm.camera.getWidth() * 1 / 3 - distanceImg.getWidth(),
				sm.camera.getHeight() * 9 / 10);
		persistantScene.attachChild(distanceImg);

		Rectangle r = new Rectangle(0, 0, sm.camera.getWidth(),
				20 * boxheight + 10, sm.activity.getVertexBufferObjectManager());
		r.setColor(0, 0, 0);
		persistantScene.attachChild(r);

		Log.i("Testing", "The event name is: " + eventName);
		eventText = new Text(0, 0, mFont2, eventName, new TextOptions(
				HorizontalAlign.LEFT), sm.engine.getVertexBufferObjectManager());
		persistantScene.attachChild(eventText);

		return persistantScene;
	}

	private void updateStats() {

		statsInstance = TrainStats.getInstance();
		health = statsInstance.getHealth();
		speed = statsInstance.getSpeed();
		cargo = statsInstance.getCargo();
		money = statsInstance.getMoney();
		distance = statsInstance.getDistance();

		timeStamp = statsInstance.getUpdateTimeStamp();
		currentTime = System.nanoTime();
		timeDiff = (currentTime - timeStamp) / 1000000000;
		statsInstance.setUpdateTimeStamp(currentTime);
		long i = timeDiff;

		// New Events every turn
		if (i > 60) {
			if (currentEvent != null) {
				currentEvent.deactivate();
			}
			Random rand = new Random();
			rand.setSeed(System.nanoTime());
			if (rand.nextInt(8) < 3) {
				// Succeed to get an event
				currentEvent = EventsManager.getInstance().getRandomEvent();
				String result = "";

				int length = currentEvent.getContent().length();
				int index = (int) (sm.camera.getHeight() / 10);
				int is = 0;
				while (index < length) {
					result = result
							+ currentEvent.getContent().substring(is, index)
							+ "\n";
					is = index;
					index = index + 50;
					boxheight++;
				}
				result = result + currentEvent.getContent().substring(is);

				eventName = currentEvent.getTitle() + "\n" + result;
				currentEvent.activate();
			} else {
				// Failed to get an event
				currentEvent = null;
				boxheight = 2;
				eventName = "Sorry, you failed to get an event\nNext Time!";
			}
		}

		while (i > 60 && health > 0) {

			health -= speed;
			money += cargo;
			distance += speed;
			i = i - 60;
		}
		statsInstance.setHealth(health);
		statsInstance.setMoney(money);
		statsInstance.setDistance(distance);

	}

	private void resetStats() {

		resetTimer = statsInstance.getResetTimeStamp();
		Calendar calendar = Calendar.getInstance();
		int day = calendar.get(Calendar.DAY_OF_WEEK);
		if ((currentTime - resetTimer) / 1000000000 > 604800) {
			statsInstance.startNewGame();
		} else if (day == 2 && (currentTime - resetTimer) / 1000000000 > 86400) {
			statsInstance.startNewGame();
		}

	}

}
