package potatogame;

import org.andengine.engine.handler.timer.ITimerCallback;
import org.andengine.engine.handler.timer.TimerHandler;
import org.andengine.entity.scene.Scene;
import org.andengine.entity.scene.background.Background;
import org.andengine.entity.sprite.Sprite;
import org.andengine.opengl.texture.atlas.bitmap.BitmapTextureAtlas;
import org.andengine.opengl.texture.atlas.bitmap.BitmapTextureAtlasTextureRegionFactory;
import org.andengine.opengl.texture.region.ITextureRegion;

import com.example.traingame.SceneManager;
import com.example.traingame.Setup;

public class PNextSetup extends Setup{

	private BitmapTextureAtlas nextTA;
	private ITextureRegion nextTR;
	
	public PNextSetup(SceneManager SM){
		this.sm = SM;
	}
	
	@Override
	public void load(){
		BitmapTextureAtlasTextureRegionFactory.setAssetBasePath("gfx/");
		nextTA = new BitmapTextureAtlas(sm.activity.getTextureManager(),
				2048, 2048);
		nextTR = BitmapTextureAtlasTextureRegionFactory.createFromAsset(
				nextTA, sm.activity, "next round.png", 0, 0);
		nextTA.load();
	}
	
	@Override
	public Scene create(){
		Scene nextScene = new Scene();
		nextScene.setBackground(new Background(100,0,255));
		
		Sprite sIcon = new Sprite(0,0,nextTR,sm.engine.getVertexBufferObjectManager());
		sIcon.setPosition((sm.camera.getWidth() - sIcon.getWidth())/2, (sm.camera.getHeight() - sIcon.getHeight())/2);
		sIcon.setScale(sm.camera.getWidth()/sIcon.getWidth(), sm.camera.getHeight()/sIcon.getHeight());
		nextScene.attachChild(sIcon);
		sm.engine.registerUpdateHandler(new TimerHandler(1.5f,new ITimerCallback(){
			public void onTimePassed(TimerHandler pTimerHandler){
				sm.engine.unregisterUpdateHandler(pTimerHandler);
				sm.setCurrentS(SceneManager.AllScenes.POTATO);
			}
		})); 
		return nextScene;
	}
}
