package potatogame;

import org.andengine.engine.handler.timer.ITimerCallback;
import org.andengine.engine.handler.timer.TimerHandler;
import org.andengine.entity.scene.Scene;
import org.andengine.entity.scene.background.Background;
import org.andengine.entity.sprite.Sprite;
import org.andengine.opengl.texture.atlas.bitmap.BitmapTextureAtlas;
import org.andengine.opengl.texture.atlas.bitmap.BitmapTextureAtlasTextureRegionFactory;
import org.andengine.opengl.texture.region.ITextureRegion;

import persistantgame.TrainStats;

import android.content.SharedPreferences;

import com.example.traingame.SceneManager;
import com.example.traingame.Setup;

import database.DBProtocolC;

public class pWinSetup extends Setup{

	private BitmapTextureAtlas winTA;
	private ITextureRegion winTR;
	
	public pWinSetup(SceneManager SM){
		this.sm = SM;
	}
	
	@Override
	public void load(){
		BitmapTextureAtlasTextureRegionFactory.setAssetBasePath("gfx/");
		winTA = new BitmapTextureAtlas(sm.activity.getTextureManager(),
				2048, 2048);
		winTR = BitmapTextureAtlasTextureRegionFactory.createFromAsset(
				winTA, sm.activity, "landscape win.png", 0, 0);
		winTA.load();
	}
	
	@Override
	public Scene create(){
		Scene winScene = new Scene();
		winScene.setBackground(new Background(255,255,0));
		
		Sprite sIcon = new Sprite(0,0,winTR,sm.engine.getVertexBufferObjectManager());
		sIcon.setPosition((sm.camera.getWidth() - sIcon.getWidth())/2, (sm.camera.getHeight() - sIcon.getHeight())/2);
		sIcon.setScale(sm.camera.getWidth()/sIcon.getWidth(), sm.camera.getHeight()/sIcon.getHeight());
		winScene.attachChild(sIcon);
		int rounds = sm.getPotatosetup().getSurvivedPrev();
		TrainStats ts = TrainStats.getInstance();
		ts.setMoney(ts.getMoney() + (rounds * 15));
		SharedPreferences sp = sm.activity.getSharedPreferences("currentUser", 0);
		String UID = sp.getString("uid", "");
		/*DBProtocolC.connectToDB();
		DBProtocolC.updateUserScore(UID, DBProtocolC.getUserScore(UID) + (rounds * 15));
		DBProtocolC.storeScore(UID, "1", "" + (rounds * 15));
		DBProtocolC.close();*/
		sm.engine.registerUpdateHandler(new TimerHandler(3f,new ITimerCallback(){
			public void onTimePassed(TimerHandler pTimerHandler){
				sm.engine.unregisterUpdateHandler(pTimerHandler);
				sm.activity.finish();
			}
		})); 
		return winScene;
	}
}
