package potatogame;

import java.util.Random;

import org.andengine.engine.handler.IUpdateHandler;
import org.andengine.engine.handler.timer.ITimerCallback;
import org.andengine.engine.handler.timer.TimerHandler;
import org.andengine.entity.scene.Scene;
import org.andengine.entity.sprite.AnimatedSprite;
import org.andengine.entity.sprite.Sprite;
import org.andengine.input.touch.TouchEvent;

import android.util.Log;

import com.example.traingame.SceneManager;

public class passHandler{

	private enum animations{
		STANDING,FALLING,CATCHING,HOLDING,THROWING;
	}
	
	private int PO_FRAMES = 2;
	
	//the index of the highest player (so people not counting the client)
	private int numPlay = 5;
	//current player. the highest number is the client. 
	//In single player mode the potato starts with them
	private int curPlay = numPlay;
	private int nextPlay = -1;
	//list of all sprites, the potato will be first
	private AnimatedSprite sprites[]; 
	//used to figure out how much the potato should move if updated.
	//they reflect the total amount it will move in NUMUPDATES.
	private int NUMUPDATES = 80;
	private float dx = 0;
	private float dy = 0;
	private Scene game;
	private int curUpdates = 0;
	private boolean passComplete = true;
	private boolean justComplete = true;
	private float potatoPos[][] = new float[numPlay + 1][2];
	private boolean timeup = false;
	private timerHandler TM;
	private boolean swipeable = true;
	private float sStartx = -1;
	private float sStarty = -1;
	private SceneManager SM;
	private double atans[] = new double[numPlay];
	
	private int catchPause = 0;
	private int pauseDuration = 60;
	private int usernums[] = {1,2,3,4,5,6};

	private potatoSetup ps;
	private Boolean passPacketRecieved = false;
	private AnimatedSprite ex = null;
	private potatoClient pc;
	private Integer GameI;
	
	Random R = new Random();
	
	public passHandler(AnimatedSprite spr[], Scene g, float pos[][], SceneManager sm, int np, int cp, potatoSetup PS, int[] unums, Integer gi){
		numPlay = np;
		curPlay = cp;
		sprites = spr;
		game = g;
		potatoPos = pos;
		SM = sm;
		usernums = unums;
		ps = PS;
		pc = new potatoClient(ps);
		pc.setCur(unums[curPlay]);
		GameI = gi;
		PacketInt first = new PacketInt();
		first.i = 2;
		first.gid = GameI;
		pc.pclient.sendTCP(first);
		createDeltas();
		for(int i = 1; i <= numPlay + 1; i++){
			animatePl(sprites[i],animations.STANDING);
		}
		animatePl(sprites[curPlay + 1], animations.HOLDING);
		TM = new timerHandler(this,sm, PS, gi);
		game.registerUpdateHandler(new IUpdateHandler(){
			@Override
			public void onUpdate(float pSecondsElapsed){
				if(timeup){
					game.unregisterUpdateHandler(this);
				}
				if(passComplete){
					if(nextPlay >= 0){
						curPlay = nextPlay;
						if(catchPause == 0){
							animatePl(sprites[curPlay + 1], animations.HOLDING);
						}
					}
					if(justComplete){
						justComplete = false;
						if(!(curPlay == numPlay)){
							swipeable = false;
							catchPause++;
							if(catchPause == pauseDuration - 17){
								/*animatePl(sprites[curPlay + 1], animations.THROWING);
								if(curPlay == 0 || curPlay == 2 || curPlay == 3){
									sprites[0].setY(sprites[0].getY() - sprites[0].getHeight() * .1f);
								}
								if(curPlay == 1 || curPlay == 3 || curPlay == 5){
									sprites[0].setY(sprites[0].getY() + sprites[0].getHeight() * .1f);
								}
								if(curPlay == 4 || curPlay == 1){
									sprites[0].setX(sprites[0].getX() - sprites[0].getWidth() * .1f);
								}
								if(curPlay == 3 || curPlay == 2){
									sprites[0].setX(sprites[0].getX() + sprites[0].getWidth() * .1f);
								}*/
							}
							
							if(catchPause == pauseDuration){
								catchPause = 0;
								/*if(curPlay == 0 || curPlay == 2 || curPlay == 4){
									sprites[0].setY(sprites[0].getY() + sprites[0].getHeight() * .1f);
								}
								if(curPlay == 1 || curPlay == 3 || curPlay == 5){
									sprites[0].setY(sprites[0].getY() - sprites[0].getHeight() * .1f);
								}
								if(curPlay == 4 || curPlay == 1){
									sprites[0].setX(sprites[0].getX() +sprites[0].getWidth() * .1f);
								}
								if(curPlay == 3 || curPlay == 2){
									sprites[0].setX(sprites[0].getX() -sprites[0].getWidth() * .1f);
								}
								animatePl(sprites[curPlay + 1], animations.STANDING);*/
							}
						}
						else{
							swipeable = true;
							TM.countDown();
						}
					}
				}
				else{
					if(passPacketRecieved || curPlay == numPlay){
						float nx = (float)(sprites[0].getX() + (dx/NUMUPDATES));
						float ny = (float)(sprites[0].getY() + (dy/NUMUPDATES));
						sprites[0].setRotation(sprites[0].getRotation() + 5);
						
						sprites[0].setPosition(nx, ny);
						if(curUpdates == NUMUPDATES - 25){
							animatePl(sprites[curPlay + 1], animations.THROWING);
							if(curPlay == 0 || curPlay == 2 || curPlay == 3){
								sprites[0].setY(sprites[0].getY() - sprites[0].getHeight() * .1f);
							}
							if(curPlay == 1 || curPlay == 3 || curPlay == 5){
								sprites[0].setY(sprites[0].getY() + sprites[0].getHeight() * .1f);
							}
							if(curPlay == 4 || curPlay == 1){
								sprites[0].setX(sprites[0].getX() - sprites[0].getWidth() * .1f);
							}
							if(curPlay == 3 || curPlay == 2){
								sprites[0].setX(sprites[0].getX() + sprites[0].getWidth() * .1f);
							}
							
							animatePl(sprites[nextPlay + 1], animations.CATCHING);
							
						}
						curUpdates++;
						if(curUpdates == NUMUPDATES){
							animatePl(sprites[nextPlay + 1], animations.HOLDING);
							passComplete = true;
							justComplete = true;
							passPacketRecieved = false;
							curUpdates = 0;
						}
					}
				}
			}
			@Override
			public void reset(){
				
			}
		});
	}
	
	private void createDeltas(){
		float player[] = potatoPos[numPlay];
		for (int i = 0; i < numPlay; i++){
			
			float xd = potatoPos[i][0] - player[0];
			//since for y down is positive.
			float yd = player[1] - potatoPos[i][1];
			atans[i] = Math.atan2(yd, xd);
		}
		
	}
	
	private void calcPass(){
		passComplete = false;
		int ran = R.nextInt(numPlay);
		if(ran >= curPlay)
			ran++;
		float curX = sprites[0].getX();
		float curY = sprites[0].getY();
		float nexX = potatoPos[ran][0];
		float nexY = potatoPos[ran][1];
		dx =  nexX - curX;
		dy = nexY - curY;
		nextPlay = ran;
		
	}
	
	private void calcSwipe(float sX, float sY, float eX, float eY){
		TM.passed();
		passComplete = false;
		float delX =  eX - sX;
		//since up is negative.
		float delY = sY - eY;
		double atan = Math.atan2(delY, delX);
		
		float minDiff = 1000;
		int play = -1;
		for(int i = 0; i < numPlay; i++){
			float diff = Math.abs((float)(atan - atans[i]));
			if(diff < minDiff){
				minDiff = diff;
				play = i;
			}
		}
		
		float curX = sprites[0].getX();
		float curY = sprites[0].getY();
		float nexX = potatoPos[play][0];
		float nexY = potatoPos[play][1];
		dx =  nexX - curX;
		dy = nexY - curY;
		nextPlay = play;
		
		PacketInt pi = new PacketInt();
		String temp = "3" + usernums[curPlay] + usernums[nextPlay];
		Integer temp2 = Integer.parseInt(temp);
		pi.i = temp2.intValue();
		pi.gid = GameI;
		pc.pclient.sendTCP(pi);
		
		
		//ensure that holding has already registered.
		TimerHandler tm = new TimerHandler(.05f,new ITimerCallback(){
			public void onTimePassed(TimerHandler pTimerHandler){
				SM.engine.unregisterUpdateHandler(pTimerHandler);
				animatePl(sprites[curPlay + 1], animations.THROWING);
			}
		});
		TimerHandler tm2 = new TimerHandler(.5f,new ITimerCallback(){
			public void onTimePassed(TimerHandler pTimerHandler){
				SM.engine.unregisterUpdateHandler(pTimerHandler);
				animatePl(sprites[curPlay + 1], animations.STANDING);
			}
		});
		SM.engine.registerUpdateHandler(tm);
		SM.engine.registerUpdateHandler(tm2);
	}
	
	public void timeUp(){
		timeup = true;
	}
	
	public int getCur(){
		if(curUpdates >= (NUMUPDATES - 25)){
			curPlay = nextPlay;
		}
		return curPlay;
	}
	
	public int getNum(){
		return numPlay;
	}
	
	public void pTapped(float xTap, float yTap, Sprite sp){
		if(swipeable){
			sStartx = sp.getX() + xTap;
			sStarty = sp.getY() + yTap;
		}
		else{
			sStartx = -1;
			sStarty = -1;
		}
	}

	public boolean onSceneTouchEvent(Scene pScene, TouchEvent event) {
		if(!(sStartx == -1 || sStarty == -1)){
			if(event.getAction() == TouchEvent.ACTION_UP){
				float endx = event.getX();
				float endy = event.getY();
				swipeable = false;
				calcSwipe(sStartx, sStarty, endx, endy);
				sStartx = -1;
				sStarty = -1;
			}
		}
		return true;
	}
	
	public void animatePo(){
		AnimatedSprite potato = sprites[0];
		long time[] = new long[PO_FRAMES];
		int frames[] = new int[PO_FRAMES];
		for(int i = 0; i < PO_FRAMES; i++){
			time[i] = 100;
			frames[i] = i;
		}
		
		potato.animate(time, frames, true);
	}
	
	
	public void animatePl(AnimatedSprite player, animations a){
		switch(a){
			case STANDING:{
				Random r = new Random();
				int t = r.nextInt(100) + 200;
				long time[] = {t,t,t,t};
				int frame[] = {1,0,4,0};
				player.animate(time,frame,true);
				break;
			}
			case HOLDING:{
				long time[] = {10};
				int frame[] = {6};
				player.animate(time,frame,false);
				break;
			}
			case THROWING:{
				long time[] = {100,100,100};
				int frame[] = {7,6,8};
				player.animate(time,frame,false);
				break;
			}
			case FALLING:{
				long time[] = {100,100,100};
				int frame[] = {1,2,3};
				player.animate(time,frame,false);
				break;
			}
			case CATCHING:{
				long time[] = {100,100,100};
				int frame[] = {4,0,5};
				player.animate(time,frame,false);
				break;
			}
			default:{
				break;
			}
		}
	}
	
	public void animateEx(){
		ex = sprites[numPlay + 2];
		ex.setPosition(sprites[0].getX(),sprites[0].getY());
		game.attachChild(ex);
		game.detachChild(sprites[0]);
		long time[] = new long[12];
		int frame[] = new int[12];
		for(int i = 0; i < 12; i++){
			time[i] = 100;
			frame[i] = i;
		}
		ex.animate(time,frame,false);
		TimerHandler fall = new TimerHandler(1f,new ITimerCallback(){
			public void onTimePassed(TimerHandler pTimerHandler){
				SM.engine.unregisterUpdateHandler(pTimerHandler);
				game.detachChild(ex);
				//just make sure it gets called after the call for other
				//parts to animate
				TimerHandler tm = new TimerHandler(.05f,new ITimerCallback(){
					public void onTimePassed(TimerHandler pTimerHandler){
						SM.engine.unregisterUpdateHandler(pTimerHandler);
						animatePl(sprites[curPlay + 1], animations.FALLING);
					}
				});
				SM.engine.registerUpdateHandler(tm);
			}
		});
		SM.engine.registerUpdateHandler(fall);
	}
	
	public void recievePassPacket(int i){
		int j = -1;
		for(int k = 0; k < 6; k++){
			if(usernums[k] == i){
				j = k;
			}
		}
		if(j > -1){
			calcPass(j);
		}
	}
	private void calcPass(int i){
		passComplete = false;
		float curX = sprites[0].getX();
		float curY = sprites[0].getY();
		float nexX = potatoPos[i][0];
		float nexY = potatoPos[i][1];
		dx =  nexX - curX;
		dy = nexY - curY;
		nextPlay = i;
		passPacketRecieved = true;
	}
	
	public int getLow(){
		int lowest = 10;
		//not numPlay + 1 because this is for the next round
		//the removed player will have already been pushed past the end
		for(int i = 0; i < numPlay; i++){
			if(usernums[i] < lowest)
				lowest = usernums[i];
		}
		return lowest;
	}
	
	public void recieveLoss(int i){
		Log.i("passHan rec", "KITTEN4 i = " + i);
		TM.recieveLoss(i);
	}
	
	public void sendCDLoss(){
		PacketInt pi = new PacketInt();
		String temp = "39" + ps.getUnum();
		Log.i("passHan send", "KITTEN1 i = " + ps.getUnum());
		Integer temp2 = Integer.parseInt(temp);
		pi.i = temp2.intValue();
		pi.gid = GameI;
		pc.pclient.sendTCP(pi);
	}
	
	public void sendWin(PacketInt p){
		pc.pclient.sendTCP(p);
	}
}
