package potatogame;

import java.util.HashMap;
import java.util.Random;
import java.util.Set;

import org.andengine.entity.scene.IOnSceneTouchListener;
import org.andengine.entity.scene.Scene;
import org.andengine.entity.scene.background.SpriteBackground;
import org.andengine.entity.sprite.AnimatedSprite;
import org.andengine.entity.sprite.Sprite;
import org.andengine.entity.text.Text;
import org.andengine.entity.text.TextOptions;
import org.andengine.input.touch.TouchEvent;
import org.andengine.opengl.font.Font;
import org.andengine.opengl.font.FontFactory;
import org.andengine.opengl.texture.atlas.bitmap.BitmapTextureAtlas;
import org.andengine.opengl.texture.atlas.bitmap.BitmapTextureAtlasTextureRegionFactory;
import org.andengine.opengl.texture.region.TextureRegion;
import org.andengine.opengl.texture.region.TiledTextureRegion;
import org.andengine.util.HorizontalAlign;
import org.andengine.util.color.Color;

import android.annotation.SuppressLint;
import android.graphics.Typeface;
import android.util.Log;

import com.example.traingame.SceneManager;
import com.example.traingame.Setup;


public class potatoSetup extends Setup implements IOnSceneTouchListener{
	//rows and columns in the player sprite sheet
	private int PL_COL = 3;
	private int PL_ROW = 3;
	
	//rows, columns, and frames in the hot potato sprite sheet
	private int PO_COL = 2;
	private int PO_ROW = 1;
	
	//rows, comumns, and frames in the explosion sprite sheet
	private int EX_COL = 4;
	private int EX_ROW = 3;
	
	private passHandler PH;
	
	private int numP;
	//the user's id for this game
	private int userNum = numP;
	
	private AnimatedSprite sprites[] = new AnimatedSprite[8];
	private int usernums[] = {1,2,3,4,5,6};
	private float potatoPos[][] = new float[6][2];
	
	private float pos1[][] = new float[2][3];
	private float pos2[][] = new float[2][3];
	private float pos3[][] = new float[2][3];
	private float pos4[][] = new float[2][3];
	private float pos5[][] = new float[2][3];
	
	private float allPosible[][][] = new float[5][2][3];
	
	//animated sprite information
	private BitmapTextureAtlas  playTA;
	private TiledTextureRegion playReg;
	private BitmapTextureAtlas  playTA2;
	private TiledTextureRegion playReg2;
	private BitmapTextureAtlas  playTA3;
	private TiledTextureRegion playReg3;
	private BitmapTextureAtlas  playTA4;
	private TiledTextureRegion playReg4;
	private BitmapTextureAtlas  playTA5;
	private TiledTextureRegion playReg5;
	private BitmapTextureAtlas  playTA6;
	private TiledTextureRegion playReg6;
	private BitmapTextureAtlas  potatoTA;
	private TiledTextureRegion potatoReg;
	private BitmapTextureAtlas explTA;
	private TiledTextureRegion explReg;
	private Font font;
	
	private HashMap<Integer, char[]> uMap = new HashMap<Integer, char[]>();
	private HashMap<Integer, Integer> numMap = new HashMap<Integer, Integer>();
	private Set<Integer> uidSet;
	private Integer gameID = 0;
	private Integer UID = 0;
	
	private Boolean set = true;
	
	private int survivedCur = -1;
	private int survivedPrev = -1;
	
	private TiledTextureRegion players[] = new TiledTextureRegion[6];
	
	//background
	private TextureRegion bgReg;
	private BitmapTextureAtlas bgTA;
	
	private int curP = numP;
	
	
	public potatoSetup(SceneManager SM){
		this.sm = SM;
		numP = 5;
	}
	
	public int getP(){
		return numP;
	}
	
	public void setP(int p, int p2, int p3){
		numP = p;
		curP = p2;
		userNum = p3;
		setupUname(p2);
	}
	
	private void setupUname(int j){
		if(set){
			usernums[numP] = userNum;
			usernums[userNum - 1] = numP + 1;
			Log.i("RAWR3", "un: " + userNum + " np: " + numP);
			set = false;
		}
		for(int i = 0; i < numP + 1; i++){
			if(usernums[i] == j)
				curP = i;
		}
	}
	
	public void markForSet(){
		set = true;
	}
	
	public potatoSetup(SceneManager SM, int player){
		this.sm = SM;
		numP = player;
	}
	
	public void load(){
		
		 
		 playTA = new BitmapTextureAtlas(sm.activity.getTextureManager(), 1024, 1024);
		 playReg = BitmapTextureAtlasTextureRegionFactory.createTiledFromAsset(playTA, sm.activity.getAssets(),"potato char 1.png", 0, 0, PL_COL, PL_ROW);
		 playTA.load();
		 
		 playTA2 = new BitmapTextureAtlas(sm.activity.getTextureManager(), 1024, 1024);
		 playReg2 = BitmapTextureAtlasTextureRegionFactory.createTiledFromAsset(playTA2, sm.activity.getAssets(),"potato char 3.png", 0, 0, PL_COL, PL_ROW);
		 playTA2.load();
		 
		 playTA3 = new BitmapTextureAtlas(sm.activity.getTextureManager(), 1024, 1024);
		 playReg3 = BitmapTextureAtlasTextureRegionFactory.createTiledFromAsset(playTA3, sm.activity.getAssets(),"potato char 4.png", 0, 0, PL_COL, PL_ROW);
		 playTA3.load();
		 
		 playTA4 = new BitmapTextureAtlas(sm.activity.getTextureManager(), 1024, 1024);
		 playReg4 = BitmapTextureAtlasTextureRegionFactory.createTiledFromAsset(playTA4, sm.activity.getAssets(),"potato char 5.png", 0, 0, PL_COL, PL_ROW);
		 playTA4.load();
		 
		 playTA5 = new BitmapTextureAtlas(sm.activity.getTextureManager(), 1024, 1024);
		 playReg5 = BitmapTextureAtlasTextureRegionFactory.createTiledFromAsset(playTA5, sm.activity.getAssets(),"potato char 6.png", 0, 0, PL_COL, PL_ROW);
		 playTA5.load();
		 
		 playTA6 = new BitmapTextureAtlas(sm.activity.getTextureManager(), 1024, 1024);
		 playReg6 = BitmapTextureAtlasTextureRegionFactory.createTiledFromAsset(playTA6, sm.activity.getAssets(),"potato char 2.png", 0, 0, PL_COL, PL_ROW);
		 playTA6.load();
		 
		 potatoTA = new BitmapTextureAtlas(sm.activity.getTextureManager(), 128, 64);
		 potatoReg = BitmapTextureAtlasTextureRegionFactory.createTiledFromAsset(potatoTA, sm.activity.getAssets(),"bomb sheet.png", 0, 0, PO_COL, PO_ROW);
		 potatoTA.load();
		 
		 
		 bgTA = new BitmapTextureAtlas(sm.activity.getTextureManager(), 2048, 2048);
		 bgReg = BitmapTextureAtlasTextureRegionFactory.createFromAsset(
					bgTA, sm.activity, "hot potato background.png", 0, 0);
		 bgTA.load();
		 
		 explTA = new BitmapTextureAtlas(sm.activity.getTextureManager(), 512, 512);
		 explReg = BitmapTextureAtlasTextureRegionFactory.createTiledFromAsset(explTA, sm.activity.getAssets(),"explosion sheet.png", 0, 0, EX_COL, EX_ROW);
		 explTA.load();
		 
		 //all posible opponent positions
		 float f1[] = {(sm.camera.getWidth() - playReg.getWidth())/2, 0,180};
		 float f2[] = {sm.camera.getWidth() * .1f, sm.camera.getHeight() * .6f, 45};
		 float f3[] = {sm.camera.getWidth() *.85f, sm.camera.getHeight() * .1f, -135};
		 float f4[] = {sm.camera.getWidth() *.85f, sm.camera.getHeight() * .6f, -45};
		 float f5[] = {sm.camera.getWidth() * .1f,  sm.camera.getHeight() * .1f, 135};
		
		 //all possible potato positions other than the start
		 float p1[] = {(sm.camera.getWidth() - potatoReg.getWidth())/2, sm.camera.getHeight() * .02f};
		 float p2[] = {sm.camera.getWidth() * .11f, sm.camera.getHeight() * .64f};
		 float p3[] ={sm.camera.getWidth() * .865f, sm.camera.getHeight() * .125f};
		 float p4[] = {sm.camera.getWidth() * .87f, sm.camera.getHeight() * .63f};
		 float p5[] = {sm.camera.getWidth() * .11f,  sm.camera.getHeight() * .12f};
		
		 pos1[0] = f1;
		 pos1[1] = p1;
		 pos2[0] = f2;
		 pos2[1] = p2;
		 pos3[0] = f3;
		 pos3[1] = p3;
		 pos4[0] = f4;
		 pos4[1] = p4;
		 pos5[0] = f5;
		 pos5[1] = p5;
		 
		 
		 font = FontFactory.create(sm.engine.getFontManager(), sm.engine.getTextureManager(), 256, 256, Typeface.create(Typeface.DEFAULT, Typeface.BOLD), 32,Color.WHITE.hashCode());
			font.load();
		
		 randomUser();
		 
	}
	
	public Scene create(){
		//800 by 480 screen. 128 by 64 sprite.
		
		//pc = new potatoClient(this);
		//PacketInt pi = new PacketInt();
		//pi.i = 100;
		//pc.pclient.sendTCP(pi);
		 
		Scene potatoScene = new Scene();
		int cX = (int)(sm.camera.getWidth() - bgReg.getWidth())/2;
		int cY = (int)(sm.camera.getHeight() - bgReg.getHeight())/2;
		survivedCur++;
		Sprite bgSprite = new Sprite(cX, cY,  bgReg, sm.activity.getVertexBufferObjectManager());
		bgSprite.setScaleX(sm.camera.getWidth()/bgSprite.getWidth());
		bgSprite.setScaleY(sm.camera.getHeight()/bgSprite.getHeight());
		SpriteBackground bg = new SpriteBackground(bgSprite);
		potatoScene.setBackground(bg);
		
		
		AnimatedSprite p1 = new AnimatedSprite(0,  0, players[1], sm.activity.getVertexBufferObjectManager());
		p1.setPosition(allPosible[0][0][0],allPosible[0][0][1]);
		p1.setRotation(allPosible[0][0][2]);
		potatoScene.attachChild(p1);
		
		
		//char[] add = uMap.get(numMap.get(usernums[0]));
		//String toAdd = add.toString();
		
		Text t1 = new Text(allPosible[0][0][0],allPosible[0][0][1],font,"Player: " + usernums[0],new TextOptions(HorizontalAlign.RIGHT), sm.engine.getVertexBufferObjectManager());
		potatoScene.attachChild(t1);
		
		AnimatedSprite p3 = null;
		int textn = 1;
		if(numP > 1){
			p3 = new AnimatedSprite(0,  0, players[2], sm.activity.getVertexBufferObjectManager());
			p3.setPosition(allPosible[1][0][0],allPosible[1][0][1]);
			p3.setRotation(allPosible[1][0][2]);
			potatoScene.attachChild(p3);
			Text t2 = new Text(allPosible[1][0][0],allPosible[1][0][1],font,"Player: " + usernums[textn],new TextOptions(HorizontalAlign.RIGHT), sm.engine.getVertexBufferObjectManager());
			potatoScene.attachChild(t2);
			textn++;
		}
		
		AnimatedSprite p4 = null;
		if(numP > 2){
			p4 = new AnimatedSprite(0,  0, players[3], sm.activity.getVertexBufferObjectManager());
			p4.setPosition(allPosible[2][0][0],allPosible[2][0][1]);
			p4.setRotation(allPosible[2][0][2]);
			potatoScene.attachChild(p4);
			Text t2 = new Text(allPosible[2][0][0],allPosible[2][0][1],font,"Player: " + usernums[textn],new TextOptions(HorizontalAlign.RIGHT), sm.engine.getVertexBufferObjectManager());
			potatoScene.attachChild(t2);
			textn++;
		}
		
		
		AnimatedSprite p5 = null;
		if(numP > 3){
			p5 = new AnimatedSprite(0,  240 - 35, players[4], sm.activity.getVertexBufferObjectManager());
			p5.setPosition(allPosible[3][0][0],allPosible[3][0][1]);
			p5.setRotation(allPosible[3][0][2]);
			potatoScene.attachChild(p5);
			Text t2 = new Text(allPosible[3][0][0],allPosible[3][0][1],font,"Player: " + usernums[textn],new TextOptions(HorizontalAlign.RIGHT), sm.engine.getVertexBufferObjectManager());
			potatoScene.attachChild(t2);
			textn++;
		}
		
		AnimatedSprite p2 = null;
		if(numP > 4){
			p2= new AnimatedSprite(0,  0, players[5], sm.activity.getVertexBufferObjectManager());
			p2.setPosition(allPosible[4][0][0],allPosible[4][0][1]);
			p2.setRotation(allPosible[4][0][2]);
			potatoScene.attachChild(p2);
			Text t2 = new Text(allPosible[4][0][0],allPosible[4][0][1],font,"Player: " + usernums[textn],new TextOptions(HorizontalAlign.RIGHT), sm.engine.getVertexBufferObjectManager());
			potatoScene.attachChild(t2);
			textn++;
		}
		
		//this is the human player.
		AnimatedSprite p6 = new AnimatedSprite(0,  0, players[0], sm.activity.getVertexBufferObjectManager());
		p6.setPosition((sm.camera.getWidth() - p6.getWidth())/2,sm.camera.getHeight() * .82f);
		potatoScene.attachChild(p6);
		Text t2 = new Text((sm.camera.getWidth() - p6.getWidth())/2,sm.camera.getHeight() * .82f,font,"Player: " + usernums[textn],new TextOptions(HorizontalAlign.RIGHT), sm.engine.getVertexBufferObjectManager());
		potatoScene.attachChild(t2);
		
		AnimatedSprite potato = new AnimatedSprite(0,  0, potatoReg, sm.activity.getVertexBufferObjectManager()){
			@Override
			public boolean onAreaTouched(final TouchEvent event, final float pTouchAreaLocalX, final float pTouchAreaLocalY) {
				if(event.getAction() == TouchEvent.ACTION_DOWN){
					PH.pTapped(pTouchAreaLocalX, pTouchAreaLocalY, this);
				}
				
				return true;
			}
		};
		float f6[] = {(sm.camera.getWidth() - potato.getWidth())/2,sm.camera.getHeight() * .85f};
		potatoScene.registerTouchArea(potato);
		
		potatoScene.attachChild(potato);
		
		AnimatedSprite expl = null;
		expl = new AnimatedSprite(0,  0, explReg, sm.activity.getVertexBufferObjectManager());
		
		int i = 0;
		sprites[i] = potato;
		i++;
		sprites[i] = p1;
		i++;
		if(numP > 1){
			sprites[i] = p3;
			i++;
		}
		if(numP > 2){
			sprites[i] = p4;
			i++;
		}
		if(numP > 3){
			sprites[i] = p5;
			i++;
		}
		if(numP > 4){
			sprites[i] = p2;
			i++;
		}
		sprites[i] = p6;
		i++;
		//put the explosion in the array so you can attach it to the scene when and if you need to.
		sprites[i] = expl;
		
		
		
		int j = 0;
		
		float f1[] = {allPosible[0][1][0],allPosible[0][1][1]};
		potatoPos[j] = f1;
		j++;
		
		if(numP > 1){
			float f3[] = {allPosible[1][1][0],allPosible[1][1][1]};
			potatoPos[j] = f3;
			j++;
		}
		
		if(numP > 2){
			float f4[] ={allPosible[2][1][0],allPosible[2][1][1]};
			potatoPos[j] = f4;
			j++;
		}
		
		if(numP > 3){
			float f5[] = {allPosible[3][1][0],allPosible[3][1][1]};
			potatoPos[j] = f5;
			j++;
		}
		if(numP > 4){
			float f2[] = {allPosible[4][1][0],allPosible[4][1][1]};
			potatoPos[j] = f2;
			j++;
		}
		potatoPos[j] = f6 ;
		
		potato.setPosition(potatoPos[curP][0],potatoPos[curP][1]);
		PH = new passHandler(sprites, potatoScene,potatoPos, sm,numP, curP, this, usernums,gameID);
		potatoScene.setOnSceneTouchListener(this);
		
		return potatoScene;
	}
	
	@Override
	public boolean onSceneTouchEvent(Scene pScene, TouchEvent event) {
		PH.onSceneTouchEvent(pScene, event);
		return true;
	}
	
	public void remSprite(int toRem){
		Log.i("SETUP", "KITTENSETUP REM: " + toRem);
		for(int i = toRem; i < 5; i++){
			players[i] = players[i+1];
			allPosible[i -1] = allPosible[i];
			usernums[i - 1] = usernums[i];
		}
		usernums[4] = usernums[5];
	}
	
	public void randomUser(){
		//the first region in players is the user, so randomize that but first reset the options
		 players[0] = playReg;
		 players[1] = playReg2;
		 players[2] = playReg3;
		 players[3] = playReg4;
		 players[4] = playReg5;
		 players[5] = playReg6;
		 
		 allPosible[0] = pos1;
		 allPosible[1] = pos2;
		 allPosible[2] = pos3;
		 allPosible[3] = pos4;
		 allPosible[4] = pos5;
		 
		 Random r = new Random();
		 int ran = r.nextInt(numP + 1);
		 TiledTextureRegion t1 = players[0];
		 TiledTextureRegion t2 = players[ran];
		 players[0] = t2;
		 players[ran] = t1;
		 
		 for(int i = 0; i < 6; i++){
			 usernums[i] = i + 1;
		 }
		 survivedPrev = survivedCur;
		 survivedCur = -1;
	}
	
	public int getUnum(){
		return userNum;
	}
	
	public void recievePassPacket(int i){
		PH.recievePassPacket(i);
	}
	
	public void recieveLoss(int j){
		Log.i("potSet rec", "KITTEN2 j = " + j);
		int send = 0;
		for(int i = 0; i < numP + 1; i++){
			if(usernums[i] == j)
				send = i;
		}
		Log.i("potSet rec", "KITTEN3 send = " + send);
		PH.recieveLoss(send);
	}
	
	@SuppressLint("UseValueOf")
	public void setHash(HashMap<Integer, char[]> hm){
		uMap = hm;
		uidSet = uMap.keySet();
		int i = 1;
		for(Integer s: uidSet){
			Log.i("HHHHH", "HUH i:" + i + " s:" + s +  " uid:" + UID);
			if(s.intValue() != UID.intValue()){
				if(i == userNum){
					i++;
				}
				Integer i2 = new Integer(i);
				numMap.put(i2, s);
				i++;
			}
			else{
				Integer i2 = new Integer(userNum);
				numMap.put(i2, s);
			}
		}
	}
	
	public void setGameID(Integer i, Integer i2){
		gameID = i;
		UID = i2;
	}
	
	public int getSurvivedPrev(){
		return survivedPrev;
	}
	
}
