package wizardgame;

import org.andengine.engine.handler.timer.ITimerCallback;
import org.andengine.engine.handler.timer.TimerHandler;
import org.andengine.entity.scene.Scene;
import org.andengine.entity.scene.background.Background;
import org.andengine.entity.sprite.Sprite;
import org.andengine.entity.text.Text;
import org.andengine.entity.text.TextOptions;
import org.andengine.opengl.font.Font;
import org.andengine.opengl.font.FontFactory;
import org.andengine.opengl.texture.atlas.bitmap.BitmapTextureAtlas;
import org.andengine.opengl.texture.atlas.bitmap.BitmapTextureAtlasTextureRegionFactory;
import org.andengine.opengl.texture.region.ITextureRegion;
import org.andengine.util.HorizontalAlign;
import org.andengine.util.color.Color;

import persistantgame.TrainStats;
import android.content.SharedPreferences;
import android.graphics.Typeface;
import android.util.Log;

import com.example.traingame.SceneManager;
import com.example.traingame.Setup;

import database.DBProtocolC;

public class wizardLoss extends Setup{
	private BitmapTextureAtlas lossTA;
	private ITextureRegion lossTR;
	private Font font;
	private int rounds = 0;
	public wizardLoss(SceneManager SM){
		this.sm = SM;
	}
	
	@Override
	public void load(){
		BitmapTextureAtlasTextureRegionFactory.setAssetBasePath("gfx/");
		lossTA = new BitmapTextureAtlas(sm.activity.getTextureManager(),
				2048, 2048);
		lossTR = BitmapTextureAtlasTextureRegionFactory.createFromAsset(
				lossTA, sm.activity, "landscape lose.png", 0, 0);
		lossTA.load();
		font = FontFactory.create(sm.engine.getFontManager(), sm.engine.getTextureManager(), 256, 256, Typeface.create(Typeface.DEFAULT, Typeface.BOLD), 32,Color.WHITE.hashCode());
		font.load();
	}
	
	@Override
	public Scene create(){
		Scene lossScene = new Scene();
		lossScene.setBackground(new Background(0,0,0));
		
		Sprite sIcon = new Sprite(0,0,lossTR,sm.engine.getVertexBufferObjectManager());
		sIcon.setPosition((sm.camera.getWidth() - sIcon.getWidth())/2, (sm.camera.getHeight() - sIcon.getHeight())/2);
		sIcon.setScale(sm.camera.getWidth()/sIcon.getWidth(), sm.camera.getHeight()/sIcon.getHeight());
		lossScene.attachChild(sIcon);
		rounds = sm.getWizardSetup().getSh().getRound();
		Boolean twoP = sm.getWizardSetup().gettwoP();
		Text t;
		SharedPreferences sp = sm.activity.getSharedPreferences("currentUser", 0);
		String UID = sp.getString("uid", "");
		//DBProtocolC.connectToDB();
		if(twoP){
			Boolean win = sm.getWizardSetup().getSh().getWin();
			if(win){
				t = new Text(sm.camera.getWidth() * .3f, sm.camera.getHeight() * .2f,font,"You won and got through " + rounds + " rounds!",new TextOptions(HorizontalAlign.RIGHT), sm.engine.getVertexBufferObjectManager());
				//DBProtocolC.storeScore(UID, "2", "" + (rounds * 4));
				//DBProtocolC.updateUserScore(UID, DBProtocolC.getUserScore(UID) + (rounds * 4));
			}
			else{
				t = new Text(sm.camera.getWidth() * .3f, sm.camera.getHeight() * .2f,font,"You lost but got through " + rounds + " rounds!",new TextOptions(HorizontalAlign.RIGHT), sm.engine.getVertexBufferObjectManager());
				//DBProtocolC.storeScore(UID, "2", "" + (rounds * 2));
				//DBProtocolC.updateUserScore(UID, DBProtocolC.getUserScore(UID) + (rounds * 2));
			}
		}
		else{
			t = new Text(sm.camera.getWidth() * .3f, sm.camera.getHeight() * .2f,font,"You got through " + rounds + " rounds!",new TextOptions(HorizontalAlign.RIGHT), sm.engine.getVertexBufferObjectManager());
			//DBProtocolC.storeScore(UID, "2", "" + (rounds * 3));
			//DBProtocolC.updateUserScore(UID, DBProtocolC.getUserScore(UID) + (rounds * 3));
		}
		//DBProtocolC.close();
		TrainStats ts = TrainStats.getInstance();
		ts.setMoney(ts.getMoney() + (rounds * 3));
		lossScene.attachChild(t);
		sm.engine.registerUpdateHandler(new TimerHandler(3f,new ITimerCallback(){
			public void onTimePassed(TimerHandler pTimerHandler){
				sm.engine.unregisterUpdateHandler(pTimerHandler);
				sm.activity.finish();
			}
		})); 
		Log.i("Loss", "LOSS9");
		return lossScene;
	}
}
