package wizardgame;

import org.andengine.entity.scene.Scene;
import android.util.Log;
import org.andengine.entity.scene.background.Background;
import org.andengine.entity.sprite.AnimatedSprite;
import org.andengine.entity.sprite.Sprite;
import org.andengine.entity.text.Text;
import org.andengine.entity.text.TextOptions;
import org.andengine.input.touch.TouchEvent;
import org.andengine.opengl.font.Font;
import org.andengine.opengl.font.FontFactory;
import org.andengine.opengl.texture.atlas.bitmap.BitmapTextureAtlas;
import org.andengine.opengl.texture.atlas.bitmap.BitmapTextureAtlasTextureRegionFactory;
import org.andengine.opengl.texture.region.ITextureRegion;
import org.andengine.opengl.texture.region.TiledTextureRegion;
import org.andengine.util.HorizontalAlign;
import org.andengine.util.color.Color;

import android.graphics.Typeface;

import com.example.traingame.SceneManager;
import com.example.traingame.Setup;

public class wizardSetup extends Setup {
	private BitmapTextureAtlas starTA;
	private ITextureRegion starReg;
	private BitmapTextureAtlas starSTA;
	private ITextureRegion starSReg;
	private BitmapTextureAtlas advTA;
	private ITextureRegion advReg;
	private BitmapTextureAtlas incomTA;
	private ITextureRegion incomReg;
	private BitmapTextureAtlas chartTA;
	private ITextureRegion chartReg;
	
	private BitmapTextureAtlas fireTA;
	private ITextureRegion fireReg;
	private BitmapTextureAtlas waterTA;
	private ITextureRegion waterReg;
	private BitmapTextureAtlas earthTA;
	private ITextureRegion earthReg;
	private BitmapTextureAtlas windTA;
	private ITextureRegion windReg;
	
	private BitmapTextureAtlas earthexplosionTA;
	private TiledTextureRegion earthexplosionReg;
	private BitmapTextureAtlas fireexplosionTA;
	private TiledTextureRegion fireexplosionReg;
	private BitmapTextureAtlas waterexplosionTA;
	private TiledTextureRegion waterexplosionReg;
	private BitmapTextureAtlas windexplosionTA;
	private TiledTextureRegion windexplosionReg;
	
	private BitmapTextureAtlas backgroundTA;
	private ITextureRegion backgroundReg;
	
	private Text chances;
	private Text chances2;
	private Text instruct;
	private Text rounds;
	private Text timer;
	
	
	private Sprite stars[][] = new Sprite[6][2];
	private Text updates[] = new Text[5];
	private Sprite elements[] = new Sprite[4];
	private AnimatedSprite magic[] = new AnimatedSprite[4];
	
	private spellHandler sh;
	
	private Font font;
	private Font font2;
	
	private Boolean pTurn = false;
	private Boolean twoPlay = false;
	
	private Integer gameID = 0;
	
	public wizardSetup(SceneManager SM){
		this.sm = SM;
	}
	
	public void load(){
		
		BitmapTextureAtlasTextureRegionFactory.setAssetBasePath("gfx/wizard/");
		
		starTA = new BitmapTextureAtlas(sm.activity.getTextureManager(), 512, 512);
		starReg = BitmapTextureAtlasTextureRegionFactory.createFromAsset(
				starTA, sm.activity, "star icon unpressed.png", 0, 0);
		starTA.load();
		
		starSTA = new BitmapTextureAtlas(sm.activity.getTextureManager(), 512, 512);
		starSReg = BitmapTextureAtlasTextureRegionFactory.createFromAsset(
				starSTA, sm.activity, "star icon.png", 0, 0);
		starSTA.load();
		
		advTA = new BitmapTextureAtlas(sm.activity.getTextureManager(), 1048, 1048);
		advReg = BitmapTextureAtlasTextureRegionFactory.createFromAsset(
				advTA, sm.activity, "element chart.png", 0, 0);
		advTA.load();
		
		incomTA = new BitmapTextureAtlas(sm.activity.getTextureManager(), 256, 256);
		incomReg = BitmapTextureAtlasTextureRegionFactory.createFromAsset(
				incomTA, sm.activity, "incomingSpell.png", 0, 0);
		incomTA.load();
		
		chartTA = new BitmapTextureAtlas(sm.activity.getTextureManager(), 256, 512);
		chartReg = BitmapTextureAtlasTextureRegionFactory.createFromAsset(
				chartTA, sm.activity, "spellchart.png", 0, 0);
		chartTA.load();
		
		fireTA = new BitmapTextureAtlas(sm.activity.getTextureManager(), 512, 512);
		fireReg = BitmapTextureAtlasTextureRegionFactory.createFromAsset(
				fireTA, sm.activity, "fire symbol L.png", 0, 0);
		fireTA.load();
		
		waterTA = new BitmapTextureAtlas(sm.activity.getTextureManager(), 512, 512);
		waterReg = BitmapTextureAtlasTextureRegionFactory.createFromAsset(
				waterTA, sm.activity, "water symbol L.png", 0, 0);
		waterTA.load();
		
		earthTA = new BitmapTextureAtlas(sm.activity.getTextureManager(), 512, 512);
		earthReg = BitmapTextureAtlasTextureRegionFactory.createFromAsset(
				earthTA, sm.activity, "earth symbol L.png", 0, 0);
		earthTA.load();
		
		windTA = new BitmapTextureAtlas(sm.activity.getTextureManager(), 512, 512);
		windReg = BitmapTextureAtlasTextureRegionFactory.createFromAsset(
				windTA, sm.activity, "wind symbol L.png", 0, 0);
		windTA.load();
		
		font = FontFactory.create(sm.engine.getFontManager(), sm.engine.getTextureManager(), 256, 256, Typeface.create(Typeface.DEFAULT, Typeface.BOLD), 32,Color.WHITE.hashCode());
		font2 = FontFactory.create(sm.engine.getFontManager(), sm.engine.getTextureManager(), 256, 256, Typeface.create(Typeface.DEFAULT, Typeface.BOLD), 60,Color.WHITE.hashCode());
		
		font.load();
		font2.load();
		
		
		// Background
		backgroundTA = new BitmapTextureAtlas(sm.activity.getTextureManager(),2048,2048);
		backgroundReg = BitmapTextureAtlasTextureRegionFactory.createFromAsset(
				backgroundTA, sm.activity, "wizard background.png",0,0);
		
		backgroundTA.load();
		
		// explosions
		
		earthexplosionTA = new BitmapTextureAtlas(sm.activity.getTextureManager(),2048,2048);
		earthexplosionReg = BitmapTextureAtlasTextureRegionFactory.createTiledFromAsset(
				earthexplosionTA, sm.activity, "earth explosion.png",0,0,4,3);
		fireexplosionTA = new BitmapTextureAtlas(sm.activity.getTextureManager(),2048,2048);
		fireexplosionReg = BitmapTextureAtlasTextureRegionFactory.createTiledFromAsset(
				fireexplosionTA, sm.activity, "fire explosion.png",0,0,4,3);
		waterexplosionTA = new BitmapTextureAtlas(sm.activity.getTextureManager(),2048,2048);
		waterexplosionReg = BitmapTextureAtlasTextureRegionFactory.createTiledFromAsset(
				waterexplosionTA, sm.activity, "water explosion.png",0,0,4,3);
		windexplosionTA = new BitmapTextureAtlas(sm.activity.getTextureManager(),2048,2048);
		windexplosionReg = BitmapTextureAtlasTextureRegionFactory.createTiledFromAsset(
				windexplosionTA, sm.activity, "wind explosion.png",0,0,4,3);
		
		earthexplosionTA.load();
		fireexplosionTA.load();
		waterexplosionTA.load();
		windexplosionTA.load();
	}
	
	public Scene create(){
		Scene wizardScene = new Scene();
		wizardScene.setBackground(new Background(0, 0, 255));
		
		Sprite wbackground = new Sprite(0,0,backgroundReg,sm.activity.getVertexBufferObjectManager());
		wizardScene.attachChild(wbackground);
		
		Sprite sChart = new Sprite(sm.camera.getWidth() - chartReg.getWidth(),  sm.camera.getHeight() - chartReg.getHeight(), chartReg, sm.activity.getVertexBufferObjectManager());
		wizardScene.attachChild(sChart);
		
		Sprite advantage = new Sprite((sm.camera.getWidth() - advReg.getWidth())/2,  sm.camera.getHeight() *.2f, advReg, sm.activity.getVertexBufferObjectManager());
		wizardScene.attachChild(advantage);
		advantage.setPosition(sm.camera.getWidth()/2 - advantage.getWidth()/2, sm.camera.getHeight()*0.7f - advantage.getHeight()/2);
		advantage.setScaleY(.6f);
		advantage.setScaleX(.6f);
		
		Sprite incoming = new Sprite((sm.camera.getWidth() - incomReg.getWidth())/2, 0, incomReg, sm.activity.getVertexBufferObjectManager());
		incoming.setScale(.7f);
		wizardScene.attachChild(incoming);
		
		Sprite s1 = new Sprite(sm.camera.getWidth() * .3f,   sm.camera.getHeight()*.5f, starReg, sm.activity.getVertexBufferObjectManager()){
		@Override
		public boolean onAreaTouched(final TouchEvent pSceneTouchEvent, final float pTouchAreaLocalX, final float pTouchAreaLocalY) {
			if(pSceneTouchEvent.getAction() == TouchEvent.ACTION_DOWN)
				sh.press(1);
			return true;
			}
		};
		s1.setPosition(sm.camera.getWidth() * .3f - s1.getWidth()/2, sm.camera.getHeight()*.5f - s1.getHeight()/2);
		
		Sprite ss1 = new Sprite(sm.camera.getWidth() * .3f,   sm.camera.getHeight()*.5f, starSReg, sm.activity.getVertexBufferObjectManager()){
		@Override
		public boolean onAreaTouched(final TouchEvent pSceneTouchEvent, final float pTouchAreaLocalX, final float pTouchAreaLocalY) {
			if(pSceneTouchEvent.getAction() == TouchEvent.ACTION_DOWN)
				sh.press(1);
			return true;
			}
		};
		ss1.setPosition(sm.camera.getWidth() * .3f - s1.getWidth()/2, sm.camera.getHeight()*.5f - s1.getHeight()/2);
		
		stars[0][0] = s1;
		stars[0][1] = ss1;
		
		Sprite s2 = new Sprite(sm.camera.getWidth() * .5f,   sm.camera.getHeight()*.5f, starReg, sm.activity.getVertexBufferObjectManager()){
		@Override
		public boolean onAreaTouched(final TouchEvent pSceneTouchEvent, final float pTouchAreaLocalX, final float pTouchAreaLocalY) {
			if(pSceneTouchEvent.getAction() == TouchEvent.ACTION_DOWN)
				sh.press(2);
			return true;
			}
		};
		s2.setPosition(sm.camera.getWidth() * .5f - s1.getWidth()/2, sm.camera.getHeight()*.5f - s1.getHeight()/2);
		
		Sprite ss2 = new Sprite(sm.camera.getWidth() * .5f,   sm.camera.getHeight()*.5f, starSReg, sm.activity.getVertexBufferObjectManager()){
		@Override
		public boolean onAreaTouched(final TouchEvent pSceneTouchEvent, final float pTouchAreaLocalX, final float pTouchAreaLocalY) {
			if(pSceneTouchEvent.getAction() == TouchEvent.ACTION_DOWN)
				sh.press(2);
			return true;
			}
		};
		ss2.setPosition(sm.camera.getWidth() * .5f - s1.getWidth()/2, sm.camera.getHeight()*.5f - s1.getHeight()/2);
		
		stars[1][0] = s2;
		stars[1][1] = ss2;
		
		Sprite s3 = new Sprite(sm.camera.getWidth() * .7f,   sm.camera.getHeight()*.5f, starReg, sm.activity.getVertexBufferObjectManager()){
		@Override
		public boolean onAreaTouched(final TouchEvent pSceneTouchEvent, final float pTouchAreaLocalX, final float pTouchAreaLocalY) {
				if(pSceneTouchEvent.getAction() == TouchEvent.ACTION_DOWN)
					sh.press(3);
				return true;
			}
		};
		s3.setPosition(sm.camera.getWidth() * .7f - s1.getWidth()/2, sm.camera.getHeight()*.5f - s1.getHeight()/2);
		
		Sprite ss3 = new Sprite(sm.camera.getWidth() * .7f,   sm.camera.getHeight()*.5f, starSReg, sm.activity.getVertexBufferObjectManager()){
		@Override
		public boolean onAreaTouched(final TouchEvent pSceneTouchEvent, final float pTouchAreaLocalX, final float pTouchAreaLocalY) {
			if(pSceneTouchEvent.getAction() == TouchEvent.ACTION_DOWN)
				sh.press(3);
			return true;
			}
		};
		ss3.setPosition(sm.camera.getWidth() * .7f - s1.getWidth()/2, sm.camera.getHeight()*.5f - s1.getHeight()/2);
		
		stars[2][0] = s3;
		stars[2][1] = ss3;
	
		Sprite s4 = new Sprite(sm.camera.getWidth() * .3f,   sm.camera.getHeight()*.85f, starReg, sm.activity.getVertexBufferObjectManager()){
		@Override
		public boolean onAreaTouched(final TouchEvent pSceneTouchEvent, final float pTouchAreaLocalX, final float pTouchAreaLocalY) {
			if(pSceneTouchEvent.getAction() == TouchEvent.ACTION_DOWN)
				sh.press(4);
			return true;
			}
		};
		s4.setPosition(sm.camera.getWidth() * .3f - s1.getWidth()/2, sm.camera.getHeight()*.85f - s1.getHeight()/2);
		
		Sprite ss4 = new Sprite(sm.camera.getWidth() * .3f,   sm.camera.getHeight()*.85f, starSReg, sm.activity.getVertexBufferObjectManager()){
		@Override
		public boolean onAreaTouched(final TouchEvent pSceneTouchEvent, final float pTouchAreaLocalX, final float pTouchAreaLocalY) {
			if(pSceneTouchEvent.getAction() == TouchEvent.ACTION_DOWN)
				sh.press(4);
			return true;
			}
		};
		ss4.setPosition(sm.camera.getWidth() * .3f - s1.getWidth()/2, sm.camera.getHeight()*.85f - s1.getHeight()/2);
		
		stars[3][0] = s4;
		stars[3][1] = ss4;
		
		Sprite s5 = new Sprite(sm.camera.getWidth() * .5f,   sm.camera.getHeight()*.85f, starReg, sm.activity.getVertexBufferObjectManager()){
		@Override
		public boolean onAreaTouched(final TouchEvent pSceneTouchEvent, final float pTouchAreaLocalX, final float pTouchAreaLocalY) {
			if(pSceneTouchEvent.getAction() == TouchEvent.ACTION_DOWN)
				sh.press(5);
			return true;
			}
		};
		s5.setPosition(sm.camera.getWidth() * .5f - s1.getWidth()/2, sm.camera.getHeight()*.85f - s1.getHeight()/2);
		
		Sprite ss5 = new Sprite(sm.camera.getWidth() * .5f,   sm.camera.getHeight()*.85f, starSReg, sm.activity.getVertexBufferObjectManager()){
		@Override
		public boolean onAreaTouched(final TouchEvent pSceneTouchEvent, final float pTouchAreaLocalX, final float pTouchAreaLocalY) {
			if(pSceneTouchEvent.getAction() == TouchEvent.ACTION_DOWN)
				sh.press(5);
			return true;
			}
		};
		ss5.setPosition(sm.camera.getWidth() * .5f - s1.getWidth()/2, sm.camera.getHeight()*.85f - s1.getHeight()/2);
		
		stars[4][0] = s5;
		stars[4][1] = ss5;
		
		Sprite s6 = new Sprite(sm.camera.getWidth() * .7f,   sm.camera.getHeight()*.85f, starReg, sm.activity.getVertexBufferObjectManager()){
		@Override
		public boolean onAreaTouched(final TouchEvent pSceneTouchEvent, final float pTouchAreaLocalX, final float pTouchAreaLocalY) {
			if(pSceneTouchEvent.getAction() == TouchEvent.ACTION_DOWN)
				sh.press(6);
			return true;
			}
		};
		s6.setPosition(sm.camera.getWidth() * .7f - s1.getWidth()/2, sm.camera.getHeight()*.85f - s1.getHeight()/2);
		
		Sprite ss6 = new Sprite(sm.camera.getWidth() * .7f,   sm.camera.getHeight()*.85f, starSReg, sm.activity.getVertexBufferObjectManager()){
		@Override
		public boolean onAreaTouched(final TouchEvent pSceneTouchEvent, final float pTouchAreaLocalX, final float pTouchAreaLocalY) {
			if(pSceneTouchEvent.getAction() == TouchEvent.ACTION_DOWN)
				sh.press(6);
			return true;
			}
		};
		ss6.setPosition(sm.camera.getWidth() * .7f - s1.getWidth()/2, sm.camera.getHeight()*.85f - s1.getHeight()/2);
		
		stars[5][0] = s6;
		stars[5][1] = ss6;
		
		s1.setScale(0.3f);
		s2.setScale(0.3f);
		s3.setScale(0.3f);
		s4.setScale(0.3f);
		s5.setScale(0.3f);
		s6.setScale(0.3f);
	
		ss1.setScale(0.3f);
		ss2.setScale(0.3f);
		ss3.setScale(0.3f);
		ss4.setScale(0.3f);
		ss5.setScale(0.3f);
		ss6.setScale(0.3f);
		

		wizardScene.attachChild(s1);
		wizardScene.registerTouchArea(s1);
		wizardScene.attachChild(s2);
		wizardScene.registerTouchArea(s2);
		wizardScene.attachChild(s3);
		wizardScene.registerTouchArea(s3);
		wizardScene.attachChild(s4);
		wizardScene.registerTouchArea(s4);
		wizardScene.attachChild(s5);
		wizardScene.registerTouchArea(s5);
		wizardScene.attachChild(s6);
		wizardScene.registerTouchArea(s6);
		
		if(!twoPlay){
			chances = new Text(sm.camera.getWidth() * .2f, 0,font,"Chances: 2",new TextOptions(HorizontalAlign.RIGHT), sm.engine.getVertexBufferObjectManager());
			rounds = new Text(sm.camera.getWidth() * .65f, 0,font,"Rounds: 00000000",new TextOptions(HorizontalAlign.RIGHT), sm.engine.getVertexBufferObjectManager());
		}
		else{
			chances = new Text(sm.camera.getWidth() * .2f, sm.camera.getHeight() * .2f,font,"YOUR\n Chances: 2",new TextOptions(HorizontalAlign.CENTER), sm.engine.getVertexBufferObjectManager());
			chances2 = new Text(sm.camera.getWidth() * .61f, sm.camera.getHeight() * .2f,font,"OPPONENT'S\nChances: 2",new TextOptions(HorizontalAlign.CENTER), sm.engine.getVertexBufferObjectManager());
			//make sure the sentence is longer than needed
			instruct = new Text(sm.camera.getWidth() * .2f,  sm.camera.getHeight() *.9f,font,"Opponent's turn: they will cast 999999 spells!",new TextOptions(HorizontalAlign.CENTER), sm.engine.getVertexBufferObjectManager());
			if(pTurn){
				instruct.setText("Your turn: please cast 1 spell!");
			}
			else{
				instruct.setText("Opponent's turn: they will cast 1 spell!");
			}
			rounds = new Text(sm.camera.getWidth() * .42f, 0,font,"Rounds: 00000000",new TextOptions(HorizontalAlign.RIGHT), sm.engine.getVertexBufferObjectManager());
			updates[3] = chances2;
			updates[4] = instruct;
			wizardScene.attachChild(chances2);
			wizardScene.attachChild(instruct);
		}
		timer = new Text(0, sm.camera.getHeight() * .5f,font2,"Timer:\n30",new TextOptions(HorizontalAlign.CENTER), sm.engine.getVertexBufferObjectManager());
		//since rounds count up  the string size needs to be long enough
		rounds.setText("Rounds: 0");
		timer.setText("Timer:\n0");
		updates[0] = chances;
		updates[1] = rounds;
		updates[2] = timer;
		
		wizardScene.attachChild(chances);
		wizardScene.attachChild(rounds);
		wizardScene.attachChild(timer);
		
		Sprite fire = new Sprite(sm.camera.getWidth() *.43f, sm.camera.getHeight() * .15f, fireReg, sm.activity.getVertexBufferObjectManager());
		Sprite water = new Sprite(sm.camera.getWidth() *.43f, sm.camera.getHeight() * .15f, waterReg, sm.activity.getVertexBufferObjectManager());
		Sprite earth = new Sprite(sm.camera.getWidth() *.43f, sm.camera.getHeight() * .15f, earthReg, sm.activity.getVertexBufferObjectManager());
		Sprite wind = new Sprite(sm.camera.getWidth() *.43f, sm.camera.getHeight() * .15f, windReg, sm.activity.getVertexBufferObjectManager());
		
		fire.setPosition((sm.camera.getWidth() - fireReg.getWidth())/2, incomReg.getHeight()/2 - fireReg.getHeight()/2);
		water.setPosition((sm.camera.getWidth() - waterReg.getWidth())/2, incomReg.getHeight()/2 - waterReg.getHeight()/2);
		earth.setPosition((sm.camera.getWidth() - earthReg.getWidth())/2, incomReg.getHeight()/2 - earthReg.getHeight()/2);
		wind.setPosition((sm.camera.getWidth() - windReg.getWidth())/2, incomReg.getHeight()/2 - windReg.getHeight()/2);
		
		fire.setScale(0.35f);
		water.setScale(0.35f);
		earth.setScale(0.35f);
		wind.setScale(0.35f);
		
		elements[0] = fire;
		elements[1] = water;
		elements[2] = earth;
		elements[3] = wind;
		
		AnimatedSprite waterM = new AnimatedSprite(0,0,waterexplosionReg, sm.activity.getVertexBufferObjectManager());
		AnimatedSprite fireM = new AnimatedSprite(0,0,fireexplosionReg, sm.activity.getVertexBufferObjectManager());
		AnimatedSprite windM = new AnimatedSprite(0,0,windexplosionReg, sm.activity.getVertexBufferObjectManager());
		AnimatedSprite earthM = new AnimatedSprite(0,0,earthexplosionReg, sm.activity.getVertexBufferObjectManager());
		
		magic[0] = waterM;
		magic[1] = fireM;
		magic[2] = windM;
		magic[3] = earthM;
		
		sh = new spellHandler(wizardScene,stars, elements, updates, sm, twoPlay, pTurn, gameID, magic);
		return wizardScene;
	}
	
	public spellHandler getSh(){
		return sh;
	}
	
	public void setPlay(boolean tp){
		twoPlay = tp;
	}
	
	public void setTurn(boolean pt){
		pTurn = pt;
	}
	public void setID(Integer gID){
		gameID = gID;
	}
	
	public Boolean gettwoP(){
		return twoPlay;
	}
}
